        .586p
DGROUP group _DATA,_BSS
_TEXT  segment dword public use32 'CODE'
       assume cs:_TEXT, ds:DGROUP, ss:DGROUP

; Petter Schau 1997

include defs.inc
include func\fellow.inc
include func\memory.inc
include func\chip.inc
include func\68000.inc
include func\floppy.inc
include func\sound.inc
include func\inout.inc
include func\joymouse.inc
include func\copper.inc
include func\cia.inc

include mac\memory.mac
include mac\drawmode.mac
include mac\keyboard.mac

public next_instruction_
next_instruction_:      pushad

        TSC_BEFORE _total_tsctmp

                        call    ni

        TSC_AFTER _total_tsctmp, _total_tsc, _total_tsctimes

                        popad
                        ret

                        align   4
ni:                     mov     dword ptr [_exceptionstack],esp
                        lea     ecx,[exceptionbackdoors]
                        mov     dword ptr [_exceptionbackdooraddress],ecx

; This label MUST be aligned! Rather on a cache line boundrary.
; Better check this by hand, since Watcom will only align on longwords
; Bad alignment will result in as much as 15 % speed decrease. 

                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop
                        nop

public checkadr_
checkadr_:
next_instruction:       mov     ecx,dword ptr _curcycle
                        cmp     ecx,dword ptr _ciaeventtime
                        jb      ni_nociaevent
                        call    cia_handle_event_  
ni_nociaevent:

; test blitter,
; if blitend is less than the current cycle, the blit is finished
; Do the blit
                        test    byte ptr _blitterstatus,0ffh
                        jz      noblitter
                        mov     ecx,dword ptr _curcycle
                        cmp     ecx,dword ptr [_blitend]   ; ecx is curcycle
                        jb      noblitter
                        call    finish_blit_
noblitter:              test    byte ptr _interruptflag,1
                        jz      nointxx
                        mov     eax,48
                        cmp     byte ptr [_cpustopflag],1
                        je      exceptionbackdoors
                        dec     byte ptr [_interruptcyclesleft]
                        jnz     nointxx     
                        call    set_up_interrupt_
nointxx:

#ifdef DEBUGBUILD
; Trace log code, not CPU trace bit handling, just logging

                        cmp     dword ptr _cputraceflag,1
                        jne     notrace
                        mov     ecx,dword ptr _cputraceptr
                        and     ecx,07ffffh
                        inc     dword ptr _cputracecount
                        inc     dword ptr _cputraceptr
                        mov     edx,dword ptr _pc
                        mov     dword ptr _cputracebuffer[4*ecx],edx
notrace:
; Trace log code ended
#endif

                        test    byte ptr [_sr + 1],0c0h
                        jnz     tracebit_handler

                        mov     ecx,[_pc]
                        fetchwopcode_inc_pos                            
                        shl     edx,5
                        lea     edi,[_t + edx]
                        lea     esi,[2 + ecx]
                        call    dword ptr [edi]           
                        mov     [_pc],esi        
return_from_tracebit:

; Blitter writes the total cyclecount for the initiated blit
; to thiscycle if blitpri is on

; If blitterstatus is 1, a nonblitpri blit is in progress
; Lets double the cycle time for CPU-instruction

                        test    byte ptr _blitterstatus,1
                        jz      noblitinprogress
                        shl     eax,1
noblitinprogress:       add     eax,dword ptr _thiscycle    ; From blitter

; Vital to align this label

                        align   4

exceptionbackdoors:     mov     dword ptr _thiscycle,0      ; 6 Must clear it
                        mov     ebx,dword ptr _xpos             ; 7
                        mov     edx,dword ptr _curcycle         ; 8
                        test    byte ptr _config_cpu_speed,1
                        jz      cpunomax
                        mov     eax,2
                        mov     ecx,dword ptr _curcycle
                        test    byte ptr [_blitterstatus],0ffh
                        jz      cpunomax
                        mov     dword ptr _blitend,ecx
cpunomax:
                        shr     eax,1                           ; 9
                        mov     ecx,dword ptr _ypos             ; 9
                        add     edx,eax                         ; 10 New curcycle, next cpu
                        add     ebx,eax                         ; 11

; edx - time for next cpu instruction
; ebx - cycles until next cpu instruction + current xpos
; ecx - current line

                        align 4
figure_out_next:
                        cmp     edx,dword ptr _nxtcopaccess
                        jae     docoppers
                        cmp     ebx,CYCLESPERLINE
                        jb      nonewlines
                        align   4
morenewlines:           sub     ebx,CYCLESPERLINE
                        mov     dword ptr _ypos,ecx
                        call    end_of_line
                        inc     ecx
                        cmp     ecx,313
                        jne     noframe
                        call    end_of_frame
                        sub     edx,CYCLESPERFRAME
                        xor     ecx,ecx
                        mov     dword ptr _curcycle,ecx
                        mov     dword ptr _xpos,ecx
                        mov     dword ptr _ypos,ecx
                        jmp     figure_out_next
                        align 4
noframe:                cmp     ebx,CYCLESPERLINE
                        jae     morenewlines
nonewlines:
                        align 4
                        mov     dword ptr _curcycle,edx
                        mov     dword ptr _xpos,ebx
                        mov     dword ptr _ypos,ecx
                        cmp     dword ptr _debugging,1
                        jne     next_instruction
                        ret

                        align   4
; esi - number of cycles until the copper access
docoppers:              mov     esi,dword ptr _nxtcopaccess     ; 10
                        sub     esi,dword ptr _curcycle
                        jns     infuture
                        xor     esi,esi
                        align 4
infuture:               add     dword ptr _curcycle,esi         ; curcycle is now at copperpos
                        add     esi,dword ptr _xpos
; esi - now xposition of copper access
                        cmp     esi,CYCLESPERLINE
                        jb      nonewlines2
                        align 4
morenewlines2:          sub     esi,CYCLESPERLINE
                        sub     ebx,CYCLESPERLINE
                        mov     dword ptr _ypos,ecx
                        call    end_of_line                     ; No more inline eof, 
                        inc     ecx
                        cmp     ecx,313
                        jne     noframe2
                        call    end_of_frame
                        sub     edx,CYCLESPERFRAME
                        xor     ecx,ecx
                        mov     dword ptr _curcycle,ecx
                        mov     dword ptr _xpos,ecx
                        mov     dword ptr _ypos,ecx
                        jmp     figure_out_next
                        align 4
noframe2:               cmp     esi,CYCLESPERLINE
                        jae     morenewlines2
                        align 4
nonewlines2:            mov     dword ptr _xpos,esi
                        mov     dword ptr _ypos,ecx
                        call    copemu
                        add     edx,2
                        add     ebx,2
                        cmp     edx,dword ptr _nxtcopaccess
                        jae     docoppers
                        jmp     figure_out_next


; A fair bit of spaghetti programming

                        align   4
tracebit_handler:
                        mov     ecx,dword ptr _pc
                        fetchwopcode_inc_pos
                        shl     edx,5                    
                        lea     edi,[_t+edx]
                        lea     esi,[2+ecx]
                        call    dword ptr [edi]           
                        mov     dword ptr _pc,esi        
                        mov     ebx,024h
                        jmp     prepare_exception_


; =====================
; End of line handler
; =====================
                        align   4
end_of_line:
	push    edx
	push    ecx
        push    ebx

#ifdef CYCLE_EXACT
; To get the last part of the line right, run copper all the way
; to cycle 6 on the new line.
; Not optimized, just straightforward to check what good it does.

        mov     eax,dword ptr _xpos
        inc     dword ptr _ypos

        push    eax
        mov     eax,dword ptr _ypos
        mov     eax,dword ptr [_copperytable+4*eax]
        add     eax,6
        cmp     eax,dword ptr _nxtcopaccess
        jb      eofnocop
eofcop: 
        call    copemu
        cmp     eax,dword ptr _nxtcopaccess
        jae     eofcop
eofnocop:
        pop     eax
        dec     dword ptr _ypos
        mov     dword ptr _xpos,eax
#endif

        test    byte ptr _frameskip,0ffh
        jnz     elx

        playfieldonoff


        cmp     dword ptr _ypos,12h
        jb      elx

        ; Here decode the sprites
        test    byte ptr _dmacon,020h
        jz      el3
        call    decodesprites_
; Now sprites are decoded, and the spritesonlineflag is set if there are any
el3:
	update_drawmode

        TSC_BEFORE _drawptr_tsctmp

        call    dword ptr [_drawptr]

        TSC_AFTER _drawptr_tsctmp, _drawptr_tsc, _drawptr_tsctimes

        test    byte ptr [_bg2ddf],1
        jz      elx
        mov     edx,[_drawddfroutine]
        mov     [_drawptr],edx
        mov     byte ptr [_bg2ddf],0
elx:

        mov     ebx,dword ptr _spritewritenext
        test    ebx,ebx
        jz      elz
        push    eax
        xor     eax,eax
        mov     dword ptr [_spritewritenext],eax
        mov     dword ptr [_spritewritereal],1
elzl:   mov     ecx,dword ptr [_spritewritebuffer+eax]
        mov     edx,dword ptr [_spritewritebuffer+4+eax]
        and     ecx,01feh
        call    dword ptr [_iowrite+2*ecx]
        add     eax,8
        cmp     eax,ebx
        jne     elzl
        pop     eax
elz:
        mov     dword ptr [_spritewritereal],0
        mov     dword ptr [_drawpartialcycle],44
        mov     dword ptr [_drawpartialpixels],0

        test    byte ptr [_ciabevwritelatching],1
        jnz     el5  ; To event B counter, just like the event A code
	mov     edx,dword ptr [_ciabev]    ; Increase cia b eventcounter
	inc     edx
	and     edx,00ffffffh
	mov     dword ptr [_ciabev],edx
	cmp     edx,dword ptr [_ciabevalarm]
        jne     el5
        or      byte ptr [_ciabicrreq],04h
        test    byte ptr [_ciabicrmsk],04h
        jz      el5
        or      byte ptr [_ciabicrreq],80h
	mov     ecx,00dff09ch               ; raise cia b int
	mov     edx,0a000h
        writew
el5:

; Check for disk dma in progress

        cmp     byte ptr [_diskdmainprogress],1
        jne     el7
        cmp     byte ptr [_diskdmaread],1
        jne     elba
        pushad
        call    read_loop_
        popad
        jmp     el7
elba:
        pushad
        call    write_loop_
        popad
el7:
        cmp     byte ptr [_config_sound],0
        je      el4
        cmp     byte ptr [_config_sound],2
        jne     el15
        mov     edx,dword ptr [_audio_hblanks]
        sub     dword ptr [_audio_hblanks],edx
        cmp     edx,100                  ; Try to prevent too much accumulation
        jb      el20
        mov     edx,5
el20:
        test    edx,edx
        jz      el4
el16:   push    edx
        call    dword ptr [_audio_handler]
        pop     edx
        inc     dword ptr [_audio_hblanks_thisbuffer]
        cmp     dword ptr [_audio_hblanks_thisbuffer],1565
        je      el17
el17a:  dec     edx
        jnz     el16
        jmp     el4
el17:   mov     dword ptr [_audio_hblanks_thisbuffer],0
        push    edx
        call    dword ptr [_sound_playbuffer]
        pop     edx
        mov     ebx,dword ptr _frames
        mov     dword ptr _sbframe,ebx
        jmp     el17a
el15:   call    dword ptr [_audio_handler]
el4:
        KEYBOARD_QUEUEHANDLER
        pop     ebx
        pop     ecx
	pop     edx
        ret


end_of_frame:
        push    edx
        push    ebx
        cmp     byte ptr [_f12pressed],1
        jne     eofnf12
        mov     dword ptr [_debugging],1
        mov     byte ptr [_f12pressed],0
eofnf12:
        xor     dword ptr _lof,08000h
        xor     edx,edx
        mov     ecx,0102h
        call    dword ptr [_iowrite+ecx*2]

        cmp     byte ptr [_newvmode],1
        jne     nonewvmode
        pushad
        call    setup_emu_videomode_
        popad
        mov     dword ptr [_newvmode],0
nonewvmode:
        cmp     byte ptr [_center_code],0
        je      nocenter
        pushad
        call    do_center_
        popad
nocenter:
; Switch buffers
        test    dword ptr _frameskip,0ffffffffh
        jnz     skipped

        cmp     dword ptr [_config_printspeed],1
        jne     nah
        pushad
        call    dump_speedbuffer_
        popad
nah:


        mov     ecx,[_configdoublebuffer]
        jmp     dword ptr [doublebuffertable+4*ecx]
simplebuffers:
        mov     edx,dword ptr [_framebuffer]   ; Reload pointer to framebuffer
        add     edx,[_startoffset]
        cmp     byte ptr [_config_graphics_flickerfree],1
        jne     nodelace
        test    byte ptr [_lof+1],080h
        jnz     nodelace
        add     edx,dword ptr [_scanlinelength]
nodelace:
        mov     dword ptr [_screenptr],edx
        jmp     afterdoublebuffercode
doublebuffers:
        xor     dword ptr [_showbuffer],1
        mov     ecx,dword ptr [_drawbuffer]
        xor     ecx,1
        mov     edx,dword ptr [_framebuffer]   ; Reload pointer to framebuffer
        add     edx,[_bufferoffsets+4*ecx]
        mov     dword ptr [_drawbuffer],ecx
        add     edx,[_startoffset]
        mov     dword ptr [_screenptr],edx
        call    set_displaybuffer_
        jmp     afterdoublebuffercode        
triplebuffers:
        dec     dword ptr [_showbuffer]
        jns     tb1
        mov     dword ptr [_showbuffer],2
tb1:
        mov     ecx,dword ptr [_drawbuffer]
        dec     ecx
        jns     tb2
        mov     ecx,2
tb2:
        mov     edx,dword ptr [_framebuffer]   ; Reload pointer to framebuffer
        add     edx,[_bufferoffsets+4*ecx]
        mov     dword ptr [_drawbuffer],ecx
        add     edx,[_startoffset]
        mov     dword ptr [_screenptr],edx
        call    set_displaybuffer_

afterdoublebuffercode:


skipped:

        cmp     byte ptr [_BMPdumpflag],1
        jne     eofnobmpdump
        pushad
        call    BMPImageDump_
        popad
eofnobmpdump:


        call    copper_restart_

        inc     dword ptr [_frames]            ; Count frames
	dec     dword ptr [_frameskip]         ; Skip frames counter
	jns     doe1
        mov     edx,dword ptr [_config_graphics_skiprate]      ; Reload skip frames counter
	mov     dword ptr [_frameskip],edx
doe1:                                            ; Handle event counter A
	test    dword ptr [_ciaaevwritelatching],1 ; Stopped by write?
	jnz     doeevend
	mov     edx,dword ptr [_ciaaev]            ; Increase cia a eventcounter
	inc     edx
	and     edx,00ffffffh
	mov     dword ptr [_ciaaev],edx
	cmp     edx,dword ptr [_ciaaevalarm]       ; Counter match alarm?
	jne     doeevend
        or      dword ptr [_ciaaicrreq],04h      ; Yes, do int stuff like above
	test    dword ptr [_ciaaicrmsk],04h
	jz      doeevend
        or      dword ptr [_ciaaicrreq],80h      ; Yes, do int stuff like above
	mov     ecx,0dff09ch                     ; raise cia a int
	mov     edx,08008h
        writew
doeevend:
        cmp     dword ptr [_ciaataleft],0ffffffffh
        jz      xnotsub1
        sub     dword ptr [_ciaataleft],CYCLESPERFRAME
        jns     xnotsub1
	mov     dword ptr [_ciaataleft],0
xnotsub1:
	cmp     dword ptr [_ciaatbleft],-1
        jz      xnotsub2
        sub     dword ptr [_ciaatbleft],CYCLESPERFRAME
        jns     xnotsub2
	mov     dword ptr [_ciaatbleft],0
xnotsub2:
	cmp     dword ptr [_ciabtaleft],-1
        je      xnotsub3
        sub     dword ptr [_ciabtaleft],CYCLESPERFRAME
        jns     xnotsub3
	mov     dword ptr [_ciabtaleft],0
xnotsub3:
	cmp     dword ptr [_ciabtbleft],-1
        je      xnotsub4
        sub     dword ptr [_ciabtbleft],CYCLESPERFRAME
        jns     xnotsub4
	mov     dword ptr [_ciabtbleft],0
xnotsub4:
        cmp     dword ptr [_ciaeventtime],-1
        je      xnotsub5
        sub     dword ptr [_ciaeventtime],CYCLESPERFRAME
        jns     xnotsub5
        mov     dword ptr [_ciaeventtime],0
xnotsub5:

        inc     dword ptr [_sound_framecounter]
        cmp     dword ptr [_sound_framecounter],5
        jb      blargh
        mov     dword ptr [_sound_framecounter],0
        cmp     byte ptr [_config_printspeed],1
        jne     noprintspeed
        pushad
        call    print_emuspeed_
        popad
noprintspeed:

        cmp     dword ptr [_config_sound],0
        je      eofwaittimer
        cmp     dword ptr [_config_sound],1
        je      eofps
        cmp     dword ptr [_config_sound],3
        jne     eofwaittimer
eofps:  call    dword ptr [_sound_playbuffer]
        mov     edx,dword ptr _frames
        mov     dword ptr _sbframe,edx
        jmp     blargh
eofwaittimer:

        cmp     dword ptr [_config_graphics_maxfps],1
        jne     blargh
eofwt:
ttck:   cmp     dword ptr _tick,5
        jb      eofwt
        mov     dword ptr _tick,0
blargh:
        ; generate FLAG int (INDEX)  every 16th frame.
        ; just to keep some loaders happy


        mov     edx,[_frames]
        and     edx,01fh
        jnz     haya
        or      byte ptr [_ciabicrreq],010h
        test    byte ptr [_ciabicrmsk],010h
        jz      haya
        mov     edx,0a000h
        mov     ecx,0dff09ch
        writew
haya:

        mov     edx,dword ptr _frames
        and     edx,7
        jnz     nojoy
        pushad
        call    read_joysticks_
        popad
nojoy:
        ; generate dsksync value int every 8th frame unless
        ; disk dma is working, lets see what
        ; good it does

        cmp     dword ptr _diskdmainprogress,1
        je      burp

        mov     edx,dword ptr _frames
        and     edx,7h
        jnz     burp
        mov     edx,09000h
        mov     ecx,0dff09ch
        writew
burp:
        xor     ecx,ecx
        mov     edx,offset _spritestate
        mov     dword ptr [edx],ecx
        mov     dword ptr 4[edx],ecx
        mov     dword ptr 8[edx],ecx
        mov     dword ptr 12[edx],ecx
        mov     dword ptr 16[edx],ecx
        mov     dword ptr 20[edx],ecx
        mov     dword ptr 24[edx],ecx
        mov     dword ptr 28[edx],ecx

        mov     dword ptr _playfieldon,ecx
        test    dword ptr [_blitterstatus],0ffh
        jz      noblitmess
        sub     dword ptr _blitend,CYCLESPERFRAME
        jns     noblitmess
        mov     dword ptr _blitend,0
noblitmess:

        mov     edx,08020h
        call    dword ptr [_iowrite+0138h]

        pop     ebx
	pop     edx
        ret

;======================================================
; Alternative performance measurement when sound is off
;======================================================


public timer_routine_
timer_routine_:                 pushad
                                inc     dword ptr [_tick]
                                call    timer_routineC_
                                mov     edx,020h
                                mov     al,020h
                                out     dx,al
                                popad
                                ret



;==================================================================
; Hack to get continuous sound quality (not speed) on slow machines
;==================================================================


public timer_routine_continuous_
timer_routine_continuous_:      push    eax
                                push    edx
                                add     dword ptr [_audio_hblanks],5
                                inc     dword ptr [_tick2]
                                cmp     dword ptr [_tick2],63
                                jb      trc1
                                mov     dword ptr [_tick2],0
                                inc     dword ptr [_tick]
                                pushad
                                call    timer_routineC_
                                popad
trc1:                           mov     edx,020h
                                mov     al,020h
                                out     dx,al
                                pop     edx
                                pop     eax
                                ret





_TEXT ends

_DATA segment dword public 'DATA'

include data\fellow.inc
include data\68000.inc
include data\bus.inc
include data\memory.inc
include data\chip.inc
include data\draw.inc
include data\floppy.inc
include data\sound.inc
include data\inout.inc
include data\graphem.inc
include data\cia.inc
include data\sblast.inc
include data\keyboard.inc

public _vgatest_time
_vgatest_time:  dd      0

doublebuffertable:      dd offset simplebuffers
                        dd offset doublebuffers
                        dd offset triplebuffers


#ifdef TSC_PROFILING
public _drawptr_tsc
public _drawptr_tsctimes
_drawptr_tsc:     dd      0,0
_drawptr_tsctmp:  dd      0,0
_drawptr_tsctimes:  dd      0

public _total_tsc
public _total_tsctimes
_total_tsc:     dd      0,0
_total_tsctmp:  dd      0,0
_total_tsctimes:  dd      0

#endif

_DATA ends

_BSS segment dword public 'DATA'
_BSS ends
end

