
        .586p
DGROUP group _DATA,_BSS
_TEXT  segment dword public use32 'CODE'
       assume cs:_TEXT, ds:DGROUP, ss:DGROUP

;Petter Schau 1996


include defs.inc
include func\memory.inc
include func\68000.inc
include func\inout.inc
include func\sound.inc
include func\floppy.inc
include func\joymouse.inc
include func\draw.inc

include mac\memory.mac
include mac\drawmode.mac
public blittergeneral_

extern set_displaybuffer_:near
extern setup_emu_videomode_:near

public blitter_00_
public blitter_01_
public blitter_02_
public blitter_03_
public blitter_04_
public blitter_05_
public blitter_06_
public blitter_07_
public blitter_08_
public blitter_09_
public blitter_0a_
public blitter_0b_
public blitter_0c_
public blitter_0d_
public blitter_0e_
public blitter_0f_
public blitter_2a_
public blitter_4a_
public blitter_ca_
public blitter_d8_
public blitter_ea_
public blitter_f0_
public blitter_fa_
public blitter_fc_
public blitter_ff_

public blitter_copy_
public finish_blit_



extern print_emuspeed_:near

; Decode sprites

; We know dma is on, so read all the needed datawords
; if spritestate is 0, read two control words
; else if spritestate is 1, we are waiting for first line
; else if spritestate is 2 , read two data words and decode them
; else if spritestate is 3, sprite is off

public decodesprites_
decodesprites_:
        push    esi   ; Esi used in nxt_inst loop in copper part
        push    eax
        xor     esi,esi                 ; Counts sprites*4
        mov     dword ptr _spritesonline,0 ; Initially no sprites are displayed
dsloop:
        mov     ebx,dword ptr _spritestate[esi] ; get state for current sprite
        mov     dword ptr _spriteonline[esi],0 ; Initially not displayed
        mov     dword ptr _sprite16col[esi],0       ; Initially a 4 color sprite
        cmp     ebx,3       
        je      dsloopend    ; State 3, skip sprite, this is OK
        cmp     ebx,1
        jne     dsrwr0
; State 1, waiting for first line, check if this line is the one
        mov     eax,dword ptr _ypos    ; Check if next line the first line
        cmp     eax,dword ptr _spry[esi]
        jne     dsloopend                   ; No, skip statechange and sprite
        mov     dword ptr _spritestate[esi],2  ; Statechange and fallthrough
        mov     ebx,2
dsrwr0:  ; State 2 or 0 , Here two words must be read
        mov     ecx,dword ptr _sprpt[esi]
        mov     edx,dword ptr _cmem[ecx]
        mov     dword ptr [_sprdat+esi],edx
        add     ecx,4
        and     ecx,01ffffeh
        mov     dword ptr _sprpt[esi],ecx
        test    ebx,ebx
        jz      dsrwc0
        ; State 2, Data words
        ; If sprite is attached, and the other too, let odd sprite
        ; do the decoding
;        test    dword ptr _spratt[esi],1
;        jz      dsrwrr
        test    esi,04h         ; test wether we are odd or even sprite
        jnz     dsoddsprite
        test    dword ptr _spratt+4[esi],1 ; Even sprite is attached if
        jz      dsrwrr                     ; odd sprite is attached
;        mov     ecx,dword ptr _sprx+4[esi]
;        cmp     ecx,dword ptr _sprx[esi]    ; Same xpos?
;        jne     dsrwrr
;        mov     ecx,dword ptr _spry+4[esi]
;        cmp     ecx,dword ptr _spry[esi]    ; Same start ypos?
;        jne     dsrwrr
;        mov     ecx,dword ptr _sprly+4[esi]
;        cmp     ecx,dword ptr _sprly[esi]   ; Same stop ypos?
;        jne     dsrwrr
        ; OK we are attached and even, let odd sprite do the job
        jmp     dsresumeattached
dsoddsprite:
; We are odd sprite, if attached, both are.

        test    dword ptr _spratt[esi],1 ; Attached?
        jz      dsrwrr
;        mov     ecx,dword ptr _sprx-4[esi]
;        cmp     ecx,dword ptr _sprx[esi]    ; Same xpos?
;        jne     dsrwrr
;        mov     ecx,dword ptr _spry-4[esi]
;        cmp     ecx,dword ptr _spry[esi]    ; Same start ypos?
;        jne     dsrwrr
;        mov     ecx,dword ptr _sprly-4[esi]
;        cmp     ecx,dword ptr _sprly[esi]   ; Same stop ypos?
;        jne     dsrwrr

        ; OK we are attached and odd, we must do the job

        lea     ecx,[_sprdat-4+esi]
        push    esi
        lea     esi,[_sprite+4*esi]
        call    decode16sprite
        pop     esi
        mov     dword ptr _spritesonline,1
        mov     dword ptr _spriteonline[esi],1
        mov     dword ptr _sprite16col[esi],1
        jmp     dsresumeattached

dsrwrr:  ; No attached sprites, 4 color decode
        lea     ecx,[_sprdat+esi]
        mov     ebx,esi
        shr     ebx,3
        push    esi
        lea     esi,[_sprite+4*esi]

        call    decode4sprite
        pop     esi
        mov     dword ptr _spritesonline,1
        mov     dword ptr _spriteonline[esi],1
dsresumeattached:
        mov     eax,dword ptr _ypos    ; Check if this was the last line
        inc     eax
        cmp     eax,dword ptr _sprly[esi]
        jne     dsloopend
        mov     dword ptr _spritestate[esi],0
        jmp     dsloopend
dsrwc0: ; State 0, Control words
        test    edx,edx
        jnz     dsrwcc
        mov     dword ptr _spritestate[esi],3
        mov     dword ptr _sprx[esi],edx
        mov     dword ptr _spry[esi],edx
        mov     dword ptr _sprly[esi],edx
        mov     dword ptr _spratt[esi],edx
        jmp     dsloopend
dsrwcc:
        mov     eax,edx
        rol     eax,1
        and     eax,1
        mov     dword ptr _spratt[esi],eax
        xor     eax,eax                 ; Find x position
        mov     al,dh
        shl     eax,1
        mov     ebx,edx
        shr     ebx,24
        and     ebx,1
        or      eax,ebx
        inc     eax                     ; Sprites delayed 1 cycle
        mov     dword ptr _sprx[esi],eax  ; Now found x position
        xor     eax,eax                 ; Find first y position
        mov     al,dl
        mov     ebx,edx
        shr     ebx,16
        and     ebx,0400h
        shr     ebx,2
        or      eax,ebx
        mov     dword ptr _spry[esi],eax   ; Now found first y position
        xor     eax,eax                 ; Now find last y position
        ror     edx,16
        mov     al,dl
        mov     ah,dh
        and     eax,02ffh
        shr     ah,1
        mov     dword ptr _sprly[esi],eax   ; Now found last y position
        mov     dword ptr _spritestate[esi],1  ; Set waiting for first line
dsloopend:
        add     esi,4
        cmp     esi,32
        jne     dsloop
        pop     eax
        pop     esi
        ret



mergesprites:
        xor     esi,esi

; The big question is, should PF1 or PF2 be the right one to use
; Abacus suggestes PF1 in non-dual mode, and that fails!! So I use PF2

        test    dword ptr _bplcon0,00400h
        jnz     mergedualsprites
        mov     ecx,dword ptr _bplcon2
        and     ecx,38h
        test    dword ptr _bplcon0,08000h
        jz       mergeloresloop
        cmp     byte ptr [_config_graphics_mode],0
        je      mergehiresnewsprites
        cmp     byte ptr [_config_graphics_mode],3
        je      mergehiresnewsprites
        cmp     byte ptr [_config_graphics_mode],4
        je      mergehiresnewsprites
        cmp     byte ptr [_config_graphics_mode],5
        je      mergehiresnewsprites

mergehires320loop:
        test    dword ptr _spriteonline[esi],1
        jz      mergehires320skipsprite
        mov     edi,dword ptr _sprx[esi]
        mov     eax,dword ptr _DIWlastvisiblepos
        shr     eax,1
        cmp     edi,eax        ;  dword ptr _DIWlastvisiblepos
        ja      mergehires320skipsprite
        lea     ebp,[_sprite+4*esi]

; determine whether this sprite is in front or behind the playfield
; if ecx is bigger than esi, then sprite must be drawn in front
        xor     eax,eax
        cmp     ecx,esi
        jbe     mergehires320setuploop
        mov     eax,010000h
mergehires320setuploop:
        push    ecx
        push    esi
        lea     esi,[_spritetranslate+eax]
        xor     eax,eax
        xor     ebx,ebx
mergehires320loop2:
        mov     edx,dword ptr [ebp]             ; 1 Pixel 0-3
        mov     ecx,dword ptr [_linje+edi]      ; 1
        mov     al,dl                           ; 2
        mov     bl,dh                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        ror     edx,16                          ; 4
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        mov     bl,dh                           ; 5
        ror     ecx,16                          ; 6
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+edi],ecx      ; 12 (13) (reg dep)

        mov     edx,dword ptr 4[ebp]            ; 1 Pixel 4-7
        mov     ecx,dword ptr [_linje+4+edi]    ; 1
        mov     al,dl                           ; 2
        mov     bl,dh                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        ror     edx,16                          ; 4
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        mov     bl,dh                           ; 5
        ror     ecx,16                          ; 6
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+4+edi],ecx    ; (12) 13 (reg dep)

        mov     edx,dword ptr 8[ebp]            ; 1 Pixel 8-11
        mov     ecx,dword ptr [_linje+8+edi]    ; 1
        mov     al,dl                           ; 2
        mov     bl,dh                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        ror     edx,16                          ; 4
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        mov     bl,dh                           ; 5
        ror     ecx,16                          ; 6
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+8+edi],ecx    ; 12 (13) (reg dep)

        mov     edx,dword ptr 12[ebp]           ; 1 Pixel 12-15
        mov     ecx,dword ptr [_linje+12+edi]   ; 1
        mov     al,dl                           ; 2
        mov     bl,dh                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        ror     edx,16                          ; 4
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        mov     bl,dh                           ; 5
        ror     ecx,16                          ; 6
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+12+edi],ecx   ; 12 (13) (reg dep)

        pop     esi
        pop     ecx

mergehires320skipsprite:
        add     esi,4
        cmp     esi,32
        jne     mergehires320loop
        ret




mergeloresloop:
        test    dword ptr _spriteonline[esi],1
        jz      mergeloresskipsprite
        mov     edi,dword ptr _sprx[esi]
        cmp     edi,dword ptr _DIWlastvisiblepos
        ja      mergeloresskipsprite
        lea     ebp,[_sprite+4*esi]

; determine whether this sprite is in front or behind the playfield
; if ecx is bigger than esi, then sprite must be drawn in front
        xor     eax,eax
        cmp     ecx,esi
        jbe     mergeloressetuploop
        mov     eax,010000h
mergeloressetuploop:
        push    ecx
        push    esi
        lea     esi,[_spritetranslate+eax]
        xor     eax,eax
        xor     ebx,ebx
mergeloresloop2:
        mov     edx,dword ptr [ebp]             ; 1 Pixel 0-3
        mov     ecx,dword ptr [_linje+edi]      ; 1
        mov     al,dl                           ; 2
        mov     bl,dh                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        ror     edx,16                          ; 4
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        mov     bl,dh                           ; 5
        ror     ecx,16                          ; 6
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+edi],ecx      ; 12 (13) (reg dep)

        mov     edx,dword ptr 4[ebp]            ; 1 Pixel 4-7
        mov     ecx,dword ptr [_linje+4+edi]    ; 1
        mov     al,dl                           ; 2
        mov     bl,dh                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        ror     edx,16                          ; 4
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        mov     bl,dh                           ; 5
        ror     ecx,16                          ; 6
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+4+edi],ecx    ; (12) 13 (reg dep)

        mov     edx,dword ptr 8[ebp]            ; 1 Pixel 8-11
        mov     ecx,dword ptr [_linje+8+edi]    ; 1
        mov     al,dl                           ; 2
        mov     bl,dh                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        ror     edx,16                          ; 4
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        mov     bl,dh                           ; 5
        ror     ecx,16                          ; 6
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+8+edi],ecx    ; 12 (13) (reg dep)

        mov     edx,dword ptr 12[ebp]           ; 1 Pixel 12-15
        mov     ecx,dword ptr [_linje+12+edi]   ; 1
        mov     al,dl                           ; 2
        mov     bl,dh                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        ror     edx,16                          ; 4
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        mov     bl,dh                           ; 5
        ror     ecx,16                          ; 6
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+12+edi],ecx   ; 12 (13) (reg dep)

        pop     esi
        pop     ecx

mergeloresskipsprite:
        add     esi,4
        cmp     esi,32
        jne     mergeloresloop
        ret


mergehiresnewsprites:
mergehiresnewloop:
        test    dword ptr _spriteonline[esi],1
        jz      mergehiresnewskipsprite
        mov     edi,dword ptr _sprx[esi]
        add     edi,edi
        cmp     edi,dword ptr _DIWlastvisiblepos
        ja      mergehiresnewskipsprite
        lea     ebp,[_sprite+4*esi]

; determine whether this sprite is in front or behind the playfield
; if ecx is bigger than esi, then sprite must be drawn in front

        xor     eax,eax
        cmp     ecx,esi
        jbe     mergehiresnewsetuploop
        mov     eax,010000h
mergehiresnewsetuploop:
        push    ecx
        push    esi
        lea     esi,[_spritetranslate+eax]
        xor     eax,eax
        xor     ebx,ebx
mergehiresnewloop2:
        mov     edx,dword ptr [ebp]             ; 1 Pixel 0-1
        mov     ecx,dword ptr [_linje+edi]      ; 1
        mov     al,dl                           ; 2
        mov     bl,dl                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        ror     ecx,16
        mov     al,dh                           ; Pixel 2-3
        mov     bl,dh
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        ror     ecx,16                          ; 12 
        ror     edx,16
        mov     dword ptr [_linje+edi],ecx      ; 12 (13) (reg dep)
        mov     ecx,dword ptr [_linje+4+edi]    ; 1
        mov     bl,dl                           ; 5
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     bl,dh                           ; 5
        mov     al,dh                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+4+edi],ecx      ; 12 (13) (reg dep)


        mov     edx,dword ptr 4[ebp]             ; 1 Pixel 4-5
        mov     ecx,dword ptr [_linje+8+edi]      ; 1
        mov     al,dl                           ; 2
        mov     bl,dl                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        ror     ecx,16
        mov     al,dh                           ; Pixel 6-7
        mov     bl,dh
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        ror     ecx,16                          ; 12 
        ror     edx,16
        mov     dword ptr [_linje+8+edi],ecx      ; 12 (13) (reg dep)
        mov     ecx,dword ptr [_linje+12+edi]    ; 1
        mov     bl,dl                           ; 5
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     bl,dh                           ; 5
        mov     al,dh                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+12+edi],ecx      ; 12 (13) (reg dep)


        mov     edx,dword ptr 8[ebp]             ; 1 Pixel 8-9
        mov     ecx,dword ptr [_linje+16+edi]      ; 1
        mov     al,dl                           ; 2
        mov     bl,dl                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        ror     ecx,16
        mov     al,dh                           ; Pixel 10-11
        mov     bl,dh
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        ror     ecx,16                          ; 12 
        ror     edx,16
        mov     dword ptr [_linje+16+edi],ecx      ; 12 (13) (reg dep)
        mov     ecx,dword ptr [_linje+20+edi]    ; 1
        mov     bl,dl                           ; 5
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     bl,dh                           ; 5
        mov     al,dh                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+20+edi],ecx      ; 12 (13) (reg dep)


        mov     edx,dword ptr 12[ebp]             ; 1 Pixel 12-13
        mov     ecx,dword ptr [_linje+24+edi]      ; 1
        mov     al,dl                           ; 2
        mov     bl,dl                           ; 2
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        ror     ecx,16
        mov     al,dh                           ; Pixel 14-15
        mov     bl,dh
        mov     ah,cl                           ; 3
        mov     bh,ch                           ; 3
        mov     cl,byte ptr [esi+eax]           ; 4 (5) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 5
        ror     ecx,16                          ; 12 
        ror     edx,16
        mov     dword ptr [_linje+24+edi],ecx      ; 12 (13) (reg dep)
        mov     ecx,dword ptr [_linje+28+edi]    ; 1
        mov     bl,dl                           ; 5
        mov     al,dl                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     bl,dh                           ; 5
        mov     al,dh                           ; 6
        mov     ah,cl                           ; 7
        mov     bh,ch                           ; 7
        mov     cl,byte ptr [esi+eax]           ; 8 (10) (AGI)
        mov     ch,byte ptr [esi+ebx]           ; 8 (11) (write to same reg)
        ror     ecx,16                          ; 12 
        mov     dword ptr [_linje+28+edi],ecx      ; 12 (13) (reg dep)

        pop     esi
        pop     ecx

mergehiresnewskipsprite:
        add     esi,4
        cmp     esi,32
        jne     mergehiresnewloop
        ret

mergehiressprites:
mergehiresloop:
        test    dword ptr _spriteonline[esi],1
        jz      mergehiresloopend
        mov     edi,dword ptr _sprx[esi]
        add     edi,edi
        cmp     edi,dword ptr _DIWlastvisiblepos
        ja      mergehiresloopend
        lea     eax,[_sprite+4*esi]
        xor     ebp,ebp
; Is this a 16 color sprite??
        test    dword ptr _sprite16col[esi],1
        jz      mergehiresno16
mergehiresno16:

; determine wether this sprite is in front or behind the playfield
; if ecx is bigger than esi, then sprite must be drawn in front
        push    ecx
        cmp     ecx,esi
        ja      mergehiresloopinfront2
mergehiresloopbehind2:
        mov     edx,dword ptr [eax+ebp]
        mov     ecx,dword ptr [_linje+edi+2*ebp]
        test    cl,cl
        jnz     mhhb1
        test    dl,dl
        jz      mhhb1
        mov     cl,dl
        add     cl,bl
mhhb1:
        test    ch,ch
        jnz     mhhb2
        test    dl,dl
        jz      mhhb2
        mov     ch,dl
        add     ch,bl
mhhb2:
        ror     ecx,16
        test    cl,cl
        jnz     mhhb3
        test    dh,dh
        jz      mhhb3
        mov     cl,dh
        add     cl,bl
mhhb3:
        test    ch,ch
        jnz     mhhb4
        test    dh,dh
        jz      mhhb4
        mov     ch,dh
        add     ch,bl
mhhb4:
        ror     ecx,16
        mov     dword ptr [_linje+edi+2*ebp],ecx
        add     ebp,2
        cmp     ebp,16
        jne     mergehiresloopbehind2
        pop     ecx
        jmp     mergehiresloopend

mergehiresloopinfront2:
        mov     edx,dword ptr [eax+ebp]
        mov     ecx,dword ptr [_linje+edi+2*ebp]
        test    dl,dl
        jz      mhh1
        mov     cl,dl
        add     cl,bl
mhh1:
        test    dl,dl
        jz      mhh2
        mov     ch,dl
        add     ch,bl
mhh2:
        ror     ecx,16
        test    dh,dh
        jz      mhh3
        mov     cl,dh
        add     cl,bl
mhh3:
        test    dh,dh
        jz      mhh4
        mov     ch,dh
        add     ch,bl
mhh4:
        ror     ecx,16
        mov     dword ptr [_linje+edi+2*ebp],ecx
        add     ebp,2
        cmp     ebp,16
        jne     mergehiresloopinfront2
        pop     ecx
mergehiresloopend:
        add     esi,4
        cmp     esi,32
        jne     mergehiresloop
        ret


mergedualsprites:
        
mergedualloresloop:
        test    dword ptr _spriteonline[esi],1
        jz      mergedualloresloopend
        mov     edi,dword ptr _sprx[esi]
        cmp     edi,dword ptr _DIWlastvisiblepos
        ja      mergedualloresloopend
        lea     eax,[_sprite+4*esi]
        xor     ebp,ebp



; Merge with PF1
; determine whether this sprite is in front or behind the playfield
; if ecx is bigger than esi, then sprite must be drawn in front

; test, sprite in front of PF1? Draw it there
;       sprite in front of PF2? Draw it there
;       else draw it behind PF2
mergedualloresPF1:
        mov     ecx,dword ptr _bplcon2
        test    ecx,040h
        jnz     mergedualloresevenpri
        and     ecx,7h
        shl     ecx,3
        cmp     ecx,esi
        ja      mergedualloresPF1loopinfront2
        mov     ecx,dword ptr _bplcon2
        and     ecx,038h
        cmp     ecx,esi
        ja      mergedualloresPF2loopinfront2
        jmp     mergedualloresPF2loopbehind2
mergedualloresevenpri:
        and     ecx,38h
        cmp     ecx,esi
        ja      mergedualloresPF2loopinfront2
        mov     ecx,dword ptr _bplcon2
        and     ecx,07h
        shl     ecx,3
        cmp     ecx,esi
        ja      mergedualloresPF1loopinfront2

mergedualloresPF1loopbehind2:
        mov     edx,dword ptr [eax+ebp]
        mov     ecx,dword ptr [_linje+edi+ebp]
        test    cl,cl
        jnz     mdlb1
        test    dl,dl
        jz      mdlb1
        mov     cl,dl
mdlb1:
        test    ch,ch
        jnz     mdlb2
        test    dh,dh
        jz      mdlb2
        mov     ch,dh
mdlb2:
        ror     edx,16
        ror     ecx,16
        test    cl,cl
        jnz     mdlb3
        test    dl,dl
        jz      mdlb3
        mov     cl,dl
mdlb3:
        test    ch,ch
        jnz     mdlb4
        test    dh,dh
        jz      mdlb4
        mov     ch,dh
mdlb4:
        ror     ecx,16
        mov     dword ptr [_linje+edi+ebp],ecx
        add     ebp,4
        cmp     ebp,16
        jne     mergedualloresPF1loopbehind2
        jmp     mergedualloresloopend

mergedualloresPF1loopinfront2:
        mov     edx,dword ptr [eax+ebp]
        mov     ecx,dword ptr [_linje+edi+ebp]
        test    dl,dl
        jz      mdl1
        mov     cl,dl
mdl1:
        test    dh,dh
        jz      mdl2
        mov     ch,dh
mdl2:
        ror     edx,16
        ror     ecx,16
        test    dl,dl
        jz      mdl3
        mov     cl,dl
mdl3:
        test    dh,dh
        jz      mdl4
        mov     ch,dh
mdl4:
        ror     ecx,16
        mov     dword ptr [_linje+edi+ebp],ecx
        add     ebp,4
        cmp     ebp,16
        jne     mergedualloresPF1loopinfront2
        jmp     mergedualloresloopend

mergedualloresPF2loopbehind2:
        mov     edx,dword ptr [eax+ebp]
        mov     ecx,dword ptr [_linje2+edi+ebp]
        test    cl,cl
        jnz     mdlpf2b1
        test    dl,dl
        jz      mdlpf2b1
        mov     cl,dl
mdlpf2b1:
        test    ch,ch
        jnz     mdlpf2b2
        test    dh,dh
        jz      mdlpf2b2
        mov     ch,dh
mdlpf2b2:
        ror     edx,16
        ror     ecx,16
        test    cl,cl
        jnz     mdlpf2b3
        test    dl,dl
        jz      mdlpf2b3
        mov     cl,dl
mdlpf2b3:
        test    ch,ch
        jnz     mdlpf2b4
        test    dh,dh
        jz      mdlpf2b4
        mov     ch,dh
mdlpf2b4:
        ror     ecx,16
        mov     dword ptr [_linje2+edi+ebp],ecx
        add     ebp,4
        cmp     ebp,16
        jne     mergedualloresPF2loopbehind2

        jmp     mergedualloresloopend

mergedualloresPF2loopinfront2:
        mov     edx,dword ptr [eax+ebp]
        mov     ecx,dword ptr [_linje2+edi+ebp]
        test    dl,dl
        jz      mdlpf21
        mov     cl,dl
mdlpf21:
        test    dh,dh
        jz      mdlpf22
        mov     ch,dh
mdlpf22:
        ror     edx,16
        ror     ecx,16
        test    dl,dl
        jz      mdlpf23
        mov     cl,dl
mdlpf23:
        test    dh,dh
        jz      mdlpf24
        mov     ch,dh
mdlpf24:
        ror     ecx,16
        mov     dword ptr [_linje2+edi+ebp],ecx
        add     ebp,4
        cmp     ebp,16
        jne     mergedualloresPF2loopinfront2

mergedualloresloopend:
skipdualloressprite:
        add     esi,4
        cmp     esi,32
        jne     mergedualloresloop
        ret


; Width 800

                        align   4

public drawddfline_
drawddfline_:           pushad
                        mov     ebp,[_ypos]
                        mov     dword ptr [_lineflags+4*ebp],-1
                        mov     dl,byte ptr [_configdoublebuffer]
                        mov     [_lineflagstimes+ebp],dl
                        cmp     ebp,01ah
                        jb      drawddf320wnothing
                        mov     eax,dword ptr [_screenptr]
                        mov     ebx,dword ptr [_scanlineadd]
                        lea     eax,1600[eax+ebx]
                        push    eax
                        call    dword ptr [_decoderoutineptr]
                        test    byte ptr [_spritesonline],1
                        jz      drawddfnospritemerge
                        call    mergesprites
                        mov     byte ptr [_spritesonline],0
drawddfnospritemerge:   mov     eax,[_DIWfirstposonline]
                        mov     ebx,[_DIWfirstvisiblepos]
                        sub     ebx,eax
                        jle     drawddfnobgfront
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddffilllores1
                        shr     ebx,1
drawddffilllores1:      call    fillbg800w_
drawddfnobgfront:       call    dword ptr [_drawroutineptr]
                        mov     eax,[_DIWlastvisiblepos]
                        mov     ebx,[_DIWlastposonline]
                        sub     ebx,eax
                        jle     drawddfnobgbehind
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddffilllores2
                        shr     ebx,1
drawddffilllores2:      call    fillbg800w_
drawddfnobgbehind:      pop     eax
                        mov     [_screenptr],eax
                        popad
                        ret

                        align   4

public drawham_
drawham_:               mov     ebp,dword ptr _DIWlastvisiblepos
                        mov     edi,dword ptr _DIWfirstvisiblepos
                        sub     ebp,edi
                        mov     edx,dword ptr _screenptr
                        xor     esi,esi
                        or      ebp,ebp
                        jz      dhlexit
dhl:                    mov     cl,byte ptr _linje[edi]
                        xor     ebx,ebx
                        mov     bl,cl                     ; Pixel 1
                        test    cl,0c0h
                        jz      dhlnormal
                        and     bl,0c0h
                        cmp     bl,0c0h
                        je      dhlgreen
                        cmp     bl,80h
                        je      dhlred
                        mov     bl,cl           ; Blue component to be exchanged
                        and     bl,03ch
                        shr     bl,1
                        and     esi,07fe07fe0h   ; Mask away old blue
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhldraw
dhlred:                 mov     ebx,ecx           ; Red component to be exchanged
                        and     ebx,03ch
                        shl     ebx,9
                        and     esi,03ff03ffh   ; Mask away old red
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhldraw
dhlgreen:               mov     ebx,ecx           ; Green component to be exchanged
                        and     ebx,03ch
                        shl     ebx,4
                        and     esi,07c1f7c1fh   ; Mask away old green
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhldraw
dhlnormal:              mov     esi,dword ptr _shadcol[ebx]
dhldraw:                mov     dword ptr [edx],esi
                        add     edx,4
                        inc     edi
                        dec     ebp
                        jnz     dhl
dhlexit:                mov     dword ptr _screenptr,edx
                        ret



;Width 320
                        align   4

public drawddfline320w_
drawddfline320w_:       pushad
                        mov     ebp,[_ypos]
                        cmp     ebp,[_cliptop]
                        jb      drawddf320wnothing
                        cmp     ebp,[_clipbot]
                        jae     drawddf320wnothing
                        mov     dword ptr [_lineflags+4*ebp],-1
                        mov     dl,byte ptr [_configdoublebuffer]
                        mov     [_lineflagstimes+ebp],dl
                        call    dword ptr [_decoderoutineptr]
                        test    byte ptr [_spritesonline],1
                        jz      drawddf320wnosprite
                        call    mergesprites
                        mov     byte ptr [_spritesonline],0
drawddf320wnosprite:    mov     eax,[_clipleftx]
                        mov     ebx,[_DIWfirstvisiblepos]
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddf320wfrontlo
                        shr     ebx,1
drawddf320wfrontlo:     sub     ebx,eax
                        jle     drawddf320wnobgf
                        call    fillbg320w_
drawddf320wnobgf:       call    dword ptr [_drawroutineptr]
                        mov     eax,[_DIWlastvisiblepos]
                        mov     ebx,[_cliprightx]
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddf320wbehindlo
                        shr     eax,1
drawddf320wbehindlo:    sub     ebx,eax
                        jle     drawddf320wnobgb
                        call    fillbg320w_
drawddf320wnobgb:       mov     eax,[_scanlineadd]
                        add     [_screenptr],eax
                        popad
                        ret
drawddf320wnothing:     call    dummydecode_
                        popad
                        ret

                
                        align   4

public drawddfline320b_
drawddfline320b_:       pushad
                        mov     ebp,[_ypos]
                        cmp     ebp,[_cliptop]
                        jb      drawddf320bnothing
                        cmp     ebp,[_clipbot]
                        jae     drawddf320bnothing
                        mov     dword ptr [_lineflags+4*ebp],-1
                        mov     dl,byte ptr [_configdoublebuffer]
                        mov     [_lineflagstimes+ebp],dl
                        call    dword ptr [_decoderoutineptr]
                        test    byte ptr [_spritesonline],1
                        jz      drawddf320bnosprite
                        call    mergesprites
                        mov     byte ptr [_spritesonline],0
drawddf320bnosprite:    mov     eax,[_clipleftx]
                        mov     ebx,[_DIWfirstvisiblepos]
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddf320bfrontlo
                        shr     ebx,1
drawddf320bfrontlo:     sub     ebx,eax
                        jle     drawddf320bnobgf
                        call    fillbg320b_
drawddf320bnobgf:       call    dword ptr [_drawroutineptr]
                        mov     eax,[_DIWlastvisiblepos]
                        mov     ebx,[_cliprightx]
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddf320bbehindlo
                        shr     eax,1
drawddf320bbehindlo:    sub     ebx,eax
                        jle     drawddf320bnobgb
                        call    fillbg320b_
drawddf320bnobgb:       mov     eax,[_scanlineadd]
                        add     [_screenptr],eax
                        popad
                        ret
drawddf320bnothing:     call    dummydecode_
                        popad
                        ret

                
public drawddfline640w_
drawddfline640w_:       pushad
                        mov     ebp,[_ypos]
                        mov     dword ptr [_lineflags+4*ebp],-1
                        mov     dl,byte ptr [_configdoublebuffer]
                        mov     [_lineflagstimes+ebp],dl
                        call    dword ptr [_decoderoutineptr]
                        test    byte ptr [_spritesonline],1
                        jz      drawddf640wnosprite
                        call    mergesprites
                        mov     byte ptr [_spritesonline],0
drawddf640wnosprite:    mov     eax,[_clipleftx]
                        mov     ebx,[_DIWfirstvisiblepos]
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddf640wfrontlo
                        shr     ebx,1
drawddf640wfrontlo:     sub     ebx,eax
                        jle     drawddf640wnobgf
                        call    fillbg800w_
drawddf640wnobgf:       call    dword ptr [_drawroutineptr]
                        mov     eax,[_DIWlastvisiblepos]
                        mov     ebx,[_cliprightx]
                        test    byte ptr [_bplcon0+1],080h
                        jz      drawddf640wbehindlo
                        shr     eax,1
drawddf640wbehindlo:    sub     ebx,eax
                        jle     drawddf640wnobgb
                        call    fillbg800w_
drawddf640wnobgb:       mov     eax,[_scanlineadd]
                        add     [_screenptr],eax
                        popad
                        ret
drawddf640wnothing:     call    dummydecode_
                        popad
                        ret

                
                        align   4

dummydecode_:           mov     edx,[_bplcon0]
                        shr     edx,12
                        and     edx,07h
                        mov     ecx,[_DDFnumberofwords]
                        shl     ecx,1
                        mov     ebx,[_bpl1mod]
                        mov     eax,[_bpl2mod]
                        jmp     dword ptr [dummydecodetable + edx*4]
ddec6:                  add     [_bpl6pt],ecx
                        add     [_bpl6pt],eax
ddec5:                  add     [_bpl5pt],ecx
                        add     [_bpl5pt],ebx
ddec4:                  add     [_bpl4pt],ecx
                        add     [_bpl4pt],eax
ddec3:                  add     [_bpl3pt],ecx
                        add     [_bpl3pt],ebx
ddec2:                  add     [_bpl2pt],ecx
                        add     [_bpl2pt],eax
ddec1:                  add     [_bpl1pt],ecx
                        add     [_bpl1pt],ebx
ddec0:                  ret


; ebx - number of lores pixels to draw

                        align   4

fillbg320b_:            mov     esi,[_screenptr]
                        mov     eax,[_shadcol]
                        cmp     ebx,4
                        jb      fbg320b1
fbg320b2:               mov     [esi],eax
                        sub     ebx,4
                        add     esi,4
                        cmp     ebx,4
                        jae     fbg320b2
fbg320b1:               test    ebx,ebx
                        jz      fbg320b3
fbg320b4:               mov     [esi],al
                        inc     esi
                        dec     ebx
                        jnz     fbg320b4
fbg320b3:               mov     [_screenptr],esi
                        ret

                        align   4

public drawbgline640w_
drawbgline640w_:        pushad
                        mov     ebp,[_ypos]
                        cmp     ebp,1ah
                        jb      dbg640wexit
                        mov     ebx,[_shadcol]
                        mov     ecx,[_lineflags+4*ebp]
                        mov     edx,[_configdoublebuffer]
                        cmp     ecx,ebx
                        jne     dbg640wnewcolor
                        mov     dl,[_lineflagstimes+ebp]
                        test    dl,dl
                        jz      dbg640wnodraw
                        dec     dl
dbg640wnewcolor:        mov     [_lineflags+4*ebp],ebx
                        mov     [_lineflagstimes+ebp],dl
                        mov     eax,[_screenptr]
                        mov     ebp,20                 
dbg640wloop:            mov     [eax],ebx
                        mov     4[eax],ebx
                        mov     8[eax],ebx
                        mov     12[eax],ebx
                        mov     16[eax],ebx
                        mov     20[eax],ebx
                        mov     24[eax],ebx
                        mov     28[eax],ebx
                        mov     32[eax],ebx
                        mov     36[eax],ebx
                        mov     40[eax],ebx
                        mov     44[eax],ebx
                        mov     48[eax],ebx
                        mov     52[eax],ebx
                        mov     56[eax],ebx
                        mov     60[eax],ebx
                        add     eax,64
                        dec     ebp
                        jnz     dbg640wloop
                        add     eax,[_scanlineadd]
                        mov     [_screenptr],eax
dbg640wexit:            popad
                        ret
dbg640wnodraw:
                        mov     eax,[_scanlineadd]
                        add     eax,1280
                        add     [_screenptr],eax
                        popad
                        ret


                        align   4

public drawbgline320b_
drawbgline320b_:        pushad
                        mov     ebp,[_ypos]
                        cmp     ebp,[_cliptop]
                        jb      drawbg320bouttahere
                        cmp     ebp,[_clipbot]
                        jae     drawbg320bouttahere
                        mov     ebx,[_shadcol]
                        mov     ecx,[_lineflags+4*ebp]
                        mov     edx,[_configdoublebuffer]
                        cmp     ecx,ebx
                        jne     drawbgit320b
                        mov     dl,[_lineflagstimes+ebp]
                        test    dl,dl
                        jz      iminheaven1320b
                        dec     dl
drawbgit320b:           mov     [_lineflagstimes+ebp],dl
                        mov     [_lineflags+4*ebp],ebx
                        mov     ebx,[_shadcol]
                        mov     eax,[_screenptr]
                        mov     ebp,5
dbl320b:                mov     [eax],ebx
                        mov     4[eax],ebx
                        mov     8[eax],ebx
                        mov     12[eax],ebx
                        mov     16[eax],ebx
                        mov     20[eax],ebx
                        mov     24[eax],ebx
                        mov     28[eax],ebx
                        mov     32[eax],ebx
                        mov     36[eax],ebx
                        mov     40[eax],ebx
                        mov     44[eax],ebx
                        mov     48[eax],ebx
                        mov     52[eax],ebx
                        mov     56[eax],ebx
                        mov     60[eax],ebx
                        add     eax,64
                        dec     ebp
                        jnz     dbl320b
                        add     eax,[_scanlineadd]
                        mov     [_screenptr],eax
drawbg320bouttahere:    popad
                        ret
iminheaven1320b:        mov     eax,[_scanlineadd]
                        add     eax,320
                        add     [_screenptr],eax
                        popad
                        ret

                        align   4

public drawlores640w_
drawlores640w_:         mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]
                        mov     edx,[_screenptr]
                        cmp     eax,[_clipleftx]
                        jae     dl640wleftnoclip
                        mov     eax,[_clipleftx]
dl640wleftnoclip:       cmp     ebp,[_cliprightx]
                        jbe     dl640wrightnoclip
                        mov     ebp,[_cliprightx]
dl640wrightnoclip:      sub     ebp,eax
                        jle     dl640wexit
                        xor     ebx,ebx
                        cmp     ebp,4
                        jl      dl640wlastloop
dl640wloop:             mov     ecx,[_linje+eax]
                        mov     bl,cl
                        mov     esi,[_shadcol+ebx]
                        mov     [edx],esi
                        mov     bl,ch
                        mov     esi,[_shadcol+ebx]
                        shr     ecx,16
                        mov     4[edx],esi
                        mov     bl,cl
                        mov     esi,[_shadcol+ebx]
                        mov     8[edx],esi
                        mov     bl,ch
                        mov     esi,[_shadcol+ebx]
                        mov     12[edx],esi
                        add     edx,16
                        sub     ebp,4
                        add     eax,4
                        cmp     ebp,4
                        jae     dl640wloop
                        test    ebp,ebp
                        jz      dl640wexit
dl640wlastloop:         mov     bl,byte ptr [_linje+eax]
                        mov     esi,[_shadcol+ebx]
                        mov     [edx],esi
                        add     edx,4
                        inc     eax
                        dec     ebp
                        jnz     dl640wlastloop
dl640wexit:             mov     [_screenptr],edx
                        ret


                        align   4

public drawhires640w_
drawhires640w_:         mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]
                        mov     edx,[_screenptr]
                        mov     ebx,[_clipleftx]
                        mov     ecx,[_cliprightx]
                        shl     ebx,1
                        shl     ecx,1
                        cmp     eax,ebx
                        jae     dh640wleftnoclip
                        mov     eax,ebx
dh640wleftnoclip:       cmp     ebp,ecx
                        jbe     dh640wrightnoclip
                        mov     ebp,ecx
dh640wrightnoclip:      sub     ebp,eax
                        jle     dh640wexit
                        xor     ebx,ebx
                        cmp     ebp,4
                        jl      dh640wlastloop
dh640wloop:             mov     ecx,[_linje+eax]
                        mov     bl,ch
                        mov     esi,[_shadcol+ebx]
                        mov     bl,cl
                        mov     si,[_shadcol+ebx]
                        shr     ecx,16
                        mov     [edx],esi
                        mov     bl,ch
                        mov     esi,[_shadcol+ebx]
                        mov     bl,cl
                        mov     si,[_shadcol+ebx]
                        mov     4[edx],esi
                        add     edx,8
                        sub     ebp,4
                        add     eax,4
                        cmp     ebp,4
                        jae     dh640wloop
                        test    ebp,ebp
                        jz      dh640wexit
dh640wlastloop:         mov     bl,byte ptr [_linje+eax]
                        mov     esi,[_shadcol+ebx]
                        mov     [edx],si
                        add     edx,2
                        inc     eax
                        dec     ebp
                        jnz     dh640wlastloop
dh640wexit:             mov     [_screenptr],edx
                        ret

                        align   4

public drawlores320b_
drawlores320b_:         mov     esi,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        test    byte ptr [_bplcon0+1],080h
                        jz      dl320blores
                        shr     ebp,1
                        shr     edi,1
dl320blores:            cmp     edi,[_clipleftx]
                        jae     dl320bleftnoclip
                        mov     edi,[_clipleftx]
dl320bleftnoclip:       cmp     ebp,[_cliprightx]
                        jbe     dl320brightnoclip
                        mov     ebp,[_cliprightx]
dl320brightnoclip:      sub     ebp,edi
                        xor     ebx,ebx
                        xor     eax,eax
                        cmp     ebp,4
                        jl      dl320blast4
                        test    esi,1h
                        jz      dl320balign2
                        mov     al,byte ptr [_linje+edi]
                        mov     dl,[_shadcol+eax]
                        mov     [esi],dl
                        inc     esi
                        inc     edi
                        dec     ebp
                        cmp     ebp,4
                        jl      dl320blast4
dl320balign2:           test    esi,2h
                        jz      drlo320b
                        mov     al,byte ptr [_linje+edi]
                        mov     bl,byte ptr [_linje+1+edi]
                        mov     dl,[_shadcol+eax]
                        mov     dh,[_shadcol+ebx]
                        mov     [esi],dx
                        add     esi,2
                        add     edi,2
                        sub     ebp,2
                        cmp     ebp,4
                        jl      dl320blast4
drlo320b:               mov     ecx,[_linje+edi]
                        add     edi,4                  
                        mov     bl,ch                  
                        sub     ebp,4                  
                        mov     al,cl                  
                        shr     ecx,16                 
                        mov     dh,[_shadcol+ebx]  
                        mov     bl,ch                        
                        mov     dl,[_shadcol+eax]    
                        mov     al,cl                        
                        shl     edx,16
                        mov     dh,[_shadcol+ebx]  
                        mov     dl,[_shadcol+eax]    
                        rol     edx,16
                        mov     [esi],edx
                        add     esi,4                        
                        cmp     ebp,4                        
                        jae     drlo320b                  
dl320blast4:            test    ebp,ebp
                        jz      dl320bexit
dl320blastloop:         mov     bl,byte ptr [_linje+edi]
                        mov     edx,[_shadcol+ebx]
                        mov     [esi],dl
                        inc     edi
                        inc     esi
                        dec     ebp
                        jnz     dl320blastloop
dl320bexit:             mov     [_screenptr],esi
                        ret
public drawduallores640w_
drawduallores640w_:     mov     esi,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]

                        cmp     eax,[_clipleftx]
                        jae     ddl640wleftnoclip
                        mov     eax,[_clipleftx]
ddl640wleftnoclip:      cmp     ebp,[_cliprightx]
                        jbe     ddl640wrightnoclip
                        mov     ebp,[_cliprightx]
ddl640wrightnoclip:     sub     ebp,eax
                        jle     ddl640wexit
                        lea     edi,[_dualtranslate]
                        test    byte ptr [_bplcon2],040h
                        jnz     ddl640wprinotset
                        add     edi,010000h
ddl640wprinotset:       xor     ebx,ebx
                        cmp     ebp,4
                        jl      ddl640wlast
ddl640w:                mov     ecx,[_linje+eax]
                        mov     edx,[_linje2+eax]
                        push    ebp
                        mov     bh,cl       
                        push    eax   
                        mov     bl,dl 
                        xor     eax,eax
                        mov     al,[edi+ebx] 
                        mov     ebp,[_shadcol+eax]     
                        mov     [esi],ebp       
                        mov     bh,ch                            
                        shr     ecx,16                          
                        mov     bl,dh                           
                        shr     edx,16                          
                        mov     al,[edi+ebx]           
                        mov     ebp,[_shadcol+eax]     
                        mov     4[esi],ebp             
                        mov     bh,cl
                        mov     bl,dl
                        mov     al,[edi+ebx]
                        mov     ebp,[_shadcol+eax]
                        mov     8[esi],ebp
                        mov     bh,ch
                        mov     bl,dh
                        mov     al,[edi+ebx]
                        mov     ebp,[_shadcol+eax]
                        mov     12[esi],ebp
                        pop     eax
                        pop     ebp
                        add     esi,16
                        sub     ebp,4
                        add     eax,4
                        cmp     ebp,4
                        jae     ddl640w
                        test    ebp,ebp
                        jz      ddl640wexit
ddl640wlast:            xor     ecx,ecx
ddl640wlastloop:        mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        inc     eax
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]
                        mov     [esi],edx
                        add     esi,4
                        dec     ebp
                        jnz     ddl640wlastloop
ddl640wexit:            mov     [_screenptr],esi
                        ret
                        align   4

public drawdualhires640w_
drawdualhires640w_:     mov     esi,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]

                        mov     ebx,[_clipleftx]
                        mov     ecx,[_cliprightx]
                        shl     ebx,1
                        shl     ecx,1
                        cmp     eax,ebx
                        jae     ddh640wleftnoclip
                        mov     eax,ebx
ddh640wleftnoclip:      cmp     ebp,ecx
                        jbe     ddh640wrightnoclip
                        mov     ebp,ecx
ddh640wrightnoclip:     sub     ebp,eax
                        jle     ddh640wexit
                        lea     edi,[_dualtranslate]
                        test    byte ptr [_bplcon2],040h
                        jnz     ddh640wprinotset
                        add     edi,010000h
ddh640wprinotset:       xor     ebx,ebx
                        cmp     ebp,4
                        jl      ddh640wlast
ddh640w:                mov     ecx,[_linje+eax]
                        mov     edx,[_linje2+eax]
                        push    ebp
                        mov     bh,ch       
                        push    eax   
                        mov     bl,dh 
                        xor     eax,eax
                        mov     al,[edi+ebx] 
                        mov     ebp,[_shadcol+eax]     
                        mov     bh,cl                            
                        shr     ecx,16                          
                        mov     bl,dl                           
                        shr     edx,16                          
                        mov     al,[edi+ebx]           
                        mov     bp,[_shadcol+eax]     
                        mov     [esi],ebp             
                        mov     bh,ch
                        mov     bl,dh
                        mov     al,[edi+ebx]
                        mov     ebp,[_shadcol+eax]
                        mov     bh,cl
                        mov     bl,dl
                        mov     al,[edi+ebx]
                        mov     bp,[_shadcol+eax]
                        mov     4[esi],ebp
                        pop     eax
                        pop     ebp
                        add     esi,8
                        sub     ebp,4
                        add     eax,4
                        cmp     ebp,4
                        jae     ddh640w
                        test    ebp,ebp
                        jz      ddh640wexit
ddh640wlast:            xor     ecx,ecx
ddh640wlastloop:        mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        inc     eax
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]
                        mov     [esi],dx
                        add     esi,2
                        dec     ebp
                        jnz     ddh640wlastloop
ddh640wexit:            mov     [_screenptr],esi
                        ret


                        align   4

public drawduallores320W_
drawduallores320w_:     mov     esi,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]
                        test    byte ptr [_bplcon0+1],080h
                        jz      ddul320wlores
                        shr     ebp,1
                        shr     edi,1
ddul320wlores:          cmp     eax,[_clipleftx]
                        jae     ddul320wleftnoclip
                        mov     eax,[_clipleftx]
ddul320wleftnoclip:     cmp     ebp,[_cliprightx]
                        jbe     ddul320wrightnoclip
                        mov     ebp,[_cliprightx]
ddul320wrightnoclip:    sub     ebp,eax
                        lea     edi,[_dualtranslate]
                        test    byte ptr [_bplcon2],040h
                        jnz     drdual320lopriunset
                        add     edi,010000h
drdual320lopriunset:    xor     ebx,ebx
                        xor     ecx,ecx
                        cmp     ebp,2
                        jl      dual320last
                        test    esi,03h                 ; Align VGA-pointer
                        jz      drduallo320
                        mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]    
                        mov     [esi],dx 
                        add     esi,2
                        inc     eax
                        dec     ebp
                        cmp     ebp,2
                        jl      dual320last
drduallo320:            mov     bh,byte ptr [_linje+1+eax]
                        mov     bl,byte ptr [_linje2+1+eax]
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]    
                        mov     bh,byte ptr [_linje+eax]      
                        mov     bl,byte ptr [_linje2+eax]  
                        mov     cl,[edi+ebx]
                        mov     dx,[_shadcol+ecx]
                        mov     [esi],edx 
                        sub     ebp,2
                        add     esi,4
                        add     eax,2
                        cmp     ebp,2
                        jae     drduallo320
dual320last:            test    ebp,ebp
                        jz      dual320exit
                        mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        mov     cl,[edi+ebx]
                        mov     dx,[_shadcol+ecx]
                        mov     [esi],dx
                        add     esi,2
dual320exit:            mov     [_screenptr],esi
                        ret


                        align   4

public drawduallores320b_
drawduallores320b_:     mov     esi,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]
                        test    byte ptr [_bplcon0+1],080h
                        jz      ddul320blores
                        shr     ebp,1
                        shr     edi,1
ddul320blores:          cmp     eax,[_clipleftx]
                        jae     ddul320bleftnoclip
                        mov     eax,[_clipleftx]
ddul320bleftnoclip:     cmp     ebp,[_cliprightx]
                        jbe     ddul320brightnoclip
                        mov     ebp,[_cliprightx]
ddul320brightnoclip:    sub     ebp,eax
                        lea     edi,[_dualtranslate]
                        test    byte ptr [_bplcon2],040h
                        jnz     drdual320blopriunset
                        add     edi,010000h
drdual320blopriunset:   xor     ebx,ebx
                        xor     ecx,ecx
                        cmp     ebp,4
                        jl      dual320blast
                        test    esi,01h                 ; Align VGA-pointer
                        jz      drduallo320balign2
                        mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]    
                        mov     [esi],dl 
                        inc     esi
                        inc     eax
                        dec     ebp
                        cmp     ebp,4
                        jl      dual320blast
drduallo320balign2:     test    esi,02h                 ; Align VGA-pointer
                        jz      drduallo320b
                        mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]    
                        mov     bh,byte ptr [_linje+1+eax]
                        mov     bl,byte ptr [_linje2+1+eax]
                        mov     cl,[edi+ebx]
                        mov     dh,[_shadcol+ecx]    
                        mov     [esi],dx
                        add     esi,2
                        add     eax,2
                        sub     ebp,2
                        cmp     ebp,4
                        jl      dual320blast
drduallo320b:
                        mov     bh,byte ptr [_linje+1+eax]
                        mov     bl,byte ptr [_linje2+1+eax]
                        mov     cl,[edi+ebx]
                        mov     dh,[_shadcol+ecx]    
                        mov     bh,byte ptr [_linje+eax]      
                        mov     bl,byte ptr [_linje2+eax]  
                        mov     cl,[edi+ebx]
                        mov     dl,[_shadcol+ecx]
                        shl     edx,16
                        mov     bh,byte ptr [_linje+3+eax]
                        mov     bl,byte ptr [_linje2+3+eax]
                        mov     cl,[edi+ebx]
                        mov     dh,[_shadcol+ecx]    
                        mov     bh,byte ptr [_linje+2+eax]      
                        mov     bl,byte ptr [_linje2+2+eax]  
                        mov     cl,[edi+ebx]
                        mov     dl,[_shadcol+ecx]
                        rol     edx,16
                        mov     [esi],edx
                        sub     ebp,4
                        add     esi,4
                        add     eax,4
                        cmp     ebp,4
                        jae     drduallo320b
dual320blast:           test    ebp,ebp
                        jz      dual320bexit
ddual320blastloop:      mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        mov     cl,[edi+ebx]
                        mov     dl,[_shadcol+ecx]
                        mov     [esi],dl
                        inc     eax
                        inc     esi
                        dec     ebp
                        test    ebp,ebp
                        jnz     ddual320blastloop
dual320bexit:           mov     [_screenptr],esi
                        ret

                        align   4

public drawham320W_
drawham320w_:           mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        sub     ebp,edi
                        jz      dhl320exit
                        mov     edx,[_screenptr]
                        xor     esi,esi
dhl320:                 mov     cl,byte ptr [_linje+edi]
                        xor     ebx,ebx
                        mov     bl,cl            
                        test    cl,0c0h
                        jz      dhl320normal
                        and     bl,0c0h
                        cmp     bl,0c0h
                        je      dhl320green
                        cmp     bl,80h
                        je      dhl320red
                        mov     ebx,ecx           ; Blue component to be exchanged
                        and     ebx,03ch
                        shr     ebx,1
                        and     esi,07fe07fe0h   ; Mask away old blue
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhl320draw
dhl320red:              mov     ebx,ecx           ; Red component to be exchanged
                        and     ebx,03ch
                        shl     ebx,9
                        and     esi,03ff03ffh   ; Mask away old red
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhl320draw
dhl320green:            mov     ebx,ecx           ; Green component to be exchanged
                        and     ebx,03ch
                        shl     ebx,4
                        and     esi,07c1f7c1fh   ; Mask away old green
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhl320draw
dhl320normal:           mov     esi,[_shadcol+ebx]
dhl320draw:             cmp     edi,[_clipleftx]
                        jb      dhl320nodraw
                        cmp     edi,[_cliprightx]
                        jae     dhl320nodraw
                        mov     [edx],si
                        add     edx,2
dhl320nodraw:           inc     edi
                        dec     ebp
                        jnz     dhl320
                        mov     [_screenptr],edx
dhl320exit:             ret


                        align   4

public drawham320b_
drawham320b_:           mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        sub     ebp,edi
                        jz      dhl320bexit
                        mov     edx,[_screenptr]
                        xor     esi,esi
dhl320b:                mov     cl,byte ptr [_linje+edi]
                        xor     ebx,ebx
                        mov     bl,cl            
                        test    cl,0c0h
                        jz      dhl320bnormal
                        and     bl,0c0h
                        cmp     bl,0c0h
                        je      dhl320bgreen
                        cmp     bl,80h
                        je      dhl320bred
                        mov     ebx,ecx           ; Blue component to be exchanged
                        and     ebx,03ch
                        shr     ebx,2
                        and     esi,0ff0h   ; Mask away old blue
                        or      esi,ebx
                        jmp     dhl320bdraw
dhl320bred:             mov     ebx,ecx           ; Red component to be exchanged
                        and     ebx,03ch
                        shl     ebx,6
                        and     esi,0ffh   ; Mask away old red
                        or      esi,ebx
                        jmp     dhl320bdraw
dhl320bgreen:           mov     ebx,ecx           ; Green component to be exchanged
                        and     ebx,03ch
                        shl     ebx,2
                        and     esi,0f0fh   ; Mask away old green
                        or      esi,ebx
                        jmp     dhl320bdraw
dhl320bnormal:          mov     esi,[_shadcol+ebx]
                        and     esi,0ffh
                        mov     esi,_vgareg2color[esi*4]
dhl320bdraw:            cmp     edi,[_clipleftx]
                        jb      dhl320bnodraw
                        cmp     edi,[_cliprightx]
                        jae     dhl320bnodraw
                        mov     ebx,_colortab[esi*4]
                        mov     [edx],bl
                        inc     edx
dhl320bnodraw:          inc     edi
                        dec     ebp
                        jnz     dhl320b
                        mov     [_screenptr],edx
dhl320bexit:            ret


                        align   4

public drawham640W_
drawham640w_:           mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        sub     ebp,edi
                        jz      dhl640exit
                        mov     edx,[_screenptr]
                        xor     esi,esi
dhl640:                 mov     cl,byte ptr [_linje+edi]
                        xor     ebx,ebx
                        mov     bl,cl            
                        test    cl,0c0h
                        jz      dhl640normal
                        and     bl,0c0h
                        cmp     bl,0c0h
                        je      dhl640green
                        cmp     bl,80h
                        je      dhl640red
                        mov     ebx,ecx           ; Blue component to be exchanged
                        and     ebx,03ch
                        shr     ebx,1
                        and     esi,07fe07fe0h   ; Mask away old blue
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhl640draw
dhl640red:              mov     ebx,ecx           ; Red component to be exchanged
                        and     ebx,03ch
                        shl     ebx,9
                        and     esi,03ff03ffh   ; Mask away old red
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhl640draw
dhl640green:            mov     ebx,ecx           ; Green component to be exchanged
                        and     ebx,03ch
                        shl     ebx,4
                        and     esi,07c1f7c1fh   ; Mask away old green
                        or      esi,ebx
                        shl     ebx,16
                        or      esi,ebx
                        jmp     dhl640draw
dhl640normal:           mov     esi,[_shadcol+ebx]
dhl640draw:             cmp     edi,[_clipleftx]
                        jb      dhl640nodraw
                        cmp     edi,[_cliprightx]
                        jae     dhl640nodraw
                        mov     [edx],esi
                        add     edx,4
dhl640nodraw:           inc     edi
                        dec     ebp
                        jnz     dhl640
                        mov     [_screenptr],edx
dhl640exit:             ret


; Decode sprite 4 colors
; esi - buffer to decode to
; ecx - pointer to spritedata array
; ebx - sprite class (0,1,2,3)

decode4sprite_:
decode4sprite:
        xor     edx,edx

        test    ebx,ebx
        jz      decode4spritec0
        cmp     ebx,1
        je      decode4spritec1
        cmp     ebx,2
        je      decode4spritec2

        mov     dl,byte ptr [ecx]
        mov     eax,dword ptr [_decosc31  +8*edx]
        mov     ebx,dword ptr [_decosc31+4+8*edx]
        mov     dl,byte ptr 1[ecx]
        mov     edi,dword ptr [_decosc31  +8*edx]
        mov     ebp,dword ptr [_decosc31+4+8*edx]
        mov     dl,byte ptr 2[ecx]
        or      eax,dword ptr [_decosc32  +8*edx]
        or      ebx,dword ptr [_decosc32+4+8*edx]
        mov     dl,byte ptr 3[ecx]
        or      edi,dword ptr [_decosc32  +8*edx]
        or      ebp,dword ptr [_decosc32+4+8*edx]

        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
	ret
decode4spritec2:
        mov     dl,byte ptr [ecx]
        mov     eax,dword ptr [_decosc21  +8*edx]
        mov     ebx,dword ptr [_decosc21+4+8*edx]
        mov     dl,byte ptr 1[ecx]
        mov     edi,dword ptr [_decosc21  +8*edx]
        mov     ebp,dword ptr [_decosc21+4+8*edx]
        mov     dl,byte ptr 2[ecx]
        or      eax,dword ptr [_decosc22  +8*edx]
        or      ebx,dword ptr [_decosc22+4+8*edx]
        mov     dl,byte ptr 3[ecx]
        or      edi,dword ptr [_decosc22  +8*edx]
        or      ebp,dword ptr [_decosc22+4+8*edx]

        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
	ret
decode4spritec1:
        mov     dl,byte ptr [ecx]
        mov     eax,dword ptr [_decosc11  +8*edx]
        mov     ebx,dword ptr [_decosc11+4+8*edx]
        mov     dl,byte ptr 1[ecx]
        mov     edi,dword ptr [_decosc11  +8*edx]
        mov     ebp,dword ptr [_decosc11+4+8*edx]
        mov     dl,byte ptr 2[ecx]
        or      eax,dword ptr [_decosc12  +8*edx]
        or      ebx,dword ptr [_decosc12+4+8*edx]
        mov     dl,byte ptr 3[ecx]
        or      edi,dword ptr [_decosc12  +8*edx]
        or      ebp,dword ptr [_decosc12+4+8*edx]

        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
	ret
decode4spritec0:
        mov     dl,byte ptr [ecx]
        mov     eax,dword ptr [_decosc01  +8*edx]
        mov     ebx,dword ptr [_decosc01+4+8*edx]
        mov     dl,byte ptr 1[ecx]
        mov     edi,dword ptr [_decosc01  +8*edx]
        mov     ebp,dword ptr [_decosc01+4+8*edx]
        mov     dl,byte ptr 2[ecx]
        or      eax,dword ptr [_decosc02  +8*edx]
        or      ebx,dword ptr [_decosc02+4+8*edx]
        mov     dl,byte ptr 3[ecx]
        or      edi,dword ptr [_decosc02  +8*edx]
        or      ebp,dword ptr [_decosc02+4+8*edx]

        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
	ret

; Decode sprite 16 colors
; esi - buffer to decode to
; ecx - pointer to spritedata array
decode16sprite_:
decode16sprite:
        xor     edx,edx

        mov     dl,byte ptr [ecx]
        mov     eax,dword ptr [_decosc01  +8*edx]
        mov     ebx,dword ptr [_decosc01+4+8*edx]
        mov     dl,byte ptr 1[ecx]
        mov     edi,dword ptr [_decosc01  +8*edx]
        mov     ebp,dword ptr [_decosc01+4+8*edx]
        mov     dl,byte ptr 2[ecx]
        or      eax,dword ptr [_decosc02  +8*edx]
        or      ebx,dword ptr [_decosc02+4+8*edx]
        mov     dl,byte ptr 3[ecx]
        or      edi,dword ptr [_decosc02  +8*edx]
        or      ebp,dword ptr [_decosc02+4+8*edx]

        mov     dl,byte ptr 4[ecx]
        or      eax,dword ptr [_decosc03  +8*edx]
        or      ebx,dword ptr [_decosc03+4+8*edx]
        mov     dl,byte ptr 5[ecx]
        or      edi,dword ptr [_decosc03  +8*edx]
        or     ebp,dword ptr [_decosc03+4+8*edx]
        mov     dl,byte ptr 6[ecx]
        or      eax,dword ptr [_decosc04  +8*edx]
        or      ebx,dword ptr [_decosc04+4+8*edx]
        mov     dl,byte ptr 7[ecx]
        or      edi,dword ptr [_decosc04  +8*edx]
        or      ebp,dword ptr [_decosc04+4+8*edx]


        mov     dword ptr [esi],eax
        mov     dword ptr 4[esi],ebx
        mov     dword ptr 8[esi],edi
        mov     dword ptr 12[esi],ebp
        ret



;        align   4
	align   4

; ===========================================
; Entrypoint for blitter operations
; ===========================================

; Assume never called when blitter dma is off
; Only calculate the cyclecount
; Set blitend to the cycle when the blit ends
; Set the blitter not ready flag in dmacon
; If blitpri is on, write the cyclecount to
; thiscycle

blitter_copy_:
        push    ebx
        push    eax
        mov     eax,dword ptr _bltcon
        shr     eax,24                           ; calc cycles
	and     eax,0fh
	mov     ebx,dword ptr [blitcycletab+eax*4]
	imul    ebx,dword ptr _linelength        ; cycles per line
	imul    ebx,dword ptr _linenum           ; total cyclecount
        shr     ebx,1
        mov     eax,1                           ; Set state 1, no bltpri blt
        mov     dword ptr _thiscycle,0
        test    dword ptr _dmaconr,0400h        ; test bltpri
        jz      nobltpri
        inc     eax                             ; Set state 2, bltpri blt
        mov     dword ptr _thiscycle,ebx
nobltpri:
; Set blitend to right cycle
        shr     ebx,1
        add     ebx,dword ptr _curcycle
        mov     dword ptr _blitend,ebx
; Set blitter busy bit
        or      dword ptr _dmaconr,04000h
        mov     dword ptr _blitterstatus,eax

        pop     eax
        pop     ebx
        ret





; This function does the blit, called on the last cycle
; of the blit.
finish_blit_:
        mov     dword ptr _firstwordinblit,1
	mov     dword ptr _blitterdmawaiting,0
        mov     dword ptr _blitterstatus,0
        and     dword ptr _dmaconr,0bfffh     
	xor     eax,eax
	mov     dword ptr leftoverA,eax
	mov     dword ptr leftoverB,eax
	mov     ebx,dword ptr _bltcon
	test    ebx,1
	jnz     blitterlinemode


	test    ebx,18h
	jnz     blitterfillmode

	shr     ebx,22
	and     ebx,03ch
	jmp     dword ptr [blittermodes+ebx]


; ==============================================
; Blitter line mode
; ==============================================

blitterlinemode:

        mov     dword ptr _bltlinepointflag,0
	mov     eax,dword ptr _linecount
	mov     dword ptr bltlineheight,eax     ; Line height
        mov     eax,dword ptr _bltcon
        mov     ecx,eax
        shr     ecx,28
        and     ecx,00fh         

        and     eax,1ch
        mov     ebx,ecx

        mov     bp,word ptr _bltapt   ; edi is decision variable
        mov     esi,dword ptr _bltcpt     ; get C data adress
        mov     edi,dword ptr _bltdpt     ; get destination adress
        add     esi,offset _cmem
        add     edi,offset _cmem
        sub     esi,2

        mov     edx,dword ptr _bltbdatoriginal
        mov     ecx,dword ptr _bltcon
        shr     ecx,12
        and     ecx,0fh
        ror     dx,cl
        mov     dword ptr _bltbdatline,edx
        xor     ecx,ecx
        test    edx,1
        jz      bliq
        mov     ecx,-1
bliq:


        jmp     dword ptr bltlinesudsulaul[eax]  ; Jump to correct draw routine

; SUD/SUL/AUL = 000
; Line goes down to the right, Y is independent

; Registers:
; ebp - D
; esi - cpt
; edi - dpt
; ebx - bltadat
; ecx - bltbdat
; edx - bltcdat
; eax - result

blitterlinemodeoctant0:
oct0c:
        test    dword ptr _bltcon,02000000h
        jz      oct0u
        mov     edx,dword ptr [esi]
        bswap   edx
oct0u:
        push    ebx
        push    ecx
        mov     cl,bl
        mov     ebx,dword ptr _bltadat
        shr     bx,cl
        pop     ecx

        call    dword ptr [_bltminterm]

        pop     ebx

        mov     byte ptr [edi],ah    ; Store result
        mov     byte ptr 1[edi],al
        mov     eax,dword ptr _bltcmod
        or      bp,bp                     ; D 
	jns     oct0a            
        add     ebp,dword ptr _bltbmod    ; D < 0 , D = D + 2*sdelta
	jmp     oct0b
oct0a:  add     ebp,dword ptr _bltamod    ; D >= 0, D = D + 2*sdelta-2*ldelta

        inc     ebx
        cmp     ebx,16
        jne     oct0b


        xor     ebx,ebx

        add     esi,2
        add     edi,2
oct0b:  add     esi,eax
        add     edi,eax

        mov     eax,dword ptr _bltbdatline
        rol     ax,1
        mov     dword ptr _bltbdatline,eax
        xor     ecx,ecx
        test    eax,1
        jz      oct0q
        dec     ecx
oct0q:


        dec     dword ptr bltlineheight
	jnz     oct0c
	jmp     blitterlinemodeend


; SUD/SUL/AUL = 001
; Line goes up to the right, Y is independent
blitterlinemodeoctant1: 
oct1c:
        test    dword ptr _bltcon,02000000h
        jz      oct1u
        mov     edx,dword ptr [esi]
        bswap   edx
oct1u:
        push    ebx
        push    ecx
        mov     cl,bl
        mov     ebx,dword ptr _bltadat
        shr     bx,cl
        pop     ecx
        call    dword ptr [_bltminterm]

        pop     ebx

        mov     byte ptr [edi],ah    ; Store result
        mov     byte ptr 1[edi],al
        mov     eax,dword ptr _bltcmod
        or      bp,bp                     ; D < 0
	jns     oct1a            
        add     ebp,dword ptr _bltbmod    ; D < 0 , D = D + 2*sdelta
	jmp     oct1b
oct1a:  add     ebp,dword ptr _bltamod    ; D >= 0, D = D + 2*sdelta-2*ldelta

        inc     ebx
        cmp     ebx,16
        jne     oct1b

        xor     ebx,ebx

        add     edi,2
        add     esi,2
oct1b:  sub     edi,eax
        sub     esi,eax

        mov     eax,dword ptr _bltbdatline
        rol     ax,1
        mov     dword ptr _bltbdatline,eax
        xor     ecx,ecx
        test    eax,1
        jz      oct1q
        dec     ecx
oct1q:

	dec     dword ptr bltlineheight
	jnz     oct1c
	jmp     blitterlinemodeend

; SUD/SUL/AUL = 010
; Line goes down, to the left, Y is independent
blitterlinemodeoctant2: 
oct2c:

        test    dword ptr _bltcon,02000000h
        jz      oct2u
        mov     edx,dword ptr [esi]
        bswap   edx
oct2u:

        push    ebx
        push    ecx
        mov     cl,bl
        mov     ebx,dword ptr _bltadat
        shr     bx,cl
        pop     ecx


        call    dword ptr [_bltminterm]

        pop     ebx

        mov     byte ptr [edi],ah    ; Store result
        mov     byte ptr 1[edi],al
        mov     eax,dword ptr _bltcmod
        or      bp,bp                     ; D < 0
	jns     oct2a            
        add     ebp,dword ptr _bltbmod    ; D < 0 , D = D + 2*sdelta
	jmp     oct2b
oct2a:  add     ebp,dword ptr _bltamod    ; D >= 0, D = D + 2*sdelta-2*ldelta
        dec     ebx
        jns     oct2b

        mov     ebx,15

        sub     edi,2
        sub     esi,2
oct2b:  add     edi,eax
        add     esi,eax

        mov     eax,dword ptr _bltbdatline
        rol     ax,1
        mov     dword ptr _bltbdatline,eax
        xor     ecx,ecx
        test    eax,1
        jz      oct2q
        dec     ecx
oct2q:

        dec     dword ptr bltlineheight
	jnz     oct2c
	jmp     blitterlinemodeend

; SUD/SUL/AUL = 011
; Line goes up to the left, Y is independent
blitterlinemodeoctant3: 
oct3c:

        test    dword ptr _bltcon,02000000h
        jz      oct3u
        mov     edx,dword ptr [esi]
        bswap   edx
oct3u:

        push    ebx
        push    ecx
        mov     cl,bl
        mov     ebx,dword ptr _bltadat
        shr     bx,cl
        pop     ecx


        call    dword ptr [_bltminterm]

        pop     ebx

        mov     byte ptr [edi],ah    ; Store result
        mov     byte ptr 1[edi],al
        mov     eax,dword ptr _bltcmod
        or      bp,bp                     ; D < 0
	jns     oct3a            
        add     ebp,dword ptr _bltbmod    ; D < 0 , D = D + 2*sdelta
	jmp     oct3b
oct3a:  add     ebp,dword ptr _bltamod    ; D >= 0, D = D + 2*sdelta-2*ldelta


        dec     ebx
        jns     oct3b
        mov     ebx,15

        sub     edi,2
        sub     esi,2
oct3b:  sub     edi,eax
        sub     esi,eax

        mov     eax,dword ptr _bltbdatline
        rol     ax,1
        mov     dword ptr _bltbdatline,eax
        xor     ecx,ecx
        test    eax,1
        jz      oct3q
        dec     ecx
oct3q:

	dec     dword ptr bltlineheight
	jnz     oct3c
	jmp     blitterlinemodeend

; SUD/SUL/AUL = 100
; Line goes down to the right, X is independent
blitterlinemodeoctant4: 
oct4c:

        test    dword ptr _bltcon,02000000h
        jz      oct4u
        mov     edx,dword ptr [esi]
        bswap   edx
oct4u:

        test    dword ptr _bltcon,2       ; Test sing
	jz      oct4e
	test    dword ptr _bltlinepointflag,1 ; No draw if bit already set
	jnz     oct4f
	mov     dword ptr _bltlinepointflag,1
oct4e:

        push    ebx
        push    ecx
        mov     cl,bl
        mov     ebx,dword ptr _bltadat
        shr     bx,cl
        pop     ecx


        call    dword ptr [_bltminterm]

        pop     ebx

        mov     byte ptr [edi],ah    ; Store result
        mov     byte ptr 1[edi],al
oct4f:  or      bp,bp                     ; D < 0
	jns     oct4a            
        add     ebp,dword ptr _bltbmod    ; D < 0 , D = D + 2*sdelta
	jmp     oct4b
oct4a:  mov     eax,dword ptr _bltcmod    ; Y increases
        add     ebp,dword ptr _bltamod    ; D >= 0, D = D + 2*sdelta-2*ldelta
        add     edi,eax
        add     esi,eax
	mov     dword ptr _bltlinepointflag,0 ; enable dot on this line
oct4b:
        inc     ebx
        cmp     ebx,16
        jne     oct4d
        xor     ebx,ebx
        add     edi,2
        add     esi,2
oct4d:


        mov     eax,dword ptr _bltbdatline
        rol     ax,1
        mov     dword ptr _bltbdatline,eax
        xor     ecx,ecx
        test    eax,1
        jz      oct4q
        dec     ecx
oct4q:

        dec     dword ptr bltlineheight
	jnz     oct4c
	jmp     blitterlinemodeend

; SUD/SUL/AUL = 101
; Line goes down to the left, X is independent
blitterlinemodeoctant5: 
oct5c:
        test    dword ptr _bltcon,02000000h
        jz      oct5u
        mov     edx,dword ptr [esi]
        bswap   edx
oct5u:
        test    dword ptr _bltcon,2
	jz      oct5e
	test    dword ptr _bltlinepointflag,1
	jnz     oct5f
	mov     dword ptr _bltlinepointflag,1
oct5e:

        push    ebx
        push    ecx
        mov     cl,bl
        mov     ebx,dword ptr _bltadat
        shr     bx,cl
        pop     ecx


        call    dword ptr [_bltminterm]

        pop     ebx

        mov     byte ptr [edi],ah    ; Store result
        mov     byte ptr 1[edi],al
oct5f:  or      bp,bp                     ; D < 0
	jns     oct5a            
        add     ebp,dword ptr _bltbmod    ; D < 0 , D = D + 2*sdelta
	jmp     oct5b
oct5a:  mov     eax,dword ptr _bltcmod    ; Y increases
        add     ebp,dword ptr _bltamod    ; D >= 0, D = D + 2*sdelta-2*ldelta
        add     edi,eax
        add     esi,eax
	mov     dword ptr _bltlinepointflag,0
oct5b:
        dec     ebx
        jns     oct5d
        mov     ebx,15

        sub     edi,2
        sub     esi,2
oct5d:
        mov     eax,dword ptr _bltbdatline
        rol     ax,1
        mov     dword ptr _bltbdatline,eax
        xor     ecx,ecx
        test    eax,1
        jz      oct5q
        dec     ecx
oct5q:


        dec     dword ptr bltlineheight
	jnz     oct5c
	jmp     blitterlinemodeend

; SUD/SUL/AUL = 110
; Line goes up, to the right, X is independent
blitterlinemodeoctant6: 
oct6c:
        test    dword ptr _bltcon,02000000h
        jz      oct6u
        mov     edx,dword ptr [esi]
        bswap   edx
oct6u:

        test    dword ptr _bltcon,2
	jz      oct6e
	test    dword ptr _bltlinepointflag,1
	jnz     oct6f
	mov     dword ptr _bltlinepointflag,1
oct6e:
        push    ebx
        push    ecx
        mov     cl,bl
        mov     ebx,dword ptr _bltadat
        shr     bx,cl
        pop     ecx


        call    dword ptr [_bltminterm]

        pop     ebx

        mov     byte ptr [edi],ah    ; Store result
        mov     byte ptr 1[edi],al
oct6f:  or      bp,bp                     ; D < 0
	jns     oct6a            
        add     ebp,dword ptr _bltbmod    ; D < 0 , D = D + 2*sdelta
	jmp     oct6b
oct6a:  mov     eax,dword ptr _bltcmod    ; Y decreases
        add     ebp,dword ptr _bltamod    ; D >= 0, D = D + 2*sdelta-2*ldelta
        sub     edi,eax
        sub     esi,eax
	mov     dword ptr _bltlinepointflag,0
oct6b:
        inc     ebx
        cmp     ebx,16
        jne     oct6d
        xor     ebx,ebx
        add     edi,2
        add     esi,2
oct6d:
        mov     eax,dword ptr _bltbdatline
        rol     ax,1
        mov     dword ptr _bltbdatline,eax
        xor     ecx,ecx
        test    eax,1
        jz      oct6q
        dec     ecx
oct6q:
        dec     dword ptr bltlineheight
	jnz     oct6c
	jmp     blitterlinemodeend

; SUD/SUL/AUL = 111
; Line goes up to the left, X is independent
blitterlinemodeoctant7: 
oct7c:

        test    dword ptr _bltcon,02000000h
        jz      oct7u
        mov     edx,dword ptr [esi]
        bswap   edx
oct7u:
        test    dword ptr _bltcon,2
	jz      oct7e
	test    dword ptr _bltlinepointflag,1
	jnz     oct7f
	mov     dword ptr _bltlinepointflag,1
oct7e:
        push    ebx
        push    ecx
        mov     cl,bl
        mov     ebx,dword ptr _bltadat
        shr     bx,cl
        pop     ecx


        call    dword ptr [_bltminterm]

        pop     ebx

        mov     byte ptr [edi],ah    ; Store result
        mov     byte ptr 1[edi],al
oct7f:  or      bp,bp                     ; D < 0
	jns     oct7a            
        add     ebp,dword ptr _bltbmod    ; D < 0 , D = D + 2*sdelta
	jmp     oct7b
oct7a:  mov     eax,dword ptr _bltcmod    ; Y decreases
        add     ebp,dword ptr _bltamod    ; D >= 0, D = D + 2*sdelta-2*ldelta
        sub     edi,eax
        sub     esi,eax
	mov     dword ptr _bltlinepointflag,0
oct7b:
        dec     ebx
        jns     oct7d
        mov     ebx,15

        sub     edi,2
        sub     esi,2
oct7d:

        mov     eax,dword ptr _bltbdatline
        rol     ax,1
        mov     dword ptr _bltbdatline,eax
        xor     ecx,ecx
        test    eax,1
        jz      oct7q
        dec     ecx
oct7q:

        dec     dword ptr bltlineheight
	jnz     oct7c

blitterlinemodeend:
        sub     esi,offset _cmem
        sub     edi,offset _cmem
        add     esi,2
        mov     dword ptr _bltdpt,edi
        mov     dword ptr _bltcpt,esi
        mov     edx,08040h
	mov     ecx,0dff09ch
	call    wriw
	ret




; ===============================
; Blitter fill mode
; Can I assume always decending mode???
; ===============================


; Here simply jump to the most appropriate fill routine
blitterfillmode:
        shr     ebx,22
	and     ebx,03ch
        jmp     dword ptr [blitterfillmodes+ebx]


; The general fill routine that handles any combination of ABCD
blitterfillline:
        mov     eax,dword ptr _bltcon
	mov     dword ptr bltfillbltconsave,eax
        test    eax,8
        jz      blitterexfillline

blitterincfillline:
	mov     esi,dword ptr _linelength
	mov     eax,dword ptr _bltcon
	mov     dword ptr bltfillbltconsave,eax
	mov     ebp,dword ptr _bltdesc
blitincfillword:
blitincfill1:
	test    eax,08000000h                       ; Test dma A
        jz      blitincfill2
	mov     ecx,dword ptr [_bltApt]
	mov     edx,dword ptr [_cmem+ecx]  ;[_cmem-2+ecx]
        bswap   edx                     ; My word is now in bits 31-16
        cmp     esi,dword ptr _linelength  ; Do first word masking
        jne     blitincfilld
	and     edx,dword ptr [_bltAFWM]
blitincfilld:
        cmp     esi,1                      ; Do last word masking+ modulo
        jne     blitincfillf
	mov     ebx,dword ptr [_bltAMOD]          ; BLTMOD oppdateres DESC
        add     ecx,ebx
        and     edx,dword ptr [_bltALWM]   ; Mask is mirrored in lo/hi word
blitincfillf:
        add     ecx,ebp                    ; Add +2 or -2 to ptA
        and     edx,0ffff0000h             ; Take away garbage
        and     ecx,01ffffeh               ; For safety
        mov     dword ptr [_bltApt],ecx
        mov     ecx,eax                    ; Move saved bltcon to ecx
        shr     ecx,28                     ; Exctract shift for A

        test    eax,2        ; Test desc mode
        jz      blitincnofdesc1
        rol     edx,cl                     ; Rotate to left in desc mode
        jmp     blitincnofdesc2
blitincnofdesc1:
        shr     edx,cl                     ; Shift to right in forward mode
blitincnofdesc2:


        mov     ecx,dword ptr leftoverA    ; get last leftover
        mov     dword ptr leftoverA,edx    ; Store leftover from A
        shr     edx,16                     ; Move my shifted  data down
        or      edx,ecx                    ; Merge with leftover
        mov     dword ptr [_bltADAT],edx   ; Store data from A
        jmp     blitincfill2x

; DMA A off
blitincfill2:
        mov     edx,dword ptr _bltadatoriginal
        shl     edx,16
        cmp     esi,dword ptr _linelength  ; Do first word masking
        jne     bifd
	and     edx,dword ptr [_bltAFWM]
bifd:
        cmp     esi,1                      ; Do last word masking+ modulo
        jne     biff
	mov     ebx,dword ptr [_bltAMOD]          ; BLTMOD oppdateres DESC
        add     ecx,ebx
        and     edx,dword ptr [_bltALWM]   ; Mask is mirrored in lo/hi word
biff:
        mov     ecx,eax                    ; Move saved bltcon to ecx
        shr     ecx,28                     ; Exctract shift for A

        test    eax,2        ; Test desc mode
        jz      binofdesc1
        rol     edx,cl                     ; Rotate to left in desc mode
        jmp     binofdesc2
binofdesc1:
        shr     edx,cl                     ; Shift to right in forward mode
binofdesc2:


        mov     ecx,dword ptr leftoverA    ; get last leftover
        mov     dword ptr leftoverA,edx    ; Store leftover from A
        shr     edx,16                     ; Move my shifted  data down
        or      edx,ecx                    ; Merge with leftover
        mov     dword ptr [_bltADAT],edx   ; Store data from A
blitincfill2x:
        test    eax,04000000h              ; Test dma B
        jz      blitincfill3
	mov     ecx,dword ptr [_bltBpt]
	mov     edx,dword ptr [_cmem-2+ecx]
        bswap   edx                        ; My data in lo word
        cmp     esi,1                      ; Do modulo if last word on line 
        jne     blitincfillg
        mov     ebx,dword ptr [_bltBMOD]   ; BLTBMOD
        add     ecx,ebx
blitincfillg:
        add     ecx,ebp                    ; Add ptB with +2 or -2
        and     ecx,01ffffeh               ; For safety
        mov     dword ptr [_bltBpt],ecx    ; Save ptB
        mov     ecx,eax                    ; Extract shift for B
	shr     ecx,12
        and     ecx,0fh
        shl     edx,16                     ; Move my data up, lo is clean

        test    eax,2                      ; Rotate or shift
        jz      blitincnofdesc3
        rol     edx,cl
        jmp     blitincnofdesc4
blitincnofdesc3:
        shr     edx,cl
blitincnofdesc4:


        mov     ecx,dword ptr leftoverB    ; Old leftover
        mov     dword ptr leftoverB,edx    ; Store leftover from B
        shr     edx,16                     ; Move rest of data down
        or      edx,ecx                    ; Merge with leftover
        mov     dword ptr [_bltBDAT],edx   ; Store data from B
blitincfill3:



blitincfill3x:
	test    eax,02000000h                       ; Test dma C
        jz      blitincfill4
	mov     ecx,dword ptr [_bltCpt]
        mov     edx,dword ptr _cmem-2+ecx
        bswap   edx                            ; Move my data down
        cmp     esi,1                          ; last word??
        jne     blitincfillh
        mov     ebx,dword ptr _bltCMOD         ; BLTCMOD
        add     ecx,ebx
blitincfillh:
        add     ecx,ebp
        and     ecx,01ffffeh
	mov     dword ptr [_bltCpt],ecx
	mov     dword ptr [_bltCDAT],edx           ; Store data from C

; Now the data lies in BLTXDAT registers
blitincfill4:
        push    eax
        mov     edx,dword ptr _bltcdat
	mov     ecx,dword ptr _bltbdat
	mov     ebx,dword ptr _bltadat
        call    dword ptr [_bltminterm]

        mov     edx,eax
        pop     eax
        and     edx,0ffffh
; Now we have the result
; Do fill

        test    eax,4                   ; test if FC bit is set
        jnz     blitincafc1
	mov     bx,word ptr _fillincfc0[edx*2] ; Get inc,fc0
	mov     dl,byte ptr _fillincfc0after[edx] ; get fc bit after
        jmp     blitincfillafter
blitincafc1:
	mov     bx,word ptr _fillincfc1[edx*2] ; Get inc,fc0
	mov     dl,byte ptr _fillincfc1after[edx] ; get fc bit after
blitincfillafter:
        shl     dl,2            ; Inject FC bit into saved bltcon
	and     al,0fbh
	or      al,dl
	mov     byte ptr bltfillbltconsave,al


	mov     eax,dword ptr bltfillbltconsave

	mov     ecx,dword ptr [_bltDpt]
        mov     byte ptr _cmem+ecx,bh
        mov     byte ptr _cmem+1+ecx,bl
        add     ecx,ebp
	cmp     esi,1
        jne     blitincfillj
	mov     ebx,dword ptr [_bltDMOD]
        add     ecx,ebx
blitincfillj:
        and     ecx,01ffffeh
        mov     dword ptr [_bltDpt],ecx
blitincfilli:
	dec     esi
        jnz     blitincfillword
	dec     dword ptr _linecount
        jnz     blitterincfillline
        jmp     blitterfillend

blitterexfillline:
	mov     esi,dword ptr _linelength
	mov     eax,dword ptr _bltcon
	mov     dword ptr bltfillbltconsave,eax
	mov     ebp,dword ptr _bltdesc
blitexfillword:
blitexfill1:
	test    eax,08000000h                       ; Test dma A
        jz      blitexfill2
	mov     ecx,dword ptr [_bltApt]
	mov     edx,dword ptr [_cmem+ecx]  ;[_cmem-2+ecx]
        bswap   edx                     ; My word is now in bits 31-16
        cmp     esi,dword ptr _linelength  ; Do first word masking
        jne     blitexfilld
	and     edx,dword ptr [_bltAFWM]
blitexfilld:
        cmp     esi,1                      ; Do last word masking+ modulo
        jne     blitexfillf
	mov     ebx,dword ptr [_bltAMOD]          ; BLTMOD oppdateres DESC
        add     ecx,ebx
        and     edx,dword ptr [_bltALWM]   ; Mask is mirrored in lo/hi word
blitexfillf:
        add     ecx,ebp                    ; Add +2 or -2 to ptA
        and     edx,0ffff0000h             ; Take away garbage
        and     ecx,01ffffeh               ; For safety
        mov     dword ptr [_bltApt],ecx
        mov     ecx,eax                    ; Move saved bltcon to ecx
        shr     ecx,28                     ; Exctract shift for A

        test    eax,2        ; Test desc mode
        jz      blitexnofdesc1
        rol     edx,cl                     ; Rotate to left in desc mode
        jmp     blitexnofdesc2
blitexnofdesc1:
        shr     edx,cl                     ; Shift to right in forward mode
blitexnofdesc2:


        mov     ecx,dword ptr leftoverA    ; get last leftover
        mov     dword ptr leftoverA,edx    ; Store leftover from A
        shr     edx,16                     ; Move my shifted  data down
        or      edx,ecx                    ; Merge with leftover
        mov     dword ptr [_bltADAT],edx   ; Store data from A
        jmp     blitexfill2a

; DMA A off
blitexfill2:
        mov     edx,dword ptr _bltadatoriginal
        shl     edx,16
        cmp     esi,dword ptr _linelength  ; Do first word masking
        jne     befd
	and     edx,dword ptr [_bltAFWM]
befd:
        cmp     esi,1                      ; Do last word masking+ modulo
        jne     beff
	mov     ebx,dword ptr [_bltAMOD]          ; BLTMOD oppdateres DESC
        add     ecx,ebx
        and     edx,dword ptr [_bltALWM]   ; Mask is mirrored in lo/hi word
beff:
        mov     ecx,eax                    ; Move saved bltcon to ecx
        shr     ecx,28                     ; Exctract shift for A

        test    eax,2        ; Test desc mode
        jz      befdesc1
        rol     edx,cl                     ; Rotate to left in desc mode
        jmp     befdesc2
befdesc1:
        shr     edx,cl                     ; Shift to right in forward mode
befdesc2:


        mov     ecx,dword ptr leftoverA    ; get last leftover
        mov     dword ptr leftoverA,edx    ; Store leftover from A
        shr     edx,16                     ; Move my shifted  data down
        or      edx,ecx                    ; Merge with leftover
        mov     dword ptr [_bltADAT],edx   ; Store data from A


blitexfill2a:


        test    eax,04000000h              ; Test dma B
        jz      blitexfill3
	mov     ecx,dword ptr [_bltBpt]
	mov     edx,dword ptr [_cmem-2+ecx]
        bswap   edx                        ; My data in lo word
        cmp     esi,1                      ; Do modulo if last word on line 
        jne     blitexfillg
        mov     ebx,dword ptr [_bltBMOD]   ; BLTBMOD
        add     ecx,ebx
blitexfillg:
        add     ecx,ebp                    ; Add ptB with +2 or -2
        and     ecx,01ffffeh               ; For safety
        mov     dword ptr [_bltBpt],ecx    ; Save ptB
        mov     ecx,eax                    ; Extract shift for B
	shr     ecx,12
        and     ecx,0fh
        shl     edx,16                     ; Move my data up, lo is clean

        test    eax,2                      ; Rotate or shift
        jz      blitexnofdesc3
        rol     edx,cl
        jmp     blitexnofdesc4
blitexnofdesc3:
        shr     edx,cl
blitexnofdesc4:


        mov     ecx,dword ptr leftoverB    ; Old leftover
        mov     dword ptr leftoverB,edx    ; Store leftover from B
        shr     edx,16                     ; Move rest of data down
        or      edx,ecx                    ; Merge with leftover
        mov     dword ptr [_bltBDAT],edx   ; Store data from B

blitexfill3:

blitexfill3a:
	test    eax,02000000h                       ; Test dma C
        jz      blitexfill4
	mov     ecx,dword ptr [_bltCpt]
        mov     edx,dword ptr _cmem-2+ecx
        bswap   edx                            ; Move my data down
        cmp     esi,1                          ; last word??
        jne     blitexfillh
        mov     ebx,dword ptr _bltCMOD         ; BLTCMOD
        add     ecx,ebx
blitexfillh:
        add     ecx,ebp
        and     ecx,01ffffeh
	mov     dword ptr [_bltCpt],ecx
	mov     dword ptr [_bltCDAT],edx           ; Store data from C

; Now the data lies in BLTXDAT registers
blitexfill4:

        push    eax
        mov     edx,dword ptr _bltcdat
        mov     ecx,dword ptr _bltbdat
	mov     ebx,dword ptr _bltadat
        call    dword ptr [_bltminterm]

        mov     edx,eax
        pop     eax
        and     edx,0ffffh

; Now we have the result
; Do fill

        test    eax,4                   ; test if FC bit is set
        jnz     blitexafc1
        mov     bx,word ptr _fillexcfc0[edx*2] ; Get inc,fc0
        mov     dl,byte ptr _fillexcfc0after[edx] ; get fc bit after
        jmp     blitexfillafter
blitexafc1:
        mov     bx,word ptr _fillexcfc1[edx*2] ; Get inc,fc0
        mov     dl,byte ptr _fillexcfc1after[edx] ; get fc bit after
blitexfillafter:
        shl     dl,2            ; Inject FC bit into saved bltcon
	and     al,0fbh
	or      al,dl
	mov     byte ptr bltfillbltconsave,al


	mov     eax,dword ptr bltfillbltconsave

	mov     ecx,dword ptr [_bltDpt]
        mov     byte ptr _cmem+ecx,bh
        mov     byte ptr _cmem+1+ecx,bl
        add     ecx,ebp
	cmp     esi,1
        jne     blitexfillj
	mov     ebx,dword ptr [_bltDMOD]
        add     ecx,ebx
blitexfillj:
        and     ecx,01ffffeh
        mov     dword ptr [_bltDpt],ecx
blitexfilli:
	dec     esi
        jnz     blitexfillword
	dec     dword ptr _linecount
        jnz     blitterexfillline
        jmp     blitterfillend



; Fill routine optimized for AD
ADblitterfillline:
        mov     eax,dword ptr _bltcon
	mov     dword ptr bltfillbltconsave,eax
        test    eax,8
        jz      ADblitterfillexclusive

ADblitterincfillline:
	mov     esi,dword ptr _linelength
	mov     eax,dword ptr _bltcon
	mov     dword ptr bltfillbltconsave,eax
	mov     ebp,dword ptr _bltdesc
ADblitterincfillword:
ADblitincfill1:
	mov     ecx,dword ptr [_bltApt]
	mov     edx,dword ptr [_cmem+ecx]  ;[_cmem-2+ecx]
        bswap   edx                     ; My word is now in bits 31-16

        cmp     esi,dword ptr _linelength  ; Do first word masking
        jne     ADblitincfilld
	and     edx,dword ptr [_bltAFWM]
ADblitincfilld:
        cmp     esi,1                      ; Do last word masking+ modulo
        jne     ADblitincfillf
	mov     ebx,dword ptr [_bltAMOD]          ; BLTMOD oppdateres DESC
        add     ecx,ebx
        and     edx,dword ptr [_bltALWM]   ; Mask is mirrored in lo/hi word
ADblitincfillf:
        add     ecx,ebp                    ; Add +2 or -2 to ptA
        and     edx,0ffff0000h             ; Take away garbage
        and     ecx,01ffffeh               ; For safety
        mov     dword ptr [_bltApt],ecx
        mov     ecx,eax                    ; Move saved bltcon to ecx
        shr     ecx,28                     ; Exctract shift for A

        test    eax,2        ; Test desc mode
        jz      ADblitincnofdesc1
        rol     edx,cl                     ; Rotate to left in desc mode
        jmp     ADblitincnofdesc2
ADblitincnofdesc1:
        shr     edx,cl                     ; Shift to right in forward mode
ADblitincnofdesc2:


        mov     ecx,dword ptr leftoverA    ; get last leftover
        mov     dword ptr leftoverA,edx    ; Store leftover from A
        shr     edx,16                     ; Move my shifted  data down
        or      edx,ecx                    ; Merge with leftover
        mov     dword ptr [_bltADAT],edx   ; Store data from A

ADblitincfill2:

; Now the data lies in BLTXDAT registers
ADblitincfill4:

        push    eax
	mov     edx,dword ptr _bltcdat
        mov     ecx,dword ptr _bltbdat
	mov     ebx,dword ptr _bltadat
        call    dword ptr [_bltminterm]
        mov     edx,eax
        pop     eax
        and     edx,0ffffh

; Now we have the result


        test    eax,4                   ; test if FC bit is set
        jnz     ADblitincafc1
	mov     bx,word ptr _fillincfc0[edx*2] ; Get inc,fc0
	mov     dl,byte ptr _fillincfc0after[edx] ; get fc bit after
        jmp     ADblitincfillafter
ADblitincafc1:
	mov     bx,word ptr _fillincfc1[edx*2] ; Get inc,fc0
	mov     dl,byte ptr _fillincfc1after[edx] ; get fc bit after
ADblitincfillafter:
        shl     dl,2            ; Inject FC bit into saved bltcon
	and     al,0fbh
	or      al,dl
	mov     byte ptr bltfillbltconsave,al


	mov     eax,dword ptr bltfillbltconsave

	mov     ecx,dword ptr [_bltDpt]
        mov     byte ptr _cmem+ecx,bh
        mov     byte ptr _cmem+1+ecx,bl
        add     ecx,ebp
        and     ecx,01ffffeh
        mov     dword ptr [_bltDpt],ecx
ADblitincfilli:
	dec     esi
        jnz     ADblitterincfillword
	mov     ebx,dword ptr [_bltDMOD]
        add     ecx,ebx
        and     ecx,01ffffeh
        mov     dword ptr [_bltDpt],ecx

        dec     dword ptr _linecount
        jnz     ADblitterincfillline
        jmp     blitterfillend


ADblitterfillexclusive:
ADblitterexcfillline:
	mov     esi,dword ptr _linelength
	mov     eax,dword ptr _bltcon
	mov     dword ptr bltfillbltconsave,eax
	mov     ebp,dword ptr _bltdesc
ADblitterexcfillword:
ADblitexcfill1:
	mov     ecx,dword ptr [_bltApt]
	mov     edx,dword ptr [_cmem+ecx]  ;[_cmem-2+ecx]
        bswap   edx                     ; My word is now in bits 31-16

        cmp     esi,dword ptr _linelength  ; Do first word masking
        jne     ADblitexcfilld
	and     edx,dword ptr [_bltAFWM]
ADblitexcfilld:
        cmp     esi,1                      ; Do last word masking+ modulo
        jne     ADblitexcfillf
	mov     ebx,dword ptr [_bltAMOD]          ; BLTMOD oppdateres DESC
        add     ecx,ebx
        and     edx,dword ptr [_bltALWM]   ; Mask is mirrored in lo/hi word
ADblitexcfillf:
        add     ecx,ebp                    ; Add +2 or -2 to ptA
        and     edx,0ffff0000h             ; Take away garbage
        and     ecx,01ffffeh               ; For safety
        mov     dword ptr [_bltApt],ecx
        mov     ecx,eax                    ; Move saved bltcon to ecx
        shr     ecx,28                     ; Exctract shift for A

        test    eax,2        ; Test desc mode
        jz      ADblitexcnofdesc1
        rol     edx,cl                     ; Rotate to left in desc mode
        jmp     ADblitexcnofdesc2
ADblitexcnofdesc1:
        shr     edx,cl                     ; Shift to right in forward mode
ADblitexcnofdesc2:


        mov     ecx,dword ptr leftoverA    ; get last leftover
        mov     dword ptr leftoverA,edx    ; Store leftover from A
        shr     edx,16                     ; Move my shifted  data down
        or      edx,ecx                    ; Merge with leftover
        mov     dword ptr [_bltADAT],edx   ; Store data from A

ADblitexcfill2:

; Now the data lies in BLTXDAT registers
ADblitexcfill4:

        push    eax
	mov     edx,dword ptr _bltcdat
	mov     ecx,dword ptr _bltbdat
	mov     ebx,dword ptr _bltadat
        call    dword ptr [_bltminterm]

        mov     edx,eax
        pop     eax
        and     edx,0ffffh

; Now we have the result


        test    eax,4                   ; test if FC bit is set
        jnz     ADblitexcafc1
        mov     bx,word ptr _fillexcfc0[edx*2] ; Get exc,fc0
        mov     dl,byte ptr _fillexcfc0after[edx] ; get fc bit after
        jmp     ADblitexcfillafter
ADblitexcafc1:
        mov     bx,word ptr _fillexcfc1[edx*2] ; Get exc,fc0
        mov     dl,byte ptr _fillexcfc1after[edx] ; get fc bit after
ADblitexcfillafter:
        shl     dl,2            ; Inject FC bit into saved bltcon
	and     al,0fbh
	or      al,dl
	mov     byte ptr bltfillbltconsave,al


	mov     eax,dword ptr bltfillbltconsave

	mov     ecx,dword ptr [_bltDpt]
        mov     byte ptr _cmem+ecx,bh
        mov     byte ptr _cmem+1+ecx,bl
        add     ecx,ebp
        and     ecx,01ffffeh
        mov     dword ptr [_bltDpt],ecx
ADblitexcfilli:
	dec     esi
        jnz     ADblitterexcfillword
	mov     ebx,dword ptr [_bltDMOD]
        add     ecx,ebx
        and     ecx,01ffffeh
        mov     dword ptr [_bltDpt],ecx

        dec     dword ptr _linecount
        jnz     ADblitterexcfillline



blitterfillend:

; restore blitter registers

        test    dword ptr _bltcon,008000000h
        jz      bliend1
        mov     edx,dword ptr _bltadatoriginal
        mov     dword ptr _bltadat,edx
bliend1:
        mov     edx,08040h
	mov     ecx,0dff09ch
	call    wriw

	ret








; ===========================================
; Blitter COPY
; ===========================================

; -------------------------------------------------------------------------------------
; Do one line of blitter copy operation
; Not LINEMODE!  Stupid labelname.
; This is the general routine that is called in case there isn't an optimized routine.
; -------------------------------------------------------------------------------------
blitter_normal:

blitterline:
	mov     esi,dword ptr _linelength
	mov     ebp,dword ptr _bltdesc
blitterword:
	mov     eax,dword ptr _bltcon
blit1:
	test    eax,01000000h
	jz      bliti
	test    eax,08000000h                       ; Test dma A
	jz      blit2
	mov     ecx,dword ptr [_bltApt]
	mov     edx,dword ptr [_cmem+ecx]  ;[_cmem-2+ecx]
	bswap   edx

        cmp     esi,dword ptr _linelength
        jne     blitd
        and     edx,dword ptr [_bltAFWM]
blitd:  cmp     esi,1
	jne     blitf
	mov     ebx,dword ptr [_bltAMOD]          ; BLTMOD oppdateres DESC
	add     ecx,ebx
	and     edx,dword ptr [_bltALWM]
blitf:  add     ecx,ebp
	and     edx,0ffff0000h
	mov     dword ptr [_bltApt],ecx
	mov     ecx,eax
	shr     ecx,28
        test    eax,2
        jz      nodesc1
        rol     edx,cl
        jmp     nodesc2
nodesc1:
        shr     edx,cl
nodesc2:
	mov     ecx,dword ptr leftoverA
	mov     dword ptr leftoverA,edx         ; Store leftover from A
	shr     edx,16
	or      edx,ecx                         ; Merge leftover

        and     edx,0ffffh
	mov     dword ptr [_bltADAT],edx           ; Store data from A
        jmp     blit90
blit2:

        mov     edx,dword ptr _bltadatoriginal
        shl     edx,16
        cmp     esi,dword ptr _linelength  ; Do first word masking
        jne     bnorbd
	and     edx,dword ptr [_bltAFWM]
bnorbd:
        cmp     esi,1                      ; Do last word masking+ modulo
        jne     bnorbf
	mov     ebx,dword ptr [_bltAMOD]          ; BLTMOD oppdateres DESC
        add     ecx,ebx
        and     edx,dword ptr [_bltALWM]   ; Mask is mirrored in lo/hi word
bnorbf:
        mov     ecx,eax                    ; Move saved bltcon to ecx
        shr     ecx,28                     ; Exctract shift for A

        test    eax,2        ; Test desc mode
        jz      bnordesc1
        rol     edx,cl                     ; Rotate to left in desc mode
        jmp     bnordesc2
bnordesc1:
        shr     edx,cl                     ; Shift to right in forward mode
bnordesc2:


        mov     ecx,dword ptr leftoverA    ; get last leftover
        mov     dword ptr leftoverA,edx    ; Store leftover from A
        shr     edx,16                     ; Move my shifted  data down
        or      edx,ecx                    ; Merge with leftover
        mov     dword ptr [_bltADAT],edx   ; Store data from A


blit90:
	test    eax,04000000h                       ; Test dma B
	jz      blit3
	mov     ecx,dword ptr [_bltBpt]
        mov     edx,dword ptr [_cmem+ecx]
	bswap   edx
	cmp     esi,1                           ; Siste ord??
	jne     blitg
	mov     ebx,dword ptr [_bltBMOD]        ; BLTMOD oppdateres DESC
	add     ecx,ebx
blitg:  add     ecx,ebp
	mov     dword ptr [_bltBpt],ecx
	mov     ecx,eax
	shr     ecx,12
        and     ecx,0fh 
        and     edx,0ffff0000h
        test    eax,2
        jz      nodesc3
        rol     edx,cl
        jmp     nodesc4
nodesc3:
	shr     edx,cl
nodesc4:
	mov     ecx,dword ptr leftoverB
	mov     dword ptr leftoverB,edx         ; Store leftover from B
	shr     edx,16
	or      edx,ecx
        and     edx,0ffffh
        mov     dword ptr [_bltBDAT],edx           ; Store data from B
blit3:

blit80:
	test    eax,02000000h                       ; Test dma C
	jz      blit4
	mov     ecx,dword ptr [_bltCpt]
	mov     edx,dword ptr _cmem-2+ecx
	bswap   edx
	cmp     esi,1                           ; Siste ord??
	jne     blith
	mov     ebx,dword ptr _bltCMOD         ; BLTMOD oppdateres DESC
	add     ecx,ebx
blith:  add     ecx,ebp
	mov     dword ptr [_bltCpt],ecx
        and     edx,0ffffh
	mov     dword ptr [_bltCDAT],edx           ; Store data from C

; Now the data lies in BLTXDAT registers
blit4:
	mov     edx,dword ptr _bltcdat
	mov     ecx,dword ptr _bltbdat
	mov     ebx,dword ptr _bltadat
        call    dword ptr [_bltminterm]


; Now we have the result

        

	mov     ecx,dword ptr [_bltDpt]

        mov     byte ptr _cmem+ecx,ah
        mov     byte ptr _cmem+1+ecx,al
	add     ecx,ebp
	cmp     esi,1
	jne     blitj
	mov     ebx,dword ptr [_bltDMOD]
	add     ecx,ebx
blitj:  mov     dword ptr [_bltDpt],ecx
bliti:  dec     esi
	jnz     blitterword
	dec     dword ptr _linecount
	jnz     blitterline



; restore blitter registers

        test    dword ptr _bltcon,008000000h
        jz      bliend3
        mov     edx,dword ptr _bltadatoriginal
        mov     dword ptr _bltadat,edx
bliend3:
        test    dword ptr _bltcon,004000000h
        jz      bliend4
        mov     edx,dword ptr _bltbdatoriginal
        mov     dword ptr _bltbdat,edx
bliend4:


        mov     edx,08040h
	mov     ecx,0dff09ch
	call    wriw

	ret


; ------------------------------------------
; Do one line of blitter operation
; Optimized for AD
; Doesn't accept decending mode
; ------------------------------------------
ADblitterline:        
	mov     esi,dword ptr _linelength
	mov     ebp,dword ptr _bltdesc
ADblitterword:
	mov     eax,dword ptr _bltcon
	mov     ecx,dword ptr [_bltApt]
        mov     edx,dword ptr [_cmem+ecx]  ;[_cmem-2+ecx]
	bswap   edx
	cmp     esi,dword ptr _linelength
	jne     ADblitd
	and     edx,dword ptr [_bltAFWM]
ADblitd:cmp     esi,1                            ; Last word in line
        jne     ADblitf                          ; so
        mov     ebx,dword ptr [_bltAMOD]         ; add modulo
	add     ecx,ebx
	and     edx,dword ptr [_bltALWM]
ADblitf:
        add     ecx,ebp
ADblargh2:
	and     edx,0ffff0000h
	mov     dword ptr [_bltApt],ecx
	mov     ecx,eax
	shr     ecx,28
        test    eax,2
        jz      nodesc5
        rol     edx,cl
        jmp     nodesc6
nodesc5:
	shr     edx,cl
nodesc6:
	mov     ecx,dword ptr leftoverA
	mov     dword ptr leftoverA,edx         ; Store leftover from A
	shr     edx,16
	or      edx,ecx                         ; Merge leftover
	mov     dword ptr [_bltADAT],edx           ; Store data from A

; Now the data lies in BLTXDAT registers

	mov     edx,dword ptr _bltcdat
	mov     ecx,dword ptr _bltbdat
	mov     ebx,dword ptr _bltadat
        call    dword ptr [_bltminterm] ; Do logic


; Now we have the result
	mov     ecx,dword ptr [_bltDpt]

ADblargh3:
        mov     byte ptr _cmem+ecx,ah
        mov     byte ptr _cmem+1+ecx,al
        add     ecx,ebp
ADblargh4:
	cmp     esi,1
	jne     ADblitj
	mov     ebx,dword ptr [_bltDMOD]
	add     ecx,ebx
ADblitj:mov     dword ptr [_bltDpt],ecx
ADbliti:dec     esi
	jnz     ADblitterword
	dec     dword ptr _linecount
	jnz     ADblitterline
        mov     edx,08040h
	mov     ecx,0dff09ch
	call    wriw

	ret

; ---------------------------------------
; Do one line of blitter operation
; Optimized for D, maybe a little too optimized.....:-)
; ---------------------------------------

Dblitterline:

	
	mov     edx,dword ptr _bltcdat
	mov     ecx,dword ptr _bltbdat
	mov     ebx,dword ptr _bltadat
        call    dword ptr [_bltminterm] ; Do logic

        bswap   eax
        shr     eax,16
		
	mov     ecx,dword ptr [_bltDpt]
	mov     ebx,dword ptr [_bltDMOD]
	mov     ebp,dword ptr _bltdesc
Dblitterline2:
	mov     esi,dword ptr _linelength
	
Dblitterword:
Dblit1:
Dblargh2:
        mov     word ptr _cmem+ecx,ax
        add     ecx,ebp         ; Add 2 BLTDPT,
Dblargh:
	dec     esi
        jnz     Dblitterword    ; Do another word

	add     ecx,ebx
	dec     dword ptr _linecount
	jnz     Dblitterline2
	mov     dword ptr _bltDpt,ecx


        mov     edx,08040h
	mov     ecx,0dff09ch
	call    wriw

	ret

; ===========================================================
; Blitter COPY ENDS
; ===========================================================


; ========================================================
; Blitter logic functions
; ========================================================

; -----------------------------------
; The general blitter logic function
; Takes A in ebx, B in ecx and C in edx
; Result in eax 
; -----------------------------------

blittergeneral_:
        push    ebp
        push    edi
        xor     ebp,ebp
        mov     edi,dword ptr _bltcon
        xor     eax,eax
        test    edi,00800000h                           ; Minterm ABC
	jz      blit5
	mov     ebp,ebx
	and     ebp,ecx
	and     ebp,edx
        or      eax,ebp
blit5:  not     edx                             ; minterm ABc
        test    edi,00400000h                           
	jz      blit6
	mov     ebp,ebx
	and     ebp,ecx
	and     ebp,edx
        or      eax,ebp
blit6:  not     edx                             ; minterm AbC
	not     ecx
        test    edi,00200000h                           
	jz      blit7
	mov     ebp,ebx
	and     ebp,ecx
	and     ebp,edx
        or      eax,ebp
blit7:  not     edx                             ; minterm Abc
        test    edi,00100000h                           
	jz      blit8
	mov     ebp,ebx
	and     ebp,ecx
	and     ebp,edx
        or      eax,ebp
blit8:  not     edx                             ; minterm aBC
	not     ecx
	not     ebx
        test    edi,00080000h
	jz      blit9
	mov     ebp,ebx
	and     ebp,ecx
	and     ebp,edx
        or      eax,ebp
blit9:  not     edx                             ; minterm aBc
        test    edi,00040000h
	jz      blita
	mov     ebp,ebx
	and     ebp,ecx
	and     ebp,edx
        or      eax,ebp
blita:  not     edx                             ; minterm abC
	not     ecx
        test    edi,00020000h
	jz      blitb
	mov     ebp,ebx
	and     ebp,ecx
	and     ebp,edx
        or      eax,ebp
blitb:  not     edx                             ; minterm abc
        test    edi,00010000h
	jz      blitcc
	mov     ebp,ebx
	and     ebp,ecx
	and     ebp,edx
        or      eax,ebp
blitcc:
        not     ebx
        not     ecx
        not     edx
        pop     edi
        pop     ebp
        ret


; -------------------------------------------------
; Optimized logic functions for some common cases
; Must not destroy the parameters
; in:  A - ebx   B - ecx  C - edx
; out: D - eax 
; -------------------------------------------------

; 0
blitter_00_:
        xor     eax,eax
        ret

; !(A+B+C)
blitter_01_:
        mov     eax,ebx
        or      eax,ecx
        or      eax,edx
        not     eax
        ret

; abC
blitter_02_:
        not     ebx
        mov     eax,edx
        not     ecx
        and     eax,ebx
        not     ebx
        and     eax,ecx
        not     ecx
        ret

; !(A+B)
blitter_03_:
        mov     eax,ebx
        or      eax,ecx
        not     eax
        ret

; aBc
blitter_04_:
        not     ebx
        mov     eax,ecx
        not     edx
        and     eax,ebx
        not     ebx
        and     eax,edx
        not     edx
        ret
; !(A+C)
blitter_05_:
        mov     eax,edx
        or      eax,ebx
        not     eax
        ret

; a(B xor C)
blitter_06_:
        mov     eax,ebx
        xor     ecx,edx
        not     eax
        and     eax,ecx
        xor     ecx,edx
        ret

; !(A+BC)
blitter_07_:
        mov     eax,ecx
        and     eax,edx
        or      eax,ebx
        not     eax
        ret

; aBC
blitter_08_:
        not     ebx
        mov     eax,edx
        and     eax,ebx
        not     ebx
        and     eax,ecx
        ret      

; !(A+(B xor C))
blitter_09_:
        mov     eax,ecx
        xor     eax,edx
        or      eax,ebx
        not     eax
        ret

; Ca
blitter_0a_:
        mov     eax,ebx
        not     eax
        and     eax,edx
        ret

; !(B+C) + Ca
blitter_0b_:
        push    ebx
        mov     eax,edx
        or      eax,ecx
        not     eax
        not     ebx
        and     ebx,edx
        or      eax,ebx
        pop     ebx
        ret

; Ba
blitter_0c_:
        mov     eax,ebx
        not     eax
        and     eax,ecx
        ret

; !(A+(bC))
blitter_0d_:
        mov     eax,ecx
        not     eax
        and     eax,edx
        or      eax,ebx
        not     eax
        ret

; a(B+C)
blitter_0e_:
        mov     eax,ecx
        not     ebx
        or      eax,edx
        and     eax,ebx
        not     ebx
        ret

; a
blitter_0f_:
        mov     eax,ebx
        not     eax
        ret



; (!AB)C
blitter_2a_:
        mov     eax,ebx
        and     eax,ecx
        not     eax
        and     eax,edx
        ret

; aC + ABc
blitter_4a_:
        push    edx
        mov     eax,ebx
        not     eax
        and     eax,edx
        not     edx
        and     edx,ebx
        and     edx,ecx
        or      eax,edx
        pop     edx
        ret

; AB + aC
blitter_ca_:
        push    ebx
        mov     eax,ebx
	not	ebx
        and     eax,ecx
        and	ebx,edx
        or      eax,ebx
        pop     ebx
	ret
		
; Ac + BC
blitter_d8_:
        push    ebx
        mov     eax,edx
	not	edx
        and     eax,ecx
	and	ebx,edx
        or      eax,ebx
        not     edx
        pop     ebx
	ret

; AB+aC+AbC
blitter_ea_:
        push    ecx
        push    ebx
        mov     eax,ebx
        and     eax,ecx
        not     ecx
        and     ecx,ebx
        and     ecx,edx
        not     ebx
        and     ebx,edx
        or      eax,ebx
        or      eax,ecx
        pop     ebx
        pop     ecx
        ret

;A
blitter_f0_:
        mov     eax,ebx
	ret

; C + A
blitter_fa_:
        mov     eax,ebx
        or      eax,edx
        ret

;A + aB
blitter_fc_:
        mov     eax,ebx
        not     eax
        and     eax,ecx
        or      eax,ebx
	ret

; 1
blitter_ff_:
        mov     eax,-1
        ret


; ============================================================================
; Blitter logic ENDS
; ============================================================================

public dump_speedbuffer_
dump_speedbuffer_:
        mov     ebx,dword ptr _config_graphics_mode
        mov     ecx,dword ptr _drawbuffer
        mov     eax,dword ptr _framebuffer
        add     eax,dword ptr _bufferoffsets[4*ecx]
        test    ebx,ebx
        jne     dump320
        
        add     eax,1536+1600
        add     eax,[_scanlineadd]
        mov     edi,1568
        jmp     dodump
dump320:
        cmp     ebx,3
        jae     dump640
        add     eax,608
        mov     edi,608
        jmp     dodump
dump640:
        cmp     ebx,6
        je      dump320b
        add     eax,1248
        mov     edi,1248
        jmp     dodump
dump320b:
        add     eax,304
        mov     edi,304

dodumpb:
        mov     esi,offset _speedbuffer
        mov     ch,05h
dumploop2b:
        mov     cl,08h
dumploopb:
        mov     edx,[esi]
        test    dx,dx
        jz      dumploop3b
        mov     dx,251
dumploop3b:
        test    edx,0ffff0000h
        jz      dumploop3c
        mov     dh,251
dumploop3c:
        mov     [eax],dx
        add     esi,4
        add     eax,2
        dec     cl
        jnz     dumploopb
        add     eax,edi
        add     eax,_scanlineadd
        dec     ch
        jnz     dumploop2b
        ret


        jmp     dodump

dodump:
        mov     esi,offset _speedbuffer
        mov     ch,05h
dumploop2:
        mov     cl,04h
dumploop:
        mov     edx,[esi]
        mov     [eax],edx
        mov     edx,4[esi]
        mov     4[eax],edx
        add     esi,8
        add     eax,8
        dec     cl
        jnz     dumploop
        add     eax,edi
        add     eax,_scanlineadd
        dec     ch
        jnz     dumploop2
        ret




_TEXT ends

_DATA segment dword public 'DATA'



include data\fellow.inc
include data\memory.inc
include data\inout.inc
include data\chip.inc
include data\sound.inc
include data\floppy.inc
include data\graphem.inc

; From cc.c
;------------------

extrn _bltdesc:near
extrn _ypos:near
extrn _xpos:near
extrn _delay:near
extrn _nxtcopaccess:near
extrn _thiscycle:near
extrn _curcycle:near
extrn _curcopptr:near
extrn _blitterdmawaiting:near

leftoverA: dd 0
leftoverB: dd 0
blitcycletab:   dd      0               ; 0000
		dd      4               ; 0001
		dd      4               ; 0010
		dd      8               ; 0011
		dd      4               ; 0100
		dd      8               ; 0101
		dd      8               ; 0110
		dd      12              ; 0111
		dd      4               ; 1000
		dd      8               ; 1001
		dd      8               ; 1010
		dd      12              ; 1011
		dd      8               ; 1100
		dd      12              ; 1101
		dd      12              ; 1110
		dd      16              ; 1111

xposa   dd      0                  ; Brukes som variabel i bpdma
timerscheduler: dd      0
_timeout:        dd      0

_here:  dd 0


bitplanes: dd 0




frameskip: dd 0
public _here

extrn _decoderoutineptr:near
extrn _drawroutineptr:near

extrn _blittertable:near

blittermodes:
	dd      blitterline             ; none

        dd      Dblitterline            ; D

	dd      blitterline             ; C
	dd      blitterline             ; CD
	dd      blitterline             ; B
	dd      blitterline             ; BD
	dd      blitterline             ; BC
	dd      blitterline             ; BCD
	dd      blitterline             ; A

        dd      ADblitterline             ; AD



	dd      blitterline             ; AC
	dd      blitterline             ; ACD
	dd      blitterline             ; AB
	dd      blitterline             ; ABD
	dd      blitterline             ; ABC
	dd      blitterline             ; ABCD

blitterfillmodes:
        dd      blitterfillline             ; none
        dd      blitterfillline            ; D
        dd      blitterfillline             ; C
        dd      blitterfillline             ; CD
        dd      blitterfillline             ; B
        dd      blitterfillline             ; BD
        dd      blitterfillline             ; BC
        dd      blitterfillline             ; BCD
        dd      blitterfillline             ; A

        dd      ADblitterfillline             ; AD

        dd      blitterfillline             ; AC
        dd      blitterfillline             ; ACD
        dd      blitterfillline             ; AB
        dd      blitterfillline             ; ABD
        dd      blitterfillline             ; ABC
        dd      blitterfillline             ; ABCD




bltlineheight:          dd      0
_bltlinepointflag:        dd      0
bltfillbltconsave:      dd      0

bltlinesudsulaul:
	dd      offset blitterlinemodeoctant0
	dd      offset blitterlinemodeoctant1
	dd      offset blitterlinemodeoctant2
	dd      offset blitterlinemodeoctant3
	dd      offset blitterlinemodeoctant4
	dd      offset blitterlinemodeoctant5
	dd      offset blitterlinemodeoctant6
	dd      offset blitterlinemodeoctant7


extrn _fillincfc0:near
extrn _fillincfc1:near
extrn _fillexcfc0:near
extrn _fillexcfc1:near
extrn _fillincfc0after:near
extrn _fillincfc1after:near
extrn _fillexcfc0after:near
extrn _fillexcfc1after:near


dualbuf1:       dd      0
dualbuf2:       dd      0



_firstwordinblit: dd 0



extrn _debugging:near

extrn _copperytable:near



extrn _bltminterm:near


decodetmp2: dd 0


dualspecial: dd 0

extrn _bufferoffsets:dword
extrn _drawbuffer:dword
extrn _showbuffer:dword

extrn _lineflagstimes:byte


extrn _decosc01:dword
extrn _decosc02:dword
extrn _decosc03:dword
extrn _decosc04:dword
extrn _decosc11:dword
extrn _decosc12:dword
extrn _decosc21:dword
extrn _decosc22:dword
extrn _decosc31:dword
extrn _decosc32:dword




_bltadatoriginal: dd 0

_bltadatfirstfwm: dd 0
_bltadatfirstfwmlwm: dd 0
_bltadatrotate: dd 0
_bltadatrotatefwm: dd 0
_bltadatrotatelwm: dd 0
_bltadatrotatefwmlwm: dd 0

_bltbdatoriginal: dd 0
_bltbdatfirst: dd 0
_bltbdatrotate: dd 0
_bltbdatline: dd 0

public _bltadatoriginal
public _bltbdatoriginal

extern _configdoublebuffer:dword

extern _clipleftx:dword
extern _cliprightx:dword
extern _cliptop:dword
extern _clipbot:dword



dummydecodetable:       dd      offset  ddec0
                        dd      offset  ddec1
                        dd      offset  ddec2
                        dd      offset  ddec3
                        dd      offset  ddec4
                        dd      offset  ddec5
                        dd      offset  ddec6
                        dd      offset  ddec6


extern _config_graphics_mode:dword
extern _speedbuffer:dword

extern _decodetmp:dword

_DATA ends

_BSS segment dword public 'DATA'
_BSS ends

end

