        .586p
DGROUP group _DATA,_BSS
_TEXT  segment dword public use32 'CODE'
       assume cs:_TEXT, ds:DGROUP, ss:DGROUP

; Petter Schau 1997
; Assembler routines for drawing to VGA-memory
; Might be replaced by equivalent C-routines with USE_C

include defs.inc

#ifdef USE_ASM

;--------------------------------
; Width: hires (640/800)
;--------------------------------

; ebx - number of lores pixels to draw

                        align   4
public fillbg800w_
fillbg800w_:            mov     esi,[_screenptr]
                        mov     eax,[_shadcol]
                        cmp     ebx,4
                        jb      fbg1
fbg2:                   mov     [esi],eax
                        mov     4[esi],eax
                        mov     8[esi],eax
                        mov     12[esi],eax
                        add     esi,16
                        sub     ebx,4
                        cmp     ebx,4
                        jae     fbg2
fbg1:                   test    ebx,ebx
                        jz      fbg4
fbg3:                   mov     [esi],eax
                        add     esi,4
                        dec     ebx
                        jnz     fbg3
fbg4:                   mov     [_screenptr],esi
                        ret

                        align 4

public drawbglinepartial800w_
drawbglinepartial800w_:
                        pushad
                        cmp     dword ptr [_ypos],1ah
                        jb      dbgp800w
                        mov     ebx,dword ptr _xpos
                        and     ebx,0ffch
                        mov     ecx,dword ptr _drawpartialcycle
                        mov     dword ptr _drawpartialcycle,ebx
                        sub     ebx,ecx
                        jle     dbgp800w
                        shl     ebx,1
                        add     dword ptr _drawpartialpixels,ebx
                        call    fillbg800w_
dbgp800w:               popad
                        ret

                        align 4

public drawbglinepartialfinish800w_
drawbglinepartialfinish800w_:
                        mov     ebx,384
                        sub     ebx,dword ptr _drawpartialpixels
                        jle     dbgpf800w
                        call    fillbg800w_
dbgpf800w:              mov     ebx,dword ptr _scanlineadd
                        add     ebx,64
                        add     dword ptr _screenptr,ebx
                        popad
                        ret


                        align   4
public drawbgline800w_
drawbgline800w_:        pushad
                        mov     ebp,[_ypos]
                        cmp     ebp,1ah
                        jb      dbgexit
                        TSC_BEFORE _drawbgline800_tsctmp
                        test    dword ptr _drawpartialpixels,0xfff
                        jnz     drawbglinepartialfinish800w_
                        mov     ebx,[_shadcol]
                        mov     ecx,[_lineflags+4*ebp]
                        mov     edx,[_configdoublebuffer]
                        cmp     byte ptr [_config_graphics_flickerfree],1
                        jne     nodelace
                        mov     edx,2
nodelace:               cmp     ecx,ebx
                        jne     dbgnewcolor
                        mov     dl,[_lineflagstimes+ebp]
                        test    dl,dl
                        jz      dbgnodraw
                        dec     dl
dbgnewcolor:            mov     [_lineflags+4*ebp],ebx
                        mov     [_lineflagstimes+ebp],dl
                        mov     eax,[_screenptr]
                        mov     ebp,16
dbgloop:                mov     [eax],ebx
                        mov     4[eax],ebx
                        mov     8[eax],ebx
                        mov     12[eax],ebx
                        mov     16[eax],ebx
                        mov     20[eax],ebx
                        mov     24[eax],ebx
                        mov     28[eax],ebx
                        mov     32[eax],ebx
                        mov     36[eax],ebx
                        mov     40[eax],ebx
                        mov     44[eax],ebx
                        mov     48[eax],ebx
                        mov     52[eax],ebx
                        mov     56[eax],ebx
                        mov     60[eax],ebx
                        mov     64[eax],ebx
                        mov     68[eax],ebx
                        mov     72[eax],ebx
                        mov     76[eax],ebx
                        mov     80[eax],ebx
                        mov     84[eax],ebx
                        mov     88[eax],ebx
                        mov     92[eax],ebx
                        add     eax,96
                        dec     ebp
                        jnz     dbgloop
                        add     eax,64
                        add     eax,[_scanlineadd]
                        mov     [_screenptr],eax
                        TSC_AFTER _drawbgline800_tsctmp, _drawbgline800_tsc, _drawbgline800_tsctimes
dbgexit:                popad
                        ret
dbgnodraw:              mov     eax,[_scanlineadd]
                        add     eax,1600
                        add     [_screenptr],eax
                        TSC_AFTER _drawbgline800_tsctmp, _drawbgline800notdrawn_tsc, _drawbgline800notdrawn_tsctimes
                        popad
                        ret


                        align   4

public drawbgline800wmmx_
drawbgline800wmmx_:     pushad
                        mov     ebp,[_ypos]
                        cmp     ebp,1ah
                        jb      dbgexitmmx
                        TSC_BEFORE _drawbgline800_tsctmp
                        test    dword ptr _drawpartialpixels,0xfff
                        jnz     drawbglinepartialfinish800w_
                        mov     ebx,[_shadcol]
                        mov     ecx,[_lineflags+4*ebp]
                        mov     edx,[_configdoublebuffer]
                        cmp     byte ptr [_config_graphics_flickerfree],1
                        jne     nodelacemmx
                        mov     edx,2
nodelacemmx:            cmp     ecx,ebx
                        jne     dbgnewcolormmx
                        mov     dl,[_lineflagstimes+ebp]
                        test    dl,dl
                        jz      dbgnodraw
                        dec     dl
dbgnewcolormmx:         mov     [_lineflags+4*ebp],ebx
                        mov     [_lineflagstimes+ebp],dl
                        mov     eax,[_screenptr]
                        mov     ebp,16
                        movd    mm0,ebx
                        movd    mm1,ebx
                        psllq   mm1,32
                        por     mm0,mm1
dbgloopmmx:             movq    [eax],mm0
                        movq    8[eax],mm0
                        movq    16[eax],mm0
                        movq    24[eax],mm0
                        movq    32[eax],mm0
                        movq    40[eax],mm0
                        movq    48[eax],mm0
                        movq    56[eax],mm0
                        movq    64[eax],mm0
                        movq    72[eax],mm0
                        movq    80[eax],mm0
                        movq    88[eax],mm0
                        add     eax,96
                        dec     ebp
                        jnz     dbgloopmmx
                        add     eax,64
                        add     eax,[_scanlineadd]
                        mov     [_screenptr],eax
                        TSC_AFTER _drawbgline800_tsctmp, _drawbgline800_tsc, _drawbgline800_tsctimes
dbgexitmmx:             popad
                        ret


                        align   4

public drawlores800w_
drawlores800w_:
                        TSC_BEFORE _drawlores800_tsctmp

                        mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        mov     esi,[_screenptr]
                        sub     ebp,edi
                        jle     dlexit
                        xor     ebx,ebx
                        xor     eax,eax
                        xor     edx,edx
                        xor     ecx,ecx
                        test    esi,0fffffff8h          ; One pixel aligns
                        jz      drawlores800waligned
                        mov     al,byte ptr [_linje + edi]
                        mov     eax,dword ptr [_shadcol + eax]
                        inc     edi
                        mov     [esi],eax
                        add     esi,4
                        dec     ebp
                        xor     eax,eax
drawlores800waligned:   cmp     ebp,4
                        jl      dllastloop
dlloop:                 mov     ecx,[_linje+edi]
                        mov     al,ch
                        mov     bl,cl
                        mov     edx,[_shadcol+ebx]
                        mov     [esi],edx
                        mov     edx,[_shadcol+eax]
                        shr     ecx,16
                        mov     4[esi],edx
                        mov     bl,cl
                        mov     al,ch
                        mov     edx,[_shadcol+ebx]
                        mov     8[esi],edx
                        mov     edx,[_shadcol+eax]
                        mov     12[esi],edx
                        add     esi,16
                        sub     ebp,4
                        add     edi,4
                        cmp     ebp,4
                        jae     dlloop
                        test    ebp,ebp
                        jz      dlexit
dllastloop:             mov     bl,byte ptr [_linje+edi]
                        mov     edx,[_shadcol+ebx]
                        mov     [esi],edx
                        add     esi,4
                        inc     edi
                        dec     ebp
                        jnz     dllastloop
dlexit:                 mov     [_screenptr],esi
                        TSC_AFTER _drawlores800_tsctmp, _drawlores800_tsc, _drawlores800_tsctimes
                        ret


                        align   4

public drawlores800wmmx_
drawlores800wmmx_:
                        TSC_BEFORE _drawlores800_tsctmp
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        mov     esi,[_screenptr]
                        sub     ebp,edi
                        jle     dlexitmmx
                        xor     ebx,ebx
                        xor     eax,eax
                        xor     edx,edx
                        xor     ecx,ecx
                        test    esi,0fffffff8h          ; One pixel aligns
                        jz      drawlores800walignedmmx
                        mov     al,byte ptr [_linje + edi]
                        mov     eax,dword ptr [_shadcol + eax]
                        inc     edi
                        mov     [esi],eax
                        add     esi,4
                        dec     ebp
                        xor     eax,eax
drawlores800walignedmmx:cmp     ebp,4
                        jl      dllastloopmmx
dlloopmmx:              mov     al,byte ptr [_linje+edi]
                        mov     bl,byte ptr [_linje+1+edi]
                        mov     cl,byte ptr [_linje+2+edi]
                        mov     dl,byte ptr [_linje+3+edi]
                        movd    mm0,[_shadcol+eax]
                        movd    mm1,[_shadcol+ebx]
                        movd    mm2,[_shadcol+ecx]
                        movd    mm3,[_shadcol+edx]
                        psllq   mm1,32
                        psllq   mm3,32
                        por     mm0,mm1
                        por     mm2,mm3
                        movq    [esi],mm0
                        movq    8[esi],mm2
                        sub     ebp,4
                        add     edi,4
                        add     esi,16
                        cmp     ebp,4
                        jae     dlloopmmx
                        test    ebp,ebp
                        jz      dlexitmmx
dllastloopmmx:          mov     bl,byte ptr [_linje+edi]
                        mov     edx,[_shadcol+ebx]
                        mov     [esi],edx
                        add     esi,4
                        inc     edi
                        dec     ebp
                        jnz     dllastloopmmx
dlexitmmx:              mov     [_screenptr],esi
                        TSC_AFTER _drawlores800_tsctmp, _drawlores800_tsc, _drawlores800_tsctimes
                        ret


                        align   4

public drawhires800w_
drawhires800w_:
                        TSC_BEFORE _drawhires800_tsctmp
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        mov     esi,[_screenptr]
                        sub     ebp,edi
                        jle     dhexit
                        xor     eax,eax
                        xor     ebx,ebx
                        xor     ecx,ecx
                        xor     edx,edx
                        cmp     ebp,4
                        jl      dhlastloop
                        test    esi,06h                 ; align with one pix
                        jz      drawhires800waligned
drawhires800walign8:    mov     al,byte ptr [_linje + edi]
                        dec     ebp
                        mov     ebx,dword ptr [_shadcol + eax]
                        inc     edi
                        mov     [esi],bx
                        add     esi,2
                        test    esi,06h
                        jnz     drawhires800walign8
                        xor     ebx,ebx
drawhires800waligned:   cmp     ebp,4
                        jl      dhlastloop
dhloop:                 mov     ecx,[_linje+edi]
                        mov     bl,ch
                        mov     edx,[_shadcol+ebx]
                        mov     bl,cl
                        mov     dx,[_shadcol+ebx]
                        shr     ecx,16
                        mov     [esi],edx
                        mov     bl,ch
                        mov     edx,[_shadcol+ebx]
                        mov     bl,cl
                        mov     dx,[_shadcol+ebx]
                        mov     4[esi],edx
                        add     esi,8
                        sub     ebp,4
                        add     edi,4
                        cmp     ebp,4
                        jae     dhloop
                        test    ebp,ebp
                        jz      dhexit
dhlastloop:             mov     bl,byte ptr [_linje+edi]
                        mov     edx,[_shadcol+ebx]
                        mov     [esi],dx
                        add     esi,2
                        inc     edi
                        dec     ebp
                        jnz     dhlastloop
dhexit:                 mov     [_screenptr],esi
                        TSC_AFTER _drawhires800_tsctmp, _drawhires800_tsc, _drawhires800_tsctimes
                        ret


                        align   4

public drawhires800wmmx_
drawhires800wmmx_:
                        TSC_BEFORE _drawhires800_tsctmp
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        mov     esi,[_screenptr]
                        sub     ebp,edi
                        jle     dhexitmmx
                        xor     eax,eax
                        xor     ebx,ebx
                        xor     ecx,ecx
                        mov     edx,0ffffh
                        movd    mm4,edx
                        xor     edx,edx
                        cmp     ebp,4
                        jl      dhlastloopmmx
                        test    esi,06h                 ; align with one pix
                        jz      drawhires800walignedmmx
drawhires800walign8mmx: mov     al,byte ptr [_linje + edi]
                        dec     ebp
                        mov     ebx,dword ptr [_shadcol + eax]
                        inc     edi
                        mov     [esi],bx
                        add     esi,2
                        test    esi,06h
                        jnz     drawhires800walign8mmx
                        xor     ebx,ebx
drawhires800walignedmmx:cmp     ebp,4
                        jl      dhlastloopmmx
dhloopmmx:              mov     al,byte ptr [_linje + edi]
                        mov     bl,byte ptr [_linje + 1 + edi]
                        mov     cl,byte ptr [_linje + 2 + edi]
                        mov     dl,byte ptr [_linje + 3 + edi]
                        movd    mm0,[_shadcol + eax]
                        movd    mm1,[_shadcol + ebx]
                        movd    mm2,[_shadcol + ecx]
                        movd    mm3,[_shadcol + edx]
                        pand    mm2,mm4
                        pand    mm0,mm4
                        pslld   mm1,16
                        psllq   mm2,32
                        psllq   mm3,48
                        por     mm0,mm1
                        por     mm2,mm3
                        por     mm0,mm2
                        movq    [esi],mm0
                        sub     ebp,4
                        add     edi,4
                        add     esi,8
                        cmp     ebp,4
                        jae     dhloopmmx
                        test    ebp,ebp
                        jz      dhexitmmx
dhlastloopmmx:          mov     bl,byte ptr [_linje+edi]
                        mov     edx,[_shadcol+ebx]
                        mov     [esi],dx
                        add     esi,2
                        inc     edi
                        dec     ebp
                        jnz     dhlastloopmmx
dhexitmmx:              mov     [_screenptr],esi
                        TSC_AFTER _drawhires800_tsctmp, _drawhires800_tsc, _drawhires800_tsctimes
                        ret


                        align   4

public drawduallores800w_
drawduallores800w_:     mov     esi,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]
                        sub     ebp,eax
                        jle     ddlexit
                        lea     edi,[_dualtranslate]
                        test    byte ptr [_bplcon2],040h
                        jnz     ddlprinotset
                        add     edi,010000h
ddlprinotset:           xor     ebx,ebx
                        cmp     ebp,4
                        jl      ddllast
ddl:                    mov     ecx,[_linje+eax]
                        mov     edx,[_linje2+eax]
                        push    ebp
                        mov     bh,cl       
                        push    eax   
                        mov     bl,dl 
                        xor     eax,eax
                        mov     al,[edi+ebx] 
                        mov     ebp,[_shadcol+eax]     
                        mov     [esi],ebp       
                        mov     bh,ch                            
                        shr     ecx,16                          
                        mov     bl,dh                           
                        shr     edx,16                          
                        mov     al,[edi+ebx]           
                        mov     ebp,[_shadcol+eax]     
                        mov     4[esi],ebp             
                        mov     bh,cl
                        mov     bl,dl
                        mov     al,[edi+ebx]
                        mov     ebp,[_shadcol+eax]
                        mov     8[esi],ebp
                        mov     bh,ch
                        mov     bl,dh
                        mov     al,[edi+ebx]
                        mov     ebp,[_shadcol+eax]
                        mov     12[esi],ebp
                        pop     eax
                        pop     ebp
                        add     esi,16
                        sub     ebp,4
                        add     eax,4
                        cmp     ebp,4
                        jae     ddl
                        test    ebp,ebp
                        jz      ddlexit
ddllast:                xor     ecx,ecx
ddllastloop:            mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        inc     eax
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]
                        mov     [esi],edx
                        add     esi,4
                        dec     ebp
                        jnz     ddllastloop
ddlexit:                mov     [_screenptr],esi
                        ret


                        align   4

public drawduallores800wmmx_
drawduallores800wmmx_:  mov     esi,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]
                        sub     ebp,eax
                        jle     ddlexitmmx
                        lea     edi,[_dualtranslate]
                        test    byte ptr [_bplcon2],040h
                        jnz     ddlprinotsetmmx
                        add     edi,010000h
ddlprinotsetmmx:        xor     ebx,ebx
                        cmp     ebp,4
                        jl      ddllastmmx
                        mov     edx,0ffffffffh
                        movd    mm4,edx
                        xor     edx,edx
                        xor     ecx,ecx
                        xor     ebx,ebx
ddlmmx:                 mov     bh,byte ptr [_linje + eax]
                        mov     bl,byte ptr [_linje2 + eax]
                        mov     ch,byte ptr [_linje + 1 + eax]
                        mov     cl,byte ptr [_linje2 + 1 + eax]
                        mov     dl,[edi + ebx]
                        movd    mm0,[_shadcol + edx]
                        mov     dl,[edi + ecx]
                        movd    mm1,[_shadcol + edx]
                        pand    mm0,mm4
                        psllq   mm1,32
                        mov     bh,byte ptr [_linje + 2 + eax]
                        mov     bl,byte ptr [_linje2 + 2 + eax]
                        mov     ch,byte ptr [_linje + 3 + eax]
                        mov     cl,byte ptr [_linje2 + 3 + eax]
                        mov     dl,[edi + ebx]
                        movd    mm2,[_shadcol + edx]
                        mov     dl,[edi + ecx]
                        movd    mm3,[_shadcol + edx]
                        pand    mm2,mm4
                        psllq   mm3,32
                        por     mm0,mm1
                        por     mm2,mm3
                        movq    [esi],mm0
                        movq    [esi + 8],mm2
                        add     esi,16
                        sub     ebp,4
                        add     eax,4
                        cmp     ebp,4
                        jae     ddlmmx
                        test    ebp,ebp
                        jz      ddlexitmmx
ddllastmmx:             xor     ecx,ecx
ddllastloopmmx:         mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        inc     eax
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]
                        mov     [esi],edx
                        add     esi,4
                        dec     ebp
                        jnz     ddllastloopmmx
ddlexitmmx:             mov     [_screenptr],esi
                        ret


                        align   4

public drawdualhires800w_
drawdualhires800w_:    mov     esi,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     eax,[_DIWfirstvisiblepos]
                        sub     ebp,eax
                        jle     ddhexit
                        lea     edi,[_dualtranslate]
                        test    byte ptr [_bplcon2],040h
                        jnz     ddhprinotset
                        add     edi,010000h
ddhprinotset:           xor     ebx,ebx
                        cmp     ebp,4
                        jl      ddhlast
ddh:                    mov     ecx,[_linje+eax]
                        mov     edx,[_linje2+eax]
                        push    ebp
                        mov     bh,ch       
                        push    eax   
                        mov     bl,dh 
                        xor     eax,eax
                        mov     al,[edi+ebx] 
                        mov     ebp,[_shadcol+eax]     
                        mov     bh,cl                            
                        shr     ecx,16                          
                        mov     bl,dl                           
                        shr     edx,16                          
                        mov     al,[edi+ebx]           
                        mov     bp,[_shadcol+eax]     
                        mov     [esi],ebp             
                        mov     bh,ch
                        mov     bl,dh
                        mov     al,[edi+ebx]
                        mov     ebp,[_shadcol+eax]
                        mov     bh,cl
                        mov     bl,dl
                        mov     al,[edi+ebx]
                        mov     bp,[_shadcol+eax]
                        mov     4[esi],ebp
                        pop     eax
                        pop     ebp
                        add     esi,8
                        sub     ebp,4
                        add     eax,4
                        cmp     ebp,4
                        jae     ddh
                        test    ebp,ebp
                        jz      ddhexit
ddhlast:                xor     ecx,ecx
ddhlastloop:            mov     bh,byte ptr [_linje+eax]
                        mov     bl,byte ptr [_linje2+eax]
                        inc     eax
                        mov     cl,[edi+ebx]
                        mov     edx,[_shadcol+ecx]
                        mov     [esi],dx
                        add     esi,2
                        dec     ebp
                        jnz     ddhlastloop
ddhexit:                mov     [_screenptr],esi
                        ret





;--------------------------------
; Width: lores (320)
;--------------------------------

; ebx - number of lores pixels to draw

                        align   4
public fillbg320w_
fillbg320w_:            mov     esi,[_screenptr]
                        mov     eax,[_shadcol]
                        cmp     ebx,4
                        jb      fbg320w1
                        test    esi,03h
                        jz      fbg320w2
                        mov     [esi],ax
                        dec     ebx
                        add     esi,2
                        cmp     ebx,4
                        jb      fbg320w1
fbg320w2:               mov     [esi],eax
                        mov     4[esi],eax
                        sub     ebx,4
                        add     esi,8
                        cmp     ebx,4
                        jae     fbg320w2
fbg320w1:               test    ebx,ebx
                        jz      fbg320w3
fbg320w4:               mov     [esi],ax
                        add     esi,2
                        dec     ebx
                        jnz     fbg320w4
fbg320w3:               mov     [_screenptr],esi
                        ret

                        align   4

public drawbgline320w_
drawbgline320w_:        pushad
                        mov     ebp,[_ypos]
                        cmp     ebp,[_cliptop]
                        jb      drawbg320wouttahere
                        cmp     ebp,[_clipbot]
                        jae     drawbg320wouttahere
                        mov     ebx,[_shadcol]
                        mov     ecx,[_lineflags+4*ebp]
                        mov     edx,[_configdoublebuffer]
                        cmp     ecx,ebx
                        jne     drawbgit320w
                        mov     dl,[_lineflagstimes+ebp]
                        test    dl,dl
                        jz      iminheaven1320w
                        dec     dl
drawbgit320w:           mov     [_lineflagstimes+ebp],dl
                        mov     [_lineflags+4*ebp],ebx
                        mov     ebx,[_shadcol]
                        mov     eax,[_screenptr]
                        mov     ebp,10
dbl320w:                mov     [eax],ebx
                        mov     4[eax],ebx
                        mov     8[eax],ebx
                        mov     12[eax],ebx
                        mov     16[eax],ebx
                        mov     20[eax],ebx
                        mov     24[eax],ebx
                        mov     28[eax],ebx
                        mov     32[eax],ebx
                        mov     36[eax],ebx
                        mov     40[eax],ebx
                        mov     44[eax],ebx
                        mov     48[eax],ebx
                        mov     52[eax],ebx
                        mov     56[eax],ebx
                        mov     60[eax],ebx
                        add     eax,64
                        dec     ebp
                        jnz     dbl320w
                        add     eax,[_scanlineadd]
                        mov     [_screenptr],eax
drawbg320wouttahere:    popad
                        ret
iminheaven1320w:        mov     eax,[_scanlineadd]
                        add     eax,640
                        add     [_screenptr],eax
                        popad
                        ret

                        align   4

public drawlores320w_
drawlores320w_:         mov     edx,[_screenptr]
                        mov     ebp,[_DIWlastvisiblepos]
                        mov     edi,[_DIWfirstvisiblepos]
                        test    byte ptr [_bplcon0+1],080h
                        jz      dl320wlores
                        shr     ebp,1
                        shr     edi,1
dl320wlores:            cmp     edi,[_clipleftx]
                        jae     dl320wleftnoclip
                        mov     edi,[_clipleftx]
dl320wleftnoclip:       cmp     ebp,[_cliprightx]
                        jbe     dl320wrightnoclip
                        mov     ebp,[_cliprightx]
dl320wrightnoclip:      sub     ebp,edi
                        xor     ebx,ebx
                        xor     eax,eax
                        cmp     ebp,4
                        jl      dl320wlast4
                        test    edx,03h
                        jz      drlo320w
                        mov     bl,byte ptr [_linje+edi]
                        inc     edi
                        dec     ebp
                        mov     si,[_shadcol+ebx]
                        mov     [edx],si
                        add     edx,2
                        cmp     ebp,4
                        jl      dl320wlast4
drlo320w:               mov     ecx,[_linje+edi]       
                        add     edi,4                  
                        mov     bl,ch                  
                        sub     ebp,4                  
                        mov     al,cl                  
                        shr     ecx,16                 
                        mov     esi,[_shadcol+ebx]  
                        mov     bl,ch                        
                        mov     si,[_shadcol+eax]    
                        mov     al,cl                        
                        mov     [edx],esi          
                        mov     esi,[_shadcol+ebx]  
                        mov     si,[_shadcol+eax]    
                        mov     4[edx],esi         
                        add     edx,8                        
                        cmp     ebp,4                        
                        jae     drlo320w                  
dl320wlast4:            test    ebp,ebp
                        jz      dl320wexit
dl320wlastloop:         mov     bl,byte ptr [_linje+edi]
                        mov     esi,[_shadcol+ebx]
                        mov     [edx],si
                        inc     edi
                        add     edx,2
                        dec     ebp
                        jnz     dl320wlastloop
dl320wexit:             mov     [_screenptr],edx
                        ret

#endif

_TEXT ends

_DATA segment dword public 'DATA'

include data\chip.inc
include data\memory.inc
include data\inout.inc
include data\fellow.inc
include data\graphem.inc

#ifdef TSC_PROFILING
public _drawlores800_tsc
public _drawbgline800_tsc
public _drawbgline800notdrawn_tsc
public _drawlores800_tsctimes
public _drawbgline800_tsctimes
public _drawbgline800notdrawn_tsctimes

public _drawhires800_tsc
public _drawhires800_tsctimes

_drawbgline800_tsctmp:  dd      0,0
_drawbgline800_tsc:  dd      0,0
_drawbgline800_tsctimes:  dd      0
_drawbgline800notdrawn_tsc:  dd      0,0
_drawbgline800notdrawn_tsctimes:  dd      0

_drawlores800_tsctmp:  dd      0,0
_drawlores800_tsc:  dd      0,0
_drawlores800_tsctimes:  dd      0

_drawhires800_tsctmp:  dd      0,0
_drawhires800_tsc:  dd      0,0
_drawhires800_tsctimes:  dd      0


#endif

_DATA ends

_BSS segment dword public 'DATA'
_BSS ends

end

