/****************************************************************************
 MEMORY RELATED FUNCTIONS
 ****************************************************************************/
/* Functions implemented in ma.asm */

/* TOP LEVEL INTERFACE */
extern ULO fetb(amigaadress ea);
extern ULO fetw(amigaadress ea);
extern ULO fetl(amigaadress ea);
extern void wrib(ULO data, amigaadress ea);
extern void wriw(ULO data, amigaadress ea);
extern void wril(ULO data, amigaadress ea);

/* CHIP RAM INTERFACE */
extern ULO readchipbyte(amigaadress ea);
extern ULO readchipword(amigaadress ea);
extern ULO readchiplong(amigaadress ea);
extern void writechipbyte(ULO data, amigaadress ea);
extern void writechipword(ULO data, amigaadress ea);
extern void writechiplong(ULO data, amigaadress ea);

/* FAST RAM INTERFACE */
extern ULO readfastbyte(amigaadress ea);
extern ULO readfastword(amigaadress ea);
extern ULO readfastlong(amigaadress ea);
extern void writefastbyte(ULO data, amigaadress ea);
extern void writefastword(ULO data, amigaadress ea);
extern void writefastlong(ULO data, amigaadress ea);

/* BOGO RAM INTERFACE */
extern ULO readbogobyte(amigaadress ea);
extern ULO readbogoword(amigaadress ea);
extern ULO readbogolong(amigaadress ea);
extern void writebogobyte(ULO data, amigaadress ea);
extern void writebogoword(ULO data, amigaadress ea);
extern void writebogolong(ULO data, amigaadress ea);

/* KICK ROM INTERFACE */
extern ULO readkickbyte(amigaadress ea);
extern ULO readkickword(amigaadress ea);
extern ULO readkicklong(amigaadress ea);
extern void writekickbyte(ULO data, amigaadress ea);
extern void writekickword(ULO data, amigaadress ea);
extern void writekicklong(ULO data, amigaadress ea);

/* IO REGISTER INTERFACE */
extern ULO readregisterbyte(amigaadress ea);
extern ULO readregisterword(amigaadress ea);
extern ULO readregisterlong(amigaadress ea);
extern void writeregisterbyte(ULO data, amigaadress ea);
extern void writeregisterword(ULO data, amigaadress ea);
extern void writeregisterlong(ULO data, amigaadress ea);

/* CIA INTERFACE */
extern ULO readciabyte(amigaadress ea);
extern ULO readciaword(amigaadress ea);
extern ULO readcialong(amigaadress ea);
extern void writeciabyte(ULO data, amigaadress ea);
extern void writeciaword(ULO data, amigaadress ea);
extern void writecialong(ULO data, amigaadress ea);

/* NOT AVAILABLE INTERFACE */
extern ULO readnotavailablebyte(amigaadress ea);
extern ULO readnotavailableword(amigaadress ea);
extern ULO readnotavailablelong(amigaadress ea);
extern void writenotavailablebyte(ULO data, amigaadress ea);
extern void writenotavailableword(ULO data, amigaadress ea);
extern void writenotavailablelong(ULO data, amigaadress ea);

extern void oddwrite(ULO data,amigaadress ea);
extern ULO oddread(amigaadress ea);

