        .486p
DGROUP group _DATA,_BSS
_TEXT  segment dword public use32 'CODE'
       assume cs:_TEXT, ds:DGROUP, ss:DGROUP

; Petter Schau 1996


include defs.inc
include func\68000.inc
include func\chip.inc
include func\inout.inc
include func\sound.inc
include func\draw.inc
include func\graphem.inc
include func\copper.inc

#ifdef DEBUGBUILD
include eventid.inc
#endif

public oddread
public oddwrite

extern blittergeneral_:near

extern drawddfline_:near

extern drawham_:near
extern do_diskdma_:near


; Export til c-rutiner
; --------------------
public fetb_
public fetw_
public fetl_
public wrib_
public wriw_
public wril_
public readchipbyte_
public readchipword_
public readchiplong_
public writechipbyte_
public writechipword_
public writechiplong_
public readbogobyte_
public readbogoword_
public readbogolong_
public writebogobyte_
public writebogoword_
public writebogolong_
public readkickbyte_
public readkickword_
public readkicklong_
public writekickbyte_
public writekickword_
public writekicklong_
public readregisterbyte_
public readregisterword_
public readregisterlong_
public writeregisterbyte_
public writeregisterword_
public writeregisterlong_
public rdmaconr_
public rvposr_
public rvhposr_
public rjoy0dat_
public rjoy1dat_
public rpot0dat_
public rpot1dat_
public rpotgor_
public rintenar_
public rintreqr_
public rid_
public rdefault_
public wcopcon_
public wbltcon0_
public wbltcon1_
public wbltafwm_
public wbltalwm_
public wbltcpth_
public wbltcptl_
public wbltbpth_
public wbltbptl_
public wbltapth_
public wbltaptl_
public wbltdpth_
public wbltdptl_
public wbltsize_
public wbltcmod_
public wbltbmod_
public wbltamod_
public wbltdmod_
public wbltcdat_
public wbltbdat_
public wbltadat_
public wcop1lch_
public wcop1lcl_
public wcop2lch_
public wcop2lcl_
public wcopjmp1_
public wcopjmp2_
public wdiwstrt_
public wdiwstop_
public wddfstrt_
public wddfstop_
public wdmacon_
public wintena_
public wintreq_
public wadcon_
public wbpl1pth_
public wbpl1ptl_
public wbpl2pth_
public wbpl2ptl_
public wbpl3pth_
public wbpl3ptl_
public wbpl4pth_
public wbpl4ptl_
public wbpl5pth_
public wbpl5ptl_
public wbpl6pth_
public wbpl6ptl_
public wbplcon0_
public wbplcon1_
public wbplcon2_
public wbpl1mod_
public wbpl2mod_
public wspr0pth_
public wspr0ptl_
public wspr1pth_
public wspr1ptl_
public wspr2pth_
public wspr2ptl_
public wspr3pth_
public wspr3ptl_
public wspr4pth_
public wspr4ptl_
public wspr5pth_
public wspr5ptl_
public wspr6pth_
public wspr6ptl_
public wspr7pth_
public wspr7ptl_



public wcolor_
public wdefault_
public readnotavailablebyte_
public readnotavailableword_
public readnotavailablelong_
public writenotavailablebyte_
public writenotavailableword_
public writenotavailablelong_

; Export til asm-rutiner
; ----------------------
public fetb
public fetw
public fetl
public wrib
public wriw
public wril

;
; Fetches a byte from memory, returns byte in dl.  Takes ecx as <ea>
;

        align   4
fetb_:  push    ecx
        push    edx
        mov     ecx,eax
        call    fetb
        mov     eax,edx
        pop     edx
        pop     ecx
        ret

        align   4
fetb:
        and     ecx,00ffffffh             ; Mask off upper byte
        mov     edx,ecx
        shr     edx,18
        jmp     dword ptr [_readbyte+4*edx]   ; Call bank handler

;
; Fetches a word from memory, returns word in dx.  Takes ecx as <ea>
;

        align   4
fetw_:  push    ecx
        push    edx
        mov     ecx,eax
        call    fetw
        mov     eax,edx
        pop     edx
        pop     ecx
        ret

        align   4
fetw:   
        test    ecx,1                     ; Check for odd adress
        jnz     oddread
        and     ecx,00ffffffh             ; Mask off upper byte
        mov     edx,ecx
        shr     edx,18
        jmp     dword ptr [_readword+4*edx]   ; Call bank handler

;
; Fetches a long from memory, returns long in edx.  Takes ecx as <ea>
;

        align   4
fetl_:  push    ecx
        push    edx
        mov     ecx,eax
        call    fetl
        mov     eax,edx
        pop     edx
        pop     ecx
        ret

        align   4
fetl:   test    ecx,1                     ; Check for odd adress
        jnz     oddread
        and     ecx,00ffffffh             ; Mask off upper byte
        mov     edx,ecx
        shr     edx,18
        jmp     dword ptr [_readlong+4*edx]   ; Call bank handler

;
; Writes a byte to memory, takes data in dl, ea in ecx
;

        align   4
wrib_:  push	ecx
	push	edx
        mov     ecx,edx         ; ea
        mov     edx,eax         ; data
        call    wrib
	pop	edx
        pop	ecx
        ret

        align   4
wrib:
        and     ecx,00ffffffh
        mov     dword ptr [_wriorgadr],ecx
        shr     ecx,18
        jmp     dword ptr [_writebyte+4*ecx]

;
; Writes a word to memory, takes data in dx, ea in ecx
;

        align   4
wriw_:  push    ecx
        push    edx
        mov     ecx,edx         ; ea
        mov     edx,eax         ; data
        call    wriw
        pop     edx
        pop     ecx
        ret

        align   4
wriw:
        test    ecx,1
        jnz     oddwrite
        and     ecx,00ffffffh
        mov     dword ptr [_wriorgadr],ecx
        shr     ecx,18
        jmp    dword ptr [_writeword+4*ecx]

;
; Writes a long to memory, takes data in edx, ea in ecx
;
        align   4
wril_:  push	ecx
	push	edx
        mov     ecx,edx         ; ea
        mov     edx,eax         ; data
        call    wril
        pop	edx
	pop	ecx
        ret

        align   4
wril:
        test    ecx,1
        jnz     oddwrite
        and     ecx,00ffffffh
        mov     dword ptr [_wriorgadr],ecx
        shr     ecx,18
        jmp     dword ptr [_writelong+4*ecx]


;
; These raises exception 3 when reading an odd address
;

        align   4
oddread:
oddwrite:
        mov     ebx,0ch
	mov	eax,44
        jmp     prepare_exception_

; ================================================= 
; These functions are the bank functions            
; called from the fetX wriX functions               
; ================================================= 

; --------- 
; Chip bank 
; --------- 

        align   4
readchipbyte_:

        movzx   edx,byte ptr [_cmem+ecx]
        ret
        align   4
readchipword_:
        xor     edx,edx
        mov     dh,byte ptr [_cmem+ecx]
        mov     dl,byte ptr [_cmem+1+ecx]
        ret
        align   4
readchiplong_:
        mov     edx,dword ptr [_cmem+ecx]
        bswap   edx
        ret

        align   4
writechipbyte_:
        mov     ecx,dword ptr [_wriorgadr]
        mov     byte ptr [_cmem+ecx],dl
        ret

        align   4
writechipword_:
        mov     ecx,dword ptr [_wriorgadr]
        mov     byte ptr [_cmem+ecx],dh
        mov     byte ptr [_cmem+1+ecx],dl
        ret

        align   4
writechiplong_:
        mov     ecx,dword ptr [_wriorgadr]
        bswap   edx
        mov     dword ptr [_cmem+ecx],edx
        ret

; ---------
; Fast bank 
; ---------

                align   4

public readfastbyte_
readfastbyte_:
                mov     edx,dword ptr [_fmem]
                movzx   edx,byte ptr [ecx+edx-0200000h]
                ret

                align   4

public readfastword_
readfastword_:
                push    ebx
                mov     ebx,dword ptr [_fmem]
                xor     edx,edx
                mov     dh,byte ptr [ecx+ebx-0200000h]
                mov     dl,byte ptr [ecx+ebx-01fffffh]
                pop     ebx
                ret

                align   4

public readfastlong_
readfastlong_:
                mov     edx,dword ptr [_fmem]
                mov     edx,dword ptr [ecx+edx-0200000h]
                bswap   edx
                ret

                align   4

public writefastbyte_
writefastbyte_:
                push    ebx
                mov     ecx,dword ptr [_wriorgadr]
                mov     ebx,dword ptr [_fmem]
                mov     byte ptr [ecx+ebx-0200000h],dl
                pop     ebx
                ret

                align   4

public writefastword_
writefastword_:
                push    ebx
                mov     ecx,dword ptr [_wriorgadr]
                mov     ebx,dword ptr [_fmem]
                mov     byte ptr [ecx+ebx-0200000h],dh
                mov     byte ptr [ecx+ebx-01fffffh],dl
                pop     ebx
                ret

                align   4

public writefastlong_
writefastlong_:
                push    ebx
                mov     ecx,dword ptr [_wriorgadr]
                mov     ebx,dword ptr [_fmem]
                bswap   edx
                mov     dword ptr [ecx+ebx-0200000h],edx
                pop     ebx
                ret

; --------- 
; Bogo bank 
; ---------

        align   4
readbogobyte_:
        movzx   edx,byte ptr _bmem-0c00000h[ecx]
        ret
        align   4
readbogoword_:
        xor     edx,edx
        mov     dh,byte ptr _bmem-0c00000h[ecx]
        mov     dl,byte ptr _bmem-0c00000h+1[ecx]
        ret
        align   4
readbogolong_:
        mov     edx,dword ptr _bmem-0c00000h[ecx]
        bswap   edx
        ret
        align   4
writebogobyte_:
        mov     ecx,dword ptr _wriorgadr

        mov     byte ptr _bmem-0c00000h[ecx],dl
        ret
        align   4
writebogoword_:
        mov     ecx,dword ptr _wriorgadr
        mov     byte ptr _bmem-0c00000h[ecx],dh
        mov     byte ptr _bmem-0c00000h+1[ecx],dl
        ret
        align   4
writebogolong_:
        mov     ecx,dword ptr _wriorgadr
        bswap   edx
        mov     dword ptr _bmem-0c00000h[ecx],edx
        ret

; --------- 
; Kick bank 
; ---------

        align   4
readkickbyte_:
        movzx   edx,byte ptr _kmem-0f80000h[ecx]
        ret
        align   4
readkickword_:
        xor     edx,edx
        mov     dh,byte ptr _kmem-0f80000h[ecx]
        mov     dl,byte ptr _kmem-0f80000h+1[ecx]
        ret
        align   4
readkicklong_:
        mov     edx,dword ptr _kmem-0f80000h[ecx]
        bswap   edx
        ret
        align   4
writekickbyte_:
        ret
        align   4
writekickword_:
        ret
        align   4
writekicklong_:
        ret

; ------------------- 
; Chip register bank  
; ------------------- 

        align   4
readregisterbyte_:
        push    ecx
        and     ecx,01feh
        call    dword ptr _ioread[ecx*2]
        pop     ecx
        test    ecx,1
        jnz     rrb1
        shr     edx,8
rrb1:   and     edx,0ffh
        ret

        align   4
readregisterword_:
        push    ecx
        and     ecx,01feh
        call     dword ptr _ioread[ecx*2]
        pop     ecx
        ret

        align   4
readregisterlong_:
        push    ecx
        and     ecx,01feh
        push    ecx
        call    dword ptr _ioread[ecx*2]
        pop     ecx
        push    edx
        call    dword ptr _ioread+4[ecx*2]
        pop     ecx
        shl     ecx,16
        or      edx,ecx
        pop     ecx
        ret


; Byte write to register, well, simply clear the other
; byte and do a word write.

        align   4
writeregisterbyte_:
        mov     ecx,dword ptr _wriorgadr
        push    ecx
        test    ecx,1
        jnz     wrbodd
        mov     dh,dl

        and     ecx,01feh
        and     edx,0ff00h
        call    dword ptr _iowrite[ecx*2]
        pop     ecx
        ret
wrbodd:
        and     ecx,01feh
        and     edx,0ffh
        call    dword ptr _iowrite[ecx*2]
        pop     ecx
        ret

	
        align   4
writeregisterword_:
        mov     ecx,dword ptr _wriorgadr
        push    ecx
        and     ecx,01feh
        and     edx,0ffffh              ; No extra bits
        call     dword ptr _iowrite[ecx*2]
        pop     ecx
        ret

        align   4
writeregisterlong_:
        mov     ecx,dword ptr _wriorgadr
        push    ecx
        push    edx
        and     ecx,01feh
        push    ecx
        add     ecx,2
        and     ecx,01feh    ; Unreal writes long to $1fe -> jump beyond array 
        and     edx,0ffffh   ; No extra bits here
        call    dword ptr _iowrite[ecx*2]
        pop     ecx
        pop     edx
        shr     edx,16          ; No extra bits! Good!
        call    dword ptr _iowrite[ecx*2]
        pop     ecx
        ret

; ----------------------------
; Chip read register functions  
; ---------------------------- 

; DMACONR
; $dff002

rdmaconr_:
        mov     edx,dword ptr _dmaconr
        ret

; VPOSR
; $dff004
rvposr_:
        mov     edx,dword ptr _lof
        mov     dl,byte ptr _ypos+1
        ret

; VPOSHR
; $dff006
rvhposr_:
        mov     edx,dword ptr _xpos
        cmp     edx,228
        jb      rvhg
        sub     edx,228
rvhg:   shr     edx,1
        mov     dh,byte ptr _ypos
        ret

; JOY0dat
; $dff00a
rjoy0dat_:
        cmp     byte ptr [_config_joyA],5
        jne     rjoy0joy
        mov     edx,dword ptr [_joy0dat]
        ret
rjoy0joy:
        xor     edx,edx
        test    byte ptr _joyAright,1
        jz      rjoy0noright
        or      dl,3
rjoy0noright:
        test    byte ptr _joyAleft,1
        jz      rjoy0noleft
        or      dh,3h
rjoy0noleft:
        test    byte ptr _joyAup,1
        jz      rjoy0noup
        xor     dh,1h
rjoy0noup:
        test    byte ptr _joyAdown,1
        jz      rjoy0nodown
        xor     dl,1
rjoy0nodown:
        ret

; joy1dat
; $dff00c

; Left and right intially sets up and down to off
rjoy1dat_:
        cmp     byte ptr [_config_joyB],5
        jne     rjoy1joy
        mov     edx,dword ptr [_joy1dat]
        ret
rjoy1joy:
        xor     edx,edx
        test    byte ptr _joyBright,1
        jz      rjoy1noright
        or      dl,3
rjoy1noright:
        test    byte ptr _joyBleft,1
        jz      rjoy1noleft
        or      dh,3h
rjoy1noleft:
        test    byte ptr _joyBup,1
        jz      rjoy1noup
        xor     dh,1h
rjoy1noup:
        test    byte ptr _joyBdown,1
        jz      rjoy1nodown
        xor     dl,1
rjoy1nodown:
        ret


; POT0dat
; $dff012
rpot0dat_:
        mov     edx,dword ptr _pot0dat
        ret

; POT1dat
; $dff014
rpot1dat_:
        mov     edx,dword ptr _pot1dat
        ret

; POTGOR
; $dff016
rpotgor_:
        mov     edx,dword ptr _potgor
        and     edx,0bbffh
        cmp     byte ptr _fire2A,1
        je      norb
        or      dh,04h
norb:   cmp     byte ptr _fire2B,1
        je      norc
        or      dh,040h
norc:   ret

; INTENAR
; $dff01c
rintenar_:
        mov     edx,dword ptr _intenar
        ret

; INTREQR
; $dff01e
rintreqr_:
        mov     edx,dword ptr _intreq
        ret

;========
; ECS id
;========
; $dff07c

rid_:
        mov     edx,0fch
        ret

; To simulate bus-noise, return 0 and -1 every second time.
; Why? Bugged demos test write-only register for various bit-values
; and to break out of loops, both 0 and 1 values must be returned.

rdefault_:
        inc     dword ptr [_busnoisecounter]
        mov     edx,dword ptr [_busnoisecounter]
        and     edx,1
        mov     edx,dword ptr [_busnoise+4*edx]
        ret

; -----------------------------
; Chip write register functions  
; ----------------------------- 

;========
; VPOS
;========
; $dff02a

public wvpos_
wvpos_: and     edx,08000h
        mov     dword ptr _lof,edx
        ret

;========
; COPCON
;========
; $dff02e

wcopcon_:
        mov     dword ptr _copcon,edx
        ret

;========
; BLTCON0
;========
; $dff040
wbltcon0_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltcona
;        pushad
;        call    finish_blit_
;        popad
wbltcona:
        mov     word ptr _bltcon+2,dx
        and     edx,0ffh
        shl     edx,2
        mov     edx,dword ptr _blittertable[edx]
        mov     dword ptr _bltminterm,edx
        ret

;========
; BLTCON1
;========
; $dff042
wbltcon1_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltcon1a
;        pushad
;        call    finish_blit_
;        popad
wbltcon1a:
        mov     dword ptr _bltdesc,2        ; Added to pointers in blit
        test    edx,0002h                   ; test desc
        jz      blits1
        mov     dword ptr _bltdesc,-2       ; Hence negative in desc mode
blits1:
        mov     ecx,dword ptr _bltcon
        mov     word ptr _bltcon,dx
        test    edx,1                       ; need to restore mods in linemode
        jnz     bconlines
        test    ecx,1           ; Going from linemode to desc mode ?
        jz      bconnoprevlines

; Here last mode was linemode, but new isn't
; Mods need changing if new is desc mode
        test    edx,2
        jz      bcon            ; New is normal, mods already ok
        jmp     modrestore

bconnoprevlines:
        and     edx,02h
        and     ecx,02h
        cmp     edx,ecx
        je      bcon
modrestore:
        neg     dword ptr _bltamod
        neg     dword ptr _bltbmod
        neg     dword ptr _bltcmod
        neg     dword ptr _bltdmod

bcon:   ret
bconlines:    ; Restore unless previous mode was linemode
        test    ecx,1
        jnz     bcon
        test    ecx,2
        jz      bcon
        jmp     modrestore

;========
; BLTAFWM
;========
; $dff044
wbltafwm_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltafwma
;        pushad
;        call    finish_blit_
;        popad
wbltafwma:
        mov     word ptr _bltafwm,dx
        mov     word ptr _bltafwm+2,dx
        ret

;========
; BLTALWM
;========
; $dff046
wbltalwm_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltalwma
;        pushad
;        call    finish_blit_
;        popad
wbltalwma:
        mov     word ptr _bltalwm,dx
        mov     word ptr _bltalwm+2,dx
        ret

;=======
; BLTCPT
;=======
; $dff048 - WORD
wbltcpth_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltcptha
;        pushad
;        call    finish_blit_
;        popad
wbltcptha:
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _bltcpt+2,dx
        ret

; $dff04a - WORD
wbltcptl_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltcptla
;        pushad
;        call    finish_blit_
;        popad
wbltcptla:
        and     edx,0fffffffeh              ; No odd adresses
        mov     word ptr _bltcpt,dx
        ret

;=======
; BLTBPT
;=======
; $dff04c - WORD
wbltbpth_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltbptha
;        pushad
;        call    finish_blit_
;        popad
wbltbptha:
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _bltbpt+2,dx
        ret

; $dff04e - WORD
wbltbptl_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltbptla
;        pushad
;        call    finish_blit_
;        popad
wbltbptla:
        and     edx,0fffffffeh              ; No odd adresses
        mov     word ptr _bltbpt,dx
        ret

;=======
; BLTAPT
;=======
; $dff050 - WORD
wbltapth_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltaptha
;        pushad
;        call    finish_blit_
;        popad
wbltaptha:
        and     edx,1fh
        mov     word ptr _bltapt+2,dx
        ret

; $dff052 - WORD
wbltaptl_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltaptla
;        pushad
;        call    finish_blit_
;        popad
wbltaptla:
        and     edx,0fffffffeh
        mov     word ptr _bltapt,dx
        ret

;=======
; BLTDPT
;=======
; $dff054 - WORD
wbltdpth_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltdptha
;        pushad
;        call    finish_blit_
;        popad
wbltdptha:
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _bltdpt+2,dx
        ret

; $dff056 - WORD
wbltdptl_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltdptla
;        pushad
;        call    finish_blit_
;        popad
wbltdptla:
        and     edx,0fffffffeh              ; No odd adresses
        mov     word ptr _bltdpt,dx
        ret

;========
; BLTSIZE
;========
; $dff058
wbltsize_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltsizex
;        pushad
;        call    finish_blit_
;        popad
wbltsizex:
        mov     ecx,edx
        and     ecx,03fh                ; Width
        jnz     wbltsizea
        mov     ecx,64
wbltsizea:
        mov     dword ptr _linelength,ecx
        shr     edx,6
        and     edx,3ffh
        jnz     wbltsizeb
        mov     edx,1024
wbltsizeb:
        mov     dword ptr _linenum,edx
        mov     dword ptr _linecount,edx
        test    dword ptr _dmacon,0040h
        jnz     dblit
        mov     dword ptr _blitterdmawaiting,1
        ret
dblit:
        call    blitter_copy_
        ret

;========
; BLTCMOD
;========
; $dff060
wbltcmod_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltcmoda
;        pushad
;        call    finish_blit_
;        popad
wbltcmoda:
        and     edx,0fffeh                      ; Even modulo
        movsx   edx,dx
        test    dword ptr _bltcon,1
        jnz     bcn     
        test    dword ptr _bltcon,2
        jz      bcn
        neg     edx
bcn:    mov     dword ptr _bltcmod,edx
        ret

;========
; BLTBMOD
;========
; $dff062
wbltbmod_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltbmoda
;        pushad
;        call    finish_blit_
;        popad
wbltbmoda:
        and     edx,0fffeh                      ; Even modulo
        movsx   edx,dx
        test    dword ptr _bltcon,1
        jnz     bbn     
        test    dword ptr _bltcon,2
        jz      bbn
        neg     edx
bbn:    mov     dword ptr _bltbmod,edx
        ret

;========
; BLTAMOD
;========
; $dff064
wbltamod_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltamoda
;        pushad
;        call    finish_blit_
;        popad
wbltamoda:
        and     edx,0fffeh                      ; Even modulo
        movsx   edx,dx
        test    dword ptr _bltcon,1
        jnz     ban     
        test    dword ptr _bltcon,2
        jz      ban
        neg     edx
ban:    mov     dword ptr _bltamod,edx
        ret

;========
; BLTDMOD
;========
; $dff066
wbltdmod_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltdmoda
;        pushad
;        call    finish_blit_
;        popad
wbltdmoda:
        and     edx,0fffeh                      ; Even modulo
        movsx   edx,dx
        test    dword ptr _bltcon,1
        jnz     bdn     
        test    dword ptr _bltcon,2
        jz      bdn
        neg     edx
bdn:    mov     dword ptr _bltdmod,edx
        ret

;========
; BLTCDAT
;========
; $dff070
wbltcdat_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltcdata
;        pushad
;        call    finish_blit_
;        popad
wbltcdata:
        mov     dword ptr _bltcdat,edx
        ret

;========
; BLTBDAT
;========
; $dff072
wbltbdat_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltbdata
;        pushad
;        call    finish_blit_
;        popad
wbltbdata:
        mov     [_bltbdatoriginal],edx
        mov     ecx,dword ptr _bltcon
        shr     ecx,12
        and     ecx,0fh
        test    dword ptr _bltcon,2
        jnz     wbltbdatb
        shr     dx,cl
        and     edx,0ffffh
        mov     dword ptr _bltbdat,edx
        ret
wbltbdatb:
        shl     dx,cl
        and     edx,0ffffh
        mov     dword ptr _bltbdat,edx
        ret

;========
; BLTADAT
;========
; $dff074
wbltadat_:
;        test     dword ptr _blitterstatus,0ffh
;        jz      wbltadata
;        pushad
;        call    finish_blit_
;        popad
wbltadata:
        mov     dword ptr _bltadat,edx
        mov     [_bltadatoriginal],edx
        ret



;=======
; COP1LC
;=======

; $dff080 - WORD
wcop1lch_:
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _cop1lc+2,dx
        ret

; $dff082 - WORD
wcop1lcl_:
        and     edx,0fffffffeh              ; No odd adresses
        mov     word ptr _cop1lc,dx
        ret

;=======
; COP2LC
;=======

; $dff084 - konvensjon, peker registre inneholder alltid adresse uten kmem
; $dff084 - WORD
wcop2lch_:
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _cop2lc+2,dx
        ret

; $dff086 - WORD
wcop2lcl_:
        and     edx,0fffffffeh              ; No odd adresses
        mov     word ptr _cop2lc,dx
        ret

;========
; COPJMP1
;========
; $dff088 - word
wcopjmp1_:
        call    copper_load1_
        ret

;========
; COPJMP2
;========
; $dff08A - word
wcopjmp2_:
        call    copper_load2_
        ret

;========
; DIWSTRT
;========
; Konvensjoner:
; _diwytop    - frste linje noe skjer
; _diwybottom - frste linje det ikke skjer noe

; $dff08e - WORD
wdiwstrt_:
        mov     dword ptr _diwstrt,edx  ; Might need to recalulate help vars.
        movzx   ecx,dh                  ; _diwytop - HJELPEVARIABEL
        mov     dword ptr _diwytop,ecx
        and     edx,0ffh
        cmp     dword ptr _diwxright,472
        jne     nofuzz2
        mov     edx,88
nofuzz2:
        mov     dword ptr _diwxleft,edx ; _diwxleft - HJELPEVARIABEL
	call	calculate_window
        ret

;========
; DIWSTOP
;========

; $dff090 - WORD
wdiwstop_:
        mov     dword ptr _diwstop,edx
        movzx   ecx,dh
        test    ecx,80h
        jnz     nor
        cmp     ecx,055h
        jae     nor
        add     ecx,256
nor:    mov     dword ptr _diwybottom,ecx
        and     edx,0ffh
        add     edx,256
        cmp     edx,457
        jb      nofuzz
        mov     edx,472
        mov     dword ptr _diwxleft,88
        jmp     fuzzyfyzz
nofuzz:
        mov     ecx,dword ptr _diwstrt
        and     ecx,0ffh
        mov     dword ptr _diwxleft,ecx
fuzzyfyzz:
        mov     dword ptr _diwxright,edx
	call	calculate_window
        ret

;========
; DDFSTRT
;========
; $dff092 - WORD

; Must calculate the following variables
; DDFstartpos
;   Calculate the initial cylinder to draw data (ddfstrt*2+17)
; DDFnumberofwords
;   Calculate the number of words in the line ((ddfstop-ddfstrt)*2)+16

wddfstrt_:
        push    ecx
        and     edx,0fch
        mov     ecx,dword ptr _ddfstrt  ; When ddfstrt is less than $18, set it to $18
        cmp     edx,18h
        jae     dstr1
        mov     edx,18h
dstr1:  mov     dword ptr _ddfstrt,edx
        cmp     ecx,edx         ; New same as old? Don't recalculate window
        je      wddfout2
        mov     ecx,edx
        sub     ecx,014h
        mov     dword ptr [_spriteddfkill],ecx

; everything seems OK, calculate offset, length
        call    calculate_window
wddfout2:
        pop     ecx
        ret


; Calculate all variables connected to the screen emulation
; First calculate the ddf variables DDFstartpos and DDFnumberofwords
;   Check if stop is bigger than start
;   Check if strt and stop is mod 8 aligned
;   If not OK then set numberofwords and startpos to 0 and DIWvisible vars to 128


calculate_window:
        test    dword ptr _bplcon0,08000h
        jnz     calculate_window_hires
        mov     ecx,dword ptr _ddfstop
	mov	edx,dword ptr _ddfstrt
        cmp     edx,ecx                    ; ddfstrt bigger than ddfstop?
        ja      cwdiwerr
        and     ecx,07h         ; Must be aligned by mod 8
        and     edx,07h
        push    ebp
        xor     ebp,ebp
        cmp     ecx,edx         ; start aligned with stop?
        je      cwdiwloddfaligned
        inc     ebp

cwdiwloddfaligned:

; everything seems OK with DDF, calculate DFFstartpos, DDFnumberofwords

        mov     ecx,dword ptr _ddfstop
        sub     ecx,dword ptr _ddfstrt
        shr     ecx,3             ; length in words
        inc     ecx
        add     ecx,ebp
        pop     ebp
        mov     dword ptr _DDFnumberofwords,ecx

        mov     ecx,dword ptr _ddfstrt
        shl     ecx,1
        add     ecx,11h
        mov     dword ptr _DDFstartpos,ecx

; Now DDF variables are done
; Now check the DIW values

	mov	ecx,dword ptr _diwxleft
	mov	edx,dword ptr _diwxright
	cmp	ecx,edx				; diwxleft less than diwxright?
	jae	cwdiwerr
	cmp	ecx,dword ptr _DDFstartpos
	jb	cwdiwless
	mov	dword ptr _DIWfirstvisiblepos,ecx ; DDFstartpos is less than diwxleft
	jmp	cwdiwlastpos
cwdiwless:
	mov	ecx,dword ptr _DDFstartpos
	mov	dword ptr _DIWfirstvisiblepos,ecx ; DDFstartpos is higher than diwxleft
cwdiwlastpos:
 	mov	ecx,dword ptr _DDFnumberofwords   ; Calculate last pos in DDF data
	mov	edx,dword ptr _DDFstartpos
	shl	ecx,4				  ; numofwords*16
	add	ecx,edx

	mov	edx,dword ptr _oddscroll
	cmp	edx,dword ptr _evenscroll
	ja	cwaddodd
	add	ecx,dword ptr _evenscroll
	jmp	cwdiwlastpos2
cwaddodd:
	add	ecx,dword ptr _oddscroll
cwdiwlastpos2:
; Now we have ecx - the last position in line(first invisible)
        ;inc     ecx
	mov	edx, dword ptr _diwxright
	cmp	ecx,edx
	jb	cwdiwxx
	
	mov	dword ptr _DIWlastvisiblepos,edx ; lastpos is higher than diwxright
	jmp	cwdiwyy
cwdiwxx:
	mov	dword ptr _DIWlastvisiblepos,ecx ; lastpos is lower than diwxright
cwdiwyy:

; Now all variables have been initialized

        ret

calculate_window_hires:
        mov     ecx,dword ptr _ddfstop
	mov	edx,dword ptr _ddfstrt
        cmp     edx,ecx                    ; ddfstrt bigger than ddfstop?
        ja      cwdiwerrh
        and     ecx,07h         ; Must be aligned by mod 8 in hires
        and     edx,07h
        ;push    ebp
        ;xor     ebp,ebp
        ;cmp     ecx,edx         ; start aligned with stop?
        ;je      cwdiwddfaligned
        ;inc     ebp

cwdiwddfaligned:
        
; everything seems OK with DDF, calculate DFFstartpos, DDFnumberofwords
; DDFnumberofwords is  stop-start/4+2
        mov     ecx,dword ptr _ddfstop
        sub     ecx,dword ptr _ddfstrt
        add     ecx,15
        shr     ecx,2             ; length in words
        and     ecx,0fffffffeh
        ;add     ecx,2
        ;add     ecx,ebp
        ;pop     ebp
        mov     dword ptr _DDFnumberofwords,ecx

; DDFstartpos = start*4+18 in hires
        mov     ecx,dword ptr _ddfstrt
        shl     ecx,2
        add     ecx,18
        mov     dword ptr _DDFstartpos,ecx

; Now DDF variables are done
; Now check the DIW values

	mov	ecx,dword ptr _diwxleft
        shl     ecx,1        
	mov	edx,dword ptr _diwxright
        shl     edx,1
        cmp	ecx,edx				; diwxleft less than diwxright?
        jae     cwdiwerrh
	cmp	ecx,dword ptr _DDFstartpos
        jb      cwdiwlessh
	mov	dword ptr _DIWfirstvisiblepos,ecx ; DDFstartpos is less than diwxleft
        jmp     cwdiwlastposh
cwdiwlessh:
	mov	ecx,dword ptr _DDFstartpos
	mov	dword ptr _DIWfirstvisiblepos,ecx ; DDFstartpos is higher than diwxleft
cwdiwlastposh:
 	mov	ecx,dword ptr _DDFnumberofwords   ; Calculate last pos in DDF data
	mov	edx,dword ptr _DDFstartpos
	shl	ecx,4				  ; numofwords*16
	add	ecx,edx

        mov     edx,dword ptr _oddhiscroll
        cmp     edx,dword ptr _evenhiscroll
        ja      cwaddoddh
        add     ecx,dword ptr _evenhiscroll
        jmp     cwdiwlastpos2h
cwaddoddh:
        add     ecx,dword ptr _oddhiscroll
cwdiwlastpos2h:
; Now we have ecx - the last position in line(first invisible)

	mov	edx, dword ptr _diwxright
        shl     edx,1
	cmp	ecx,edx
        jb      cwdiwxxh
	
	mov	dword ptr _DIWlastvisiblepos,edx ; lastpos is higher than diwxright
        jmp     cwdiwyyh
cwdiwxxh:
	mov	dword ptr _DIWlastvisiblepos,ecx ; lastpos is lower than diwxright
cwdiwyyh:

; Now all variables have been initialized

        ret

; Error with DDF variables, set all variables to off values
cwdiwerr:
        xor     ecx,ecx
        mov     dword ptr _DDFstartpos,ecx
        mov     dword ptr _DDFnumberofwords,ecx
	mov	dword ptr _DIWfirstvisiblepos,256
	mov	dword ptr _DIWlastvisiblepos,256
        ret
; Error with DDF variables, set all variables to off values
cwdiwerrh:
        xor     ecx,ecx
        mov     dword ptr _DDFstartpos,ecx
        mov     dword ptr _DDFnumberofwords,ecx
	mov	dword ptr _DIWfirstvisiblepos,256
	mov	dword ptr _DIWlastvisiblepos,256
        ret



;========
; DDFSTOP
;========
; $dff094 - WORD
wddfstop_:
        push    ecx
        and     edx,0fch
        mov     ecx,dword ptr _ddfstop
        cmp     edx,0d8h
        jbe     dsto1
        mov     edx,0d8h
dsto1:  mov     dword ptr _ddfstop,edx
        cmp     ecx,edx         ; New same as old?
        je      wddfout5
; everything seems OK, calculate offset, length
        call    calculate_window
wddfout5:
        pop     ecx
        ret

;========
; DMACON
;========
; $dff096  - Read from $dff002
; dmacon - zero if master dma bit is off
; dmaconr - is always correct.
wdmacon_:
        mov     ecx,dword ptr _dmaconr
        test    edx,08000h
	jz      wdma1
        and     edx,7ffh                ; Sett bits - Readonly bits
        or      ecx,edx                 ; ecx is new dmaconr
        mov     dword ptr _dmaconr,ecx
        test    ecx,0200h
	jnz     wdmanorm
	xor     ecx,ecx
wdmanorm:
        mov     edx,dword ptr _dmacon   ; get old dmacon (master dma adjusted)
        mov     dword ptr _dmacon,ecx   ; Store new dmacon --------"---------


; Do audio stuff
        test    ecx,1                   ; Channel 0 turned on?
        jz      snden0
        test    edx,1                   ; Already on?
        jnz     snden0
        push    edx
        push    ecx
        mov     edx,0
        call    audio_state_machine_
        pop     ecx
        pop     edx
snden0:
        test    ecx,2
        jz      snden1
        test    edx,2
        jnz     snden1
        push    edx
        push    ecx
        mov     edx,1
        call    audio_state_machine_
        pop     ecx
        pop     edx
snden1:
        test    ecx,4
        jz      snden2
        test    edx,4
        jnz     snden2
        push    edx
        push    ecx
        mov     edx,2
        call    audio_state_machine_
        pop     ecx
        pop     edx
snden2:
        test    ecx,8
        jz      snden3
        test    edx,8
        jnz     snden3
        push    edx
        push    ecx
        mov     edx,3
        call    audio_state_machine_
        pop     ecx
        pop     edx
snden3:
        test    dword ptr _blitterdmawaiting,1
        jz      wdmae1
        test    ecx,0040h
        jz      wdmae1
        call    blitter_copy_
wdmae1:
        call    copper_updatedma_
        ret

wdma1:  and     edx,7ffh                ; Vekk med Readonly bits
        not     edx
        and     ecx,edx                   ; Slett bits
        mov     dword ptr _dmaconr,ecx
        test    ecx,0200h
        jnz     wdmanormoff
	xor     ecx,ecx
wdmanormoff:
        mov     edx,dword ptr _dmacon  ; get old dmacon
        mov     dword ptr _dmacon,ecx  ; store new dmacon

; IF blitter dma is turned off in the middle of a blit
; finish the blit

        test    ecx,040h
        jnz     wdmabrag
        test    dword ptr _blitterstatus,0ffh
        jz      wdmabrag
        pushad
        call    finish_blit_
        popad
wdmabrag:
; Do audio stuff when dma turns off
; Simply set state 0, (state not set if state = 3??)

        test    ecx,1                   ; Channel 0 turned off?
        jnz     sndoff0
        test    edx,1                   ; Already off?
        jz      sndoff0
        push    ecx
        mov     ecx,0
        call    audio_kill_channel_
        pop     ecx
sndoff0:
        test    ecx,2
        jnz     sndoff1
        test    edx,2
        jz      sndoff1
        push    ecx
        mov     ecx,1
        call    audio_kill_channel_
        pop     ecx
sndoff1:
        test    ecx,4
        jnz     sndoff2
        test    edx,4
        jz      sndoff2
        push    ecx
        mov     ecx,2
        call    audio_kill_channel_
        pop     ecx
sndoff2:
        test    ecx,8
        jnz     sndoff3
        test    edx,8
        jz      sndoff3
        push    ecx
        mov     ecx,3
        call    audio_kill_channel_
        pop     ecx
sndoff3:


        test    dword ptr _blitterdmawaiting,1
        jz      wdmae2
        test    ecx,0040h
        jz      wdmae2
        pushad
        call    blitter_copy_
        popad
wdmae2:
        call    copper_updatedma_
        ret

;========
; INTENA
;========
; $dff09a  - Leses fra $dff01c
; If master bit is off, then INTENA is 0, else INTENA = INTENAR
; The master bit can not be read, the memory test in the kickstart
; depends on this.
wintena_:
        mov     ecx,dword ptr _intenar     ; Les inn status
        test    edx,08000h
	jz      wine1
        and     edx,7fffh                ; Sett bits
        or      ecx,edx
        mov     dword ptr _intenar,ecx
        test    ecx,00004000h
        jnz     wintenanorm
	xor     ecx,ecx
        mov     dword ptr _intena,ecx
        ret
wintenanorm:
        mov     dword ptr _intena,ecx
        call    raise_interrupt_
	ret
wine1:  and     edx,7fffh                ; Slett bits
        not     edx
        and     ecx,edx                   ; Slett bits
        mov     dword ptr _intenar,ecx
        test    ecx,00004000h
        jnz     wintenanorm
	xor     ecx,ecx
        mov     dword ptr _intena,ecx
	ret

;========
; INTREQ
;========

; $dff09c  - Leses fra $dff01e
; Skrives direkte til $dff01e, og raise_interrupt kalles ved setting av bits.
wintreq_:
        mov     ecx,dword ptr _intreq    ; Les inn status
        test    edx,08000h
        jz      winr1
        and     edx,7fffh                ; Sett bits
        or      ecx,edx
        mov     dword ptr _intreq,ecx
        call    raise_interrupt_
        ret
winr1:  and     edx,7fffh                ; Slett bits
        not     edx
        and     ecx,edx                   ; Slett bits
        mov     dword ptr _intreq,ecx
	ret
;========
; ADCON
;========

; $dff09e  - Leses fra $dff010
wadcon_:
        mov     ecx,dword ptr _adcon    ; Les inn status
        test    edx,08000h
        jz      adcr1
        and     edx,7fffh                ; Sett bits
        or      ecx,edx
        mov     dword ptr _adcon,ecx
        ret
adcr1:  and     edx,7fffh                ; Slett bits
        not     edx
        and     ecx,edx                   ; Slett bits
        mov     dword ptr _adcon,ecx
        ret

;=======
; BPL1PT
;=======

; $dff0e0 - konvensjon, peker registre inneholder alltid adresse uten kmem
; $dff0e0 - WORD
wbpl1pth_:
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _bpl1pt+2,dx
        ret

; $dff0e2 - WORD
wbpl1ptl_:
        and     edx,0fffffffeh              ; No odd adresses
        mov     word ptr _bpl1pt,dx
        ret

;=======
; BPL2PT
;=======

; $dff0e4 - konvensjon, peker registre inneholder alltid adresse uten kmem
; $dff0e4 - WORD
wbpl2pth_:
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _bpl2pt+2,dx
        ret

; $dff0e6 - WORD
wbpl2ptl_:
        and     edx,0fffffffeh              ; No odd adresses
        mov     word ptr _bpl2pt,dx
        ret

;=======
; BPL3PT
;=======

; $dff0e8 - konvensjon, peker registre inneholder alltid adresse uten kmem
; $dff0e8 - WORD
wbpl3pth_:
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _bpl3pt+2,dx
        ret

; $dff0ea - WORD
wbpl3ptl_:
        and     edx,0fffffffeh              ; No odd adresses
        mov     word ptr _bpl3pt,dx
        ret

;=======
; BPL4PT
;=======

; $dff0ec - konvensjon, peker registre inneholder alltid adresse uten kmem
; $dff0ec - WORD
wbpl4pth_:
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _bpl4pt+2,dx
        ret

; $dff0ee - WORD
wbpl4ptl_:
        and     edx,0fffffffeh              ; No odd adresses
        mov     word ptr _bpl4pt,dx
        ret

;=======
; BPL5PT
;=======

; $dff0f0 - konvensjon, peker registre inneholder alltid adresse uten kmem
; $dff0f0 - WORD
wbpl5pth_:
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _bpl5pt+2,dx
        ret

; $dff0f2 - WORD
wbpl5ptl_:
        and     edx,0fffffffeh              ; No odd adresses
        mov     word ptr _bpl5pt,dx
        ret


;=======
; BPL6PT
;=======

; $dff0f4 - konvensjon, peker registre inneholder alltid adresse uten kmem
; $dff0f4 - WORD
wbpl6pth_:
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _bpl6pt+2,dx
        ret

; $dff0f6 - WORD
wbpl6ptl_:
        and     edx,0fffffffeh              ; No odd adresses
        mov     word ptr _bpl6pt,dx
        ret

;========
; BPLCON0
;========
; $dff100 - WORD
wbplcon0_:
        push    ecx
        mov     dword ptr _bplcon0,edx

        mov     edx,dword ptr _bplcon0
        and     edx,0f000h
        shr     edx,12
        test    dword ptr _bplcon0,0400h
        jz      nodualpf
        mov     ecx,dword ptr _decoderoutinedualtab+edx*4
        jmp     afterdualpf
nodualpf:
        mov     ecx,dword ptr _decoderoutinetab+edx*4
afterdualpf:

        mov     dword ptr _decoderoutineptr,ecx
        mov     dword ptr _DIWfirstposonline,88
        mov     dword ptr _DIWlastposonline,472
        test    dword ptr _bplcon0,0800h
        jz      noham
        mov     ecx,[_drawhamroutine]
        jmp     wakke
noham:  test    dword ptr _bplcon0,0400h
        jz      nodualpf2
        cmp     edx,1
        je      nodualpf2
        cmp     edx,9
        je      nodualpf2
        mov     ecx,[_drawdualloresroutine]
        cmp     edx,7
        jb      wakke
        mov     ecx,[_drawdualhiresroutine]
        mov     dword ptr _DIWfirstposonline,176
        mov     dword ptr _DIWlastposonline,944
        jmp     wakke
nodualpf2:
        mov     ecx,[_drawloresroutine]
        test    edx,08h
        jz      wakke
        mov     dword ptr _DIWfirstposonline,176
        mov     dword ptr _DIWlastposonline,944
        mov     ecx,[_drawhiresroutine]
wakke:  mov     dword ptr _drawroutineptr,ecx
        call    calculate_window
        pop     ecx
        ret
;When ddfstrt is (mod 8)+4, shift order is 8-f,0-7, not implemeted in lores yet
;========
; BPLCON1
;========
; $dff102 - WORD

; Extra variables
; oddscroll - dword with the odd lores scrollvalue
; evenscroll -dword with the even lores scrollvalue

; oddhiscroll - dword with the odd hires scrollvalue
; evenhiscroll - dword with the even hires scrollvalue

wbplcon1_:
        and     edx,0ffh
        mov     dword ptr _bplcon1,edx
        mov     ecx,edx
        and     edx,0fh
        mov     dword ptr _oddscroll,edx
        and     edx,7h
        test    dword ptr _ddfstrt,2h
        jz      bpc1normal1
        add     edx,4h
        and     edx,7h
bpc1normal1:
        shl     edx,1
        mov     dword ptr _oddhiscroll,edx
        and     ecx,0f0h
        shr     ecx,4
        mov     dword ptr _evenscroll,ecx
        and     ecx,7h
        test    dword ptr _ddfstrt,2h
        jz      bpc1normal2
        add     ecx,4h
        and     ecx,7h
bpc1normal2:

        shl     ecx,1
        mov     dword ptr _evenhiscroll,ecx
        call    calculate_window
        ret

;========
; BPLCON2
;========
; $dff108 - WORD
wbplcon2_:
        mov     dword ptr _bplcon2,edx
        ret
;========
; BPL1MOD
;========
; $dff108 - WORD
wbpl1mod_:
        and     edx,0fffeh
        movsx   edx,dx
        mov     dword ptr _bpl1mod,edx
        ret

;========
; BPL2MOD
;========
; $dff10a - WORD
wbpl2mod_:
        and     edx,0fffeh
        movsx   edx,dx
        mov     dword ptr _bpl2mod,edx
        ret

; Decide delay of sprite ptr update
; ebx - cycle xpos must be past to trigger delay

decidedelay:
        cmp     dword ptr _spritewritereal,1
        je      ddnodelay
        cmp     ebx,dword ptr [_xpos]
        ja      ddnodelay
        mov     ebx,dword ptr [_spritewritenext]
        mov     dword ptr [_spritewritebuffer+ebx],ecx
        mov     dword ptr [_spritewritebuffer+4+ebx],edx
        add     ebx,8
        mov     dword ptr [_spritewritenext],ebx
        mov     ebx,1
        ret
ddnodelay:
        xor     ebx,ebx
        ret

;=======
; SPR0PT
;=======

; $dff120 - konvensjon, peker registre inneholder alltid adresse uten kmem
; $dff120 - WORD
wspr0pth_:
        push    ebx
        mov     ebx,01ch
        call    decidedelay
        test    ebx,1
        jz      wspr0h
        pop     ebx
        ret
wspr0h: pop     ebx
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _sprpt+2,dx
        ret

; $dff122 - WORD
wspr0ptl_:
        push    ebx
        mov     ebx,01ch
        call    decidedelay
        test    ebx,1
        jz      wspr0l
        pop     ebx
        ret
wspr0l: pop     ebx
        and     edx,0fffeh              ; No odd adresses
        mov     word ptr _sprpt,dx
        ret


;=======
; SPR1PT
;=======

; $dff124 - konvensjon, peker registre inneholder alltid adresse uten kmem
; $dff124 - WORD
wspr1pth_:
        push    ebx
        mov     ebx,020h
        call    decidedelay
        test    ebx,1
        jz      wspr1h
        pop     ebx
        ret
wspr1h: pop     ebx
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _sprpt+2+4,dx
        ret

; $dff126 - WORD
wspr1ptl_:
        push    ebx
        mov     ebx,020h
        call    decidedelay
        test    ebx,1
        jz      wspr1l
        pop     ebx
        ret
wspr1l: pop     ebx
        and     edx,0fffeh              ; No odd adresses
        mov     word ptr _sprpt+4,dx
        ret


;=======
; SPR2PT
;=======

; $dff128 - konvensjon, peker registre inneholder alltid adresse uten kmem
; $dff128 - WORD
wspr2pth_:
        push    ebx
        mov     ebx,024h
        call    decidedelay
        test    ebx,1
        jz      wspr2h
        pop     ebx
        ret
wspr2h: pop     ebx
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _sprpt+2+8,dx
        ret

; $dff12a - WORD
wspr2ptl_:
        push    ebx
        mov     ebx,024h
        call    decidedelay
        test    ebx,1
        jz      wspr2l
        pop     ebx
        ret
wspr2l: pop     ebx
        and     edx,0fffeh              ; No odd adresses
        mov     word ptr _sprpt+8,dx
        ret


;=======
; SPR3PT
;=======

; $dff12c - konvensjon, peker registre inneholder alltid adresse uten kmem
; $dff12c - WORD
wspr3pth_:
        push    ebx
        mov     ebx,028h
        call    decidedelay
        test    ebx,1
        jz      wspr3h
        pop     ebx
        ret
wspr3h: pop     ebx
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _sprpt+2+12,dx
        ret

; $dff12e - WORD
wspr3ptl_:
        push    ebx
        mov     ebx,028h
        call    decidedelay
        test    ebx,1
        jz      wspr3l
        pop     ebx
        ret
wspr3l: pop     ebx
        and     edx,0fffeh              ; No odd adresses
        mov     word ptr _sprpt+12,dx
        ret


;=======
; SPR4PT
;=======

; $dff130 - konvensjon, peker registre inneholder alltid adresse uten kmem
; $dff130 - WORD
wspr4pth_:
        push    ebx
        mov     ebx,02ch
        call    decidedelay
        test    ebx,1
        jz      wspr4h
        pop     ebx
        ret
wspr4h: pop     ebx
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _sprpt+2+16,dx
        ret

; $dff132 - WORD
wspr4ptl_:
        push    ebx
        mov     ebx,02ch
        call    decidedelay
        test    ebx,1
        jz      wspr4l
        pop     ebx
        ret
wspr4l: pop     ebx
        and     edx,0fffeh              ; No odd adresses
        mov     word ptr _sprpt+16,dx
        ret


;=======
; SPR5PT
;=======

; $dff134 - konvensjon, peker registre inneholder alltid adresse uten kmem
; $dff134 - WORD
wspr5pth_:
        push    ebx
        mov     ebx,030h
        call    decidedelay
        test    ebx,1
        jz      wspr5h
        pop     ebx
        ret
wspr5h: pop     ebx
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _sprpt+2+20,dx
        ret

; $dff136 - WORD
wspr5ptl_:
        push    ebx
        mov     ebx,030h
        call    decidedelay
        test    ebx,1
        jz      wspr5l
        pop     ebx
        ret
wspr5l: pop     ebx
        and     edx,0fffeh              ; No odd adresses
        mov     word ptr _sprpt+20,dx
        ret


;=======
; SPR6PT
;=======

; $dff138 - konvensjon, peker registre inneholder alltid adresse uten kmem
; $dff138 - WORD
wspr6pth_:
        push    ebx
        mov     ebx,034h
        call    decidedelay
        test    ebx,1
        jz      wspr6h
        pop     ebx
        ret
wspr6h: pop     ebx
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _sprpt+2+24,dx
        ret

; $dff13a - WORD
wspr6ptl_:
        push    ebx
        mov     ebx,034h
        call    decidedelay
        test    ebx,1
        jz      wspr6l
        pop     ebx
        ret
wspr6l: pop     ebx
        and     edx,0fffeh              ; No odd adresses
        mov     word ptr _sprpt+24,dx
        ret


;=======
; SPR7PT
;=======

; $dff13c - konvensjon, peker registre inneholder alltid adresse uten kmem
; $dff13c - WORD
wspr7pth_:
        push    ebx
        mov     ebx,038h
        call    decidedelay
        test    ebx,1
        jz      wspr7h
        pop     ebx
        ret
wspr7h: pop     ebx
        and     edx,01fh                ; Store 21 bit (2 MB)
        mov     word ptr _sprpt+2+28,dx
        ret

; $dff13e - WORD
wspr7ptl_:
        push    ebx
        mov     ebx,038h
        call    decidedelay
        test    ebx,1
        jz      wspr7l
        pop     ebx
        ret
wspr7l: pop     ebx
        and     edx,0fffeh              ; No odd adresses
        mov     word ptr _sprpt+28,dx
        ret




;========
; COLORXX
;========
; $dff180
wcolor_:
        and     edx,0fffh
        push    edx
        mov     edx,dword ptr [_colortab+edx*4] ; Translate color
        mov     dword ptr [_shadcol-0300h+ecx*2],edx
        pop     edx
        and     edx,0eeeh
        shr     edx,1
        mov     edx,dword ptr [_colortab+edx*4] ; Translate color
        mov     dword ptr [_shadcol-0300h+128+ecx*2],edx
wdefault_:
        ret

#ifdef CYCLE_EXACT

public wcolorcycleexact_
wcolorcycleexact_:
        and     edx,0fffh
        push    edx
        mov     edx,dword ptr [_colortab+edx*4] ; Translate color
        mov     dword ptr [_shadcol-0300h+ecx*2],edx
        pop     edx
        and     edx,0eeeh
        shr     edx,1
        mov     edx,dword ptr [_colortab+edx*4] ; Translate color
        mov     dword ptr [_shadcol-0300h+128+ecx*2],edx
        cmp     dword ptr [_drawptr],offset drawbgline800w_
        jne     wdefault_
        cmp     ecx,0180h
        jne     wdefault_
        cmp     dword ptr [_xpos],44
        jle     wdefault_
        call    drawbglinepartial800w_
        ret

#endif

	


; ------------------- 
; Unavailable bank  
; ------------------- 

readnotavailablebyte_:
        xor     edx,edx
        ret

readnotavailableword_:
        mov     edx,06100h
        ret
        
readnotavailablelong_:
        mov     edx,061006100h
        ret

writenotavailablebyte_:
writenotavailableword_:
writenotavailablelong_:
        ret

_TEXT ends

_DATA  segment dword public use32 'DATA'


include data\chip.inc
include data\floppy.inc

#ifdef DEBUGBUILD
include data\log.inc
#endif

include data\sound.inc
include data\inout.inc
include data\joymouse.inc
include data\graphem.inc
include data\bus.inc

extern _decoderoutineptr:near
extern _drawroutineptr:near

; Data from mc.c
;-----------------

extern _DDFstartpos:near
extern _DDFnumberofwords:near
extern _DIWfirstvisiblepos:near
extern _DIWlastvisiblepos:near

extern _led:near
extern _readbyte:near
extern _readword:near
extern _readlong:near
extern _writebyte:near
extern _writeword:near
extern _writelong:near
extern _ioread:near
extern _iowrite:near
extern _evenscroll:near
extern _evenhiscroll:near
extern _oddscroll:near
extern _oddhiscroll:near
extern _dmaconr:near
extern _dmacon:near
extern _intenar:near
extern _intena:near
extern _intreq:near
extern _joy0dat:near
extern _joy1dat:near
extern _pot0dat:near
extern _pot1dat:near
extern _potgor:near
extern _lof:near
extern _xpos:near
extern _ypos:near
extern _diwstrt:near
extern _diwstop:near
extern _diwxleft:near
extern _diwxright:near
extern _diwytop:near
extern _diwybottom:near
extern _ddfstrt:near
extern _ddfstop:near
extern _bpl1pt:near
extern _bpl2pt:near
extern _bpl3pt:near
extern _bpl4pt:near
extern _bpl5pt:near
extern _bpl6pt:near
extern _bplcon0:near
extern _bplcon1:near
extern _bplcon2:near
extern _bpl1mod:near
extern _bpl2mod:near
extern _sprpt:near
extern _copcon:near
extern _cop1lc:near
extern _cop2lc:near
extern _nxtcopaccess:near
extern _bltcon:near
extern _bltdesc:near
extern _bltafwm:near
extern _bltalwm:near
extern _bltapt:near
extern _bltbpt:near
extern _bltcpt:near
extern _bltdpt:near
extern _bltamod:near
extern _bltbmod:near
extern _bltcmod:near
extern _bltdmod:near
extern _bltadat:near
extern _bltbdat:near
extern _bltcdat:near
extern _blitteraccess:near
extern _linenum:near
extern _linecount:near
extern _linelength:near
extern _blitterdmawaiting:near
extern _cmem:near
extern _fmem:near
extern _bmem:near
extern _kmem:near
extern _colortab:near
extern _shadcol:near
extern _screenmode:near

extern _xpos:near
extern _ypos:near
extern _pc:near

extern _DIWfirstposonline:near
extern _DIWlastposonline:near

extern _adcon:near
extern _dskpt:near
extern _dsklen:near
extern _dsksync:near

extern _blitterstatus:near
extern _bltminterm:near

; Used to temporary store the write address in memory routines
public _wriorgadr
_wriorgadr: dd 0
public _regdata
_regdata: dd 0


public _d
public _a
public _aend

_d: dd 8 dup(0)
_a: dd 8 dup(0)
_aend:

extern _blittertable:near

extern _ciaeventtime:near
extern _blitend:near


extern _bltadatoriginal:dword
extern _bltbdatoriginal:dword

extern _configdoublebuffer:dword




extern _drawloresroutine:dword
extern _drawhiresroutine:dword
extern _drawdualhiresroutine:dword
extern _drawdualloresroutine:dword
extern _drawhamroutine:dword

extern _powerledcolor:dword
extern _drivemotorcolor:dword


extern _spritewritebuffer:dword
extern _spritewritenext:dword
extern _spritewritereal:dword

_busnoise:       dd      0
                 dd      -1

_busnoisecounter:        dd      0

_DATA  ends

_BSS  segment dword public use32 'BSS'
_BSS  ends

end
